# ARCPROC -- Compute correlation and emission line velocities for
#	     a range of reduced file numbers
#	     February 4, 1992
#	     By Doug Mink, Center for Astrophysics TDC

procedure arcproc (rfnrange)

string rfnrange=""		{prompt="RFN range or file"}
file rfn_file="temp.rfn"	{prompt="Output file name"}
bool delfile=yes		{prompt="Delete IRAF copy of archive file (y or n)"}
bool emis_vel=no		{prompt="Compute emission line velocities (y or n)"}
bool corr_vel=no		{prompt="Compute cross correlation velocities (y or n)"}
bool save_arch=no		{prompt="Save result in TDC archive (y or n)"}
bool verbose=no			{prompt="Print what's happening (y or n)"}
bool debug=no		{prompt="Debugging mode (y or n)"}

begin

bool firstrfn, oldfile, vb, delf, savarc, arctest, corvel,emvel
int irfn, nrfn
file rfnlist, rfnfile, rfntemp, iraffile, irafhead, arcdir, arcrec
string rfn,tchar, xcspectra, inst, arg, arg1

	vb = verbose
	delf = delfile
	savarc = save_arch
	arctest = debug
	corvel = corr_vel
	emvel = emis_vel
	
	rfntemp = mktemp ("axcor")
	rfn = rfnrange
	inst = rarc.instrument
	arcdir = rarc.arc_dir

	rfnfile = rfn
	rfsub (rfn,1,1)
	tchar = rfsub.outstring
	firstrfn = yes
	if (tchar == '@') {
	    rflist (rfn,0)
	    nrfn = rflist.nlist
	    if (vb)
		print (nrfn," rfns = ",rflist.rfile)
 
	    for (irfn=1; irfn <= nrfn; irfn=irfn+1) {
		rflist (rfnfile,irfn)
		rfn = rflist.rfn
		rfnobj (rfn, list_file=rfntemp,
			instrument=inst,arc_dir=arcdir,verbose=no)
		if (rfnfile != "") {
		    if (firstrfn) {
			set clobber = yes
			type (rfntemp, >rfn_file)
			set clobber = no
			firstrfn = no
			}
		    else
			type (rfntemp, >>rfn_file)
		    }
		if (vb)
			type (rfntemp)
		delete (rfntemp)
		}
	    rfnfile = "@" // rfn_file
	    }
	else {
	    rfnobj (rfn, list_file=rfn_file,
		    instrument=inst,arc_dir=arcdir,verbose=no)
	    nrfn = rfnobj.nfiles
	    rfnfile = "@" // rfn_file
	    if (vb)
		type (rfn_file)
	    }

	if (corvel) {
	    if (savarc)
		xcsao.archive=yes
	    else
		xcsao.archive=yes
	    }
	set clobber = yes

	if (vb)
	    print (nrfn," rfns = ",rflist.rfile)
 
	for (irfn=1; irfn <= nrfn; irfn=irfn+1) {

	    rflist (rfnfile,irfn)
	    iraffile = rflist.rfile
	    rfn = rflist.rfn
	    arg = "-inst " // inst // " " // rfn
	    arg1 = "-inst " // inst // " " // rflist.rfile
	    irafhead = rflist.rfile // ".imh"
	    oldfile = access (irafhead)
	    if (vb)
		print (irfn, iraffile," ", rfn)
	    if (corvel) {
		if (!oldfile) {
		    rarc (rfn)
		    demach (iraffile)
		    }
		xcsao (iraffile,archive=yes)
		}
	    if (emvel)
		emspec (rfn,archive=yes)
	    if (corvel) {
		if (delf)
		    imdelete (iraffile)
		}
	    if (savarc) {
		cspec (arg)
		}
	    gflush
	    }
end
# Dec 11 1991	Change EMSAO to EMSPEC to avoid name conflicts
# Dec 31 1991	Delete IRAF file before running archinstall

# Feb  4 1992	Don't load redshift
