# AFITS0 -- Write FITS files from a range of reduced files
#	    July 20, 1992
#           By Doug Mink, Center for Astrophysics TDC

procedure afits0 (rfnrange)

string rfnrange=""	{prompt="RFN range or file"}

file rfn_file="temp.rfn"	{prompt="Output list file name"}
bool write_tape=no		{prompt="Write FITS files to tape (y or n)"}
bool new_tape=no		{prompt="Start new FITS tape (y or n)"}
file tape_file="mtb"		{prompt="Output tape file name"}
bool delfile=no			{prompt="Delete IRAF copy of archive file (y or n)"}
bool verbose=no			{prompt="Print what's happening (y or n)"}

begin

bool firstrfn, oldfile, vb, delf, wtape, ntape
int irfn, nrfn
file rfnlist, rfnfile, rfntemp, iraffile, irafhead, arcdir
file fitsfile,tfile
string rfn,tchar, xcspectra, inst

	vb = verbose
	delf = delfile
	wtape = write_tape
	ntape = new_tape
	tfile = tape_file
	rfntemp = mktemp ("afits")
	rfn = rfnrange
	inst = rarc0.instrument
	arcdir = rarc0.arc_dir

	rfnfile = rfn
	rfsub (rfn,1,1)
	tchar = rfsub.outstring
	firstrfn = yes
	if (tchar == '@') {
	    rflist (rfn,0)
	    nrfn = rflist.nlist
	    if (vb)
		print (nrfn," rfns = ",rflist.rfile)
 
	    for (irfn=1; irfn <= nrfn; irfn=irfn+1) {
		rflist (rfnfile,irfn)
		rfn = rflist.rfn
		rfnobj (rfn, list_file=rfntemp,
			instrument=inst,arc_dir=arcdir,verbose=no)
		if (rfnfile != "") {
		    if (firstrfn) {
			set clobber = yes
			type (rfntemp, >rfn_file)
			set clobber = no
			firstrfn = no
			}
		    else
			type (rfntemp, >>rfn_file)
		    }
		if (vb)
			type (rfntemp)
		delete (rfntemp)
		}
	    rfnfile = "@" // rfn_file
	    }
	else {
	    rfnobj (rfn, list_file=rfn_file,
		    instrument=inst,arc_dir=arcdir,verbose=no)
	    nrfn = rfnobj.nfiles
	    rfnfile = "@" // rfn_file
	    if (vb)
		type (rfn_file)
	    }

	dataio

	if (vb)
	    print (nrfn," rfns = ",rflist.rfile)
 
	for (irfn=1; irfn <= nrfn; irfn=irfn+1) {

	    rflist (rfnfile,irfn)
	    iraffile = rflist.rfile
	    rfn = rflist.rfn
	    irafhead = rflist.rfile // ".imh"
	    if (wtape)
		fitsfile = tfile
	    else
		fitsfile = rflist.rfile // ".fits"
	    oldfile = access (irafhead)
	    if (vb)
		print (irafhead," -> ",fitsfile)
	    if (oldfile) {
		wfits (iraffile,fitsfile,ntape)
		ntape = no
		}
	    else {
		rarc0 (rfn)
		demach (iraffile)
		wfits (iraffile,fitsfile,ntape)
		ntape = no
		}
	    if (delf)
		imdelete (iraffile)
	    }

end
# Nov 18 1991	Always call demach when rarc creates a file
# Jul 20 1992	make afits0 and afits1
