# File archive/Scripts/assrfn.cl
# June 10, 1994
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# ASSRFN -- Assign reduced file numbers in temporal order to a list of
#           image files

procedure assrfn (imagelist,firstrfn)

string	imagelist=""		{prompt="file or files"}
int	firstrfn=100000		{prompt="First RFN to assign"}

string	imagext=".imh"		{prompt="Image header file name extension"}
file	logfile="rfn.log"	{prompt="Log file for RFN assignment"}
bool	verbose=no		{prompt="Print what's happening (y or n)"}

begin

bool vb, dellist
int ifile, icom, lname
file listfile,datefile,headfile,iraffile,irafhead,lf
string iml, tchar,imx, imhl, iml1

	vb = verbose
	iml = imagelist
	imx = imagext
	lf = logfile

#  If first character of imagelist is @, get number of images in list
        tchar = substr (iml,1,1)
	icom = stridx (',',iml)
        if (tchar == "@") {
            listfile = substr (iml,2,100)
	    dellist = no
            }

#  If comma-delimited list, list to file, adding image header extension
	else if (icom > 0) {
	    imhl = ""
	    while (icom > 0) {
		imhl = imhl // substr (iml,1,icom-1)
		imhl = imhl // imx // ","
		iml = substr (iml,icom+1,100)
		icom = stridx (',',iml)
		print (icom," ",iml)
		}
	    imhl = imhl // iml // imx
	    listfile = mktemp ("assrf")
	    files (imhl,>listfile)
	    dellist = yes
	    }

#  Else list to file, adding image header extension
	else {
	    listfile = mktemp ("assrf")
	    iml = iml // imx
	    files (iml,>listfile)
	    dellist = yes
	    } 
        if (vb)
            print ("ASSRFN: reading from ",listfile)

	arg = "@" // listfile
	headfile = mktemp ("assrt")
	hselect (arg,"$I,HJDN",yes,>headfile)
	datefile = mktemp ("assrd")
	sort (headfile,column=2,>datefile)

#  Loop through reduced files in list

	list = datefile
	while (fscan (list,irafhead) != EOF) {
	    if (!access (irafhead)) {
		irafhead = irafhead // imx
		if (!access (irafhead)) {
		    print ("ASSRFN: Cannot read file ",irafhead)
		    next
		    }
		}

	    lname = strlen (irafhead) - 4
	    iraffile = substr (irafhead,1,lname)
	    hedit.add = yes
	    hedit.show = no
	    hedit.verify = no
	    hedit.delete = no
	    hedit (iraffile,"RFN",rfn)
	    if (vb)
		print ("ASSRFN: ",rfn,": ",iraffile)
	    rfn = rfn + 1
	    }

	if (dellist)
	    delete (listfile)
	firstrfn = rfn
end
