# File saotdc/archive/Scripts/autocor1.cl
# August 13, 1992
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# AUTOCOR1 -- Compute correlation and emission line velocities for
#	     a range of reduced file numbers using RVSAO package

procedure autocor1 (rfnrange)

string rfnrange=""		{prompt="RFN range or file"}
bool plot=yes			{prompt="Plot results on display (y or n)"}
bool hard_copy=no		{prompt="Make printer hard copies (y or n)"}
bool cursor=no			{prompt="Wait after plot with cursor (y or n)"}
bool delfile=yes		{prompt="Delete IRAF copy of archive file (y or n)"}
bool verbose=no			{prompt="Print what's happening (y or n)"}
bool debug=no			{prompt="Debugging mode (y or n)"}

begin

bool firstrfn, oldfile, vb, delf, arctest, corvel,emvel,plres,hcres
bool curwait
int irfn, nrfn
file rfnlist, rfnfile, rfntemp, iraffile, irafhead, arcdir, arcrec, rfn_file
string rfn,tchar, xcspectra, inst, logfiles

	vb = verbose
	delf = delfile
	arctest = debug
	plres = plot
	hcres = hard_copy
	curwait = cursor
	
	rfntemp = mktemp ("arcproc")
	rfn_file = mktemp ("arcrfn")
	rfn = rfnrange
	inst = rarc1.instrument
	arcdir = rarc1.arc_dir

#  Make list of files from rfn range or file of rfn's

	rfnfile = rfn
	rfsub (rfn,1,1)
	tchar = rfsub.outstring
	firstrfn = yes
	if (tchar == '@') {
	    rflist (rfn,0)
	    nrfn = rflist.nlist
	    if (vb)
		print (nrfn," rfns = ",rflist.rfile)
 
	    for (irfn=1; irfn <= nrfn; irfn=irfn+1) {
		rflist (rfnfile,irfn)
		rfn = rflist.rfn
		rfnobj (rfn, list_file=rfntemp,
			instrument=inst,arc_dir=arcdir,verbose=no)
		if (rfnfile != "") {
		    if (firstrfn) {
			set clobber = yes
			type (rfntemp, >rfn_file)
			set clobber = no
			firstrfn = no
			}
		    else
			type (rfntemp, >>rfn_file)
		    }
		if (vb)
			type (rfntemp)
		delete (rfntemp)
		}
	    rfnfile = "@" // rfn_file
	    }
	else {
	    rfnobj (rfn, list_file=rfn_file,
		    instrument=inst,arc_dir=arcdir,verbose=no)
	    nrfn = rfnobj.nfiles
	    rfnfile = "@" // rfn_file
	    if (vb)
		type (rfn_file)
	    }
	rvsao

#  Set up parameters in archive writing, graphic display, and hard copies

	rarc1.dispcor = yes
	rarc1.log = yes
	xcsao.displot = plres
	xcsao.hardcopy = hcres
	xcsao.curmode = curwait

	set clobber = yes

	if (vb)
	    print (nrfn," rfns = ",rflist.rfile)
 
#  Loop through reduced files in list

	for (irfn=1; irfn <= nrfn; irfn=irfn+1) {

	    rflist (rfnfile,irfn)
	    iraffile = rflist.rfile
	    rfn = rflist.rfn
	    irafhead = rflist.rfile // ".imh"
	    oldfile = access (irafhead)
	    if (vb)
		print (irfn, iraffile," ", rfn)

#	Find cross-correlation velocity

	    if (!oldfile) {
		rarc1 (rfn)
		demach (iraffile)
		oldfile = yes
		}
	    xcsao (iraffile, templates=iraffile, tempdir="")

#	Delete IRAF file

	    if (delf)
		imdelete (iraffile)
	    if (hcres)
		gflush
	    }
	delete (rfn_file)
end
