# File archive/Scripts/fastlist.cl
# December 21, 1995
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# FASTLIST -- List FAST spectra in archive to a file

procedure fastlist (date1, first_obn, date2, last_obn)

string	date1="1994.0101"		{prompt="First date (yyyy.mmdd)"}
int	first_obn=1	{prompt="First observation number on first day"}
string	date2="1995.1231"		{prompt="Last date (yyyy.mmdd)"}
int	last_obn=300	{prompt="Last observation number on last day"}
int	obn1=1		{prompt="First observation number per day"}
int	obn2=300	{prompt="Last observation number per day"}
string	rootdir="/ret/ret11/fast/onedtemp"	{prompt="Root directory"}
file	listfile="fastfiles"	{prompt="File to which to list FAST spectra"}
bool	verbose=no	{prompt="Print what's happening (y or n)"}

begin

bool	vb
string	obsdate
int	nobs, nobs1, nobs2, jd, jd1, jd2, firstobs, lastobs
file	iraffile, irafhead
file	localfile, obsdir, irafpath

	vb = verbose

	obnobj.root_dir = rootdir
#	obnobj.verbose = vb
	vtoj.frac_day = 0.5
	vtoj (date1)
	jd1 = vtoj.julian_day
	firstobs = first_obn
	vtoj (date2)
	jd2 = vtoj.julian_day
	lastobs = last_obn

#  Loop through range of dates
	for (jd = jd1; jd<=jd2; jd=jd+1) {
	    jtov (jd)
	    obsdate = jtov.date
	    obnobj.date = obsdate
	    obsdir = rootdir // "/" // obsdate
	    if (access (obsdir)) {

	#  Loop through range of observation numbers
		if (jd == jd1) {
		    nobs1 = firstobs
		    }
		else {
		    nobs1 = obn1
		    }
		if (jd == jd2) {
		    nobs2 = lastobs
		    }
		else {
		    nobs2 = obn2
		    }
		for (nobs=nobs1; nobs <= nobs2; nobs=nobs+1) {
		    obnobj (nobs)
		    iraffile = obnobj.arcfile

		# If reduced file is found, process it in the working directory
		    if (iraffile != "") {
			smatch (iraffile,"COMP")
			if (smatch.found)
			    next
			smatch (iraffile,"henear")
			if (smatch.found)
			    next
			localfile = obsdate
			localfile = localfile // "." // iraffile
			if (vb)
			    print (nobs," ",localfile)
#			irafpath = rootdir // "/" // obsdate // "/" // iraffile
#			if (access (irafpath))
			    print (localfile,>>listfile)
			}

		# Print error message if file is not found
#		    else if (vb)
#			print ("IRAF file for observation ",nobs," not found")
		    }
		}

	# Print error message if directory is not found
#	    else if (vb)
#		print ("Directory for ",obsdate," not found")
	    }
end

# Dec 21 1995	New task based on structure of EMRANGF
