# File archive/Scripts/fastseq1.cl
# December 21, 1995
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# FASTSEQ1 -- Set date and sequence number in file the FAST archive

procedure fastseq1 (filename)

string	filename=""		{prompt="Date (yyyy.mmdd)"}
file	dirpath=""		{prompt="Directory name"}
string	obseq=""		{prompt="Root directory"}
bool	verbose=no		{prompt="Print what's happening (y or n)"}

begin

bool	vb
string	obsdate,fdate,seqno
int	iob1
file	obsfile,obspath

	vb = verbose
#	ftov.verbose = vb
	obsfile = filename
	obspath = dirpath // obsfile

# Get date from header parameter
	imgetp (obspath,"DATE-OBS")
	fdate = imgetp.value
	ftov (fdate,timeoff=-20.0)
	obsdate = ftov.vdate

# Get observation sequence number from file name
	iob1 = stridx ('.',obsfile)
	seqno = substr (obsfile,1,iob1-1)
	obseq = obsdate // "." // seqno
	imputp (obspath,"OBSEQ",obseq)
	if (vb)
	    print ("FASTSEQ1: ",obspath,": ",obseq)

end
# Dec 19 1995	New task
# Dec 21 1995	Add verification display
