# File archive/Scripts/findall.cl
# April 10, 1995
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# FINDALL -- Find and extract aperture for a list of FAST observation numbers

procedure findall (rfnfile)

string	rfnfile=""	{prompt="RFN or file"}
bool	verbose=no	{prompt="Print what's happening (y or n)"}

begin

bool vb, delf
file	rfn_temp
string	filename
string	listfile
string	tchar, rfile

	rfile = rfnfile
	vb = verbose

	set clobber = yes

#  Process data files from command line or file of files

	tchar = substr (rfile,1,1)
	if (tchar != '@') {
	    rfn_temp = mktemp ("findall")
	    print (rfile,>rfn_temp)
	    listfile = rfn_temp
	    }
	else
	    listfile = substr (rfile,2,64)

	if (vb)
	    print ("RFNs from ",listfile)
 
#  Loop through list of reduced files
	list = listfile
	while (fscan (list,filename) != EOF) {
	    findspec (filename)
	    apall.lower = findspec.lower
	    apall.upper = findspec.upper
	    apall.b_sample = findspec.b_sample
	    apall.find = no
	    apall.edit = no
	    apall.b_function = "legendre"
	    apall.b_order = 2
	    apall.b_niterate = 1
	    apall (filename)
	    }

	if (tchar != '@')
	    delete (rfn_temp)
end
