# File archive/Scripts/pfast.cl
# July 29, 1998
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# PFAST -- Plot spectra of a list of FAST observations numbers using SPLOT

procedure pfast (rfnfile)

string	rfnfile=""	{prompt="RFN or file"}
string	rootdir="/ret/ret7/fast/"	{prompt="Root directory"}
int	band=1		{prompt="Band to plot (1=spec, 3=sky)"}
bool	delfile=yes	{prompt="Delete IRAF copy of archive file (y or n)"}
bool	verbose=no	{prompt="Print what's happening (y or n)"}
bool	debug=no	{prompt="Debugging mode (y or n)"}

begin

bool	vb, delf
int	nobs, npix, i, b
file	iraffile, irafhead, irafpix, rfn_temp
file	localfile, localpix, localhead, newpix,newpath
string	line1, line2
file	listfile, obsdir, irafpath
string	tchar, obsdate, arg, arg1, rfile

	rfile = rfnfile
	b = band
	vb = verbose
	delf = delfile
	rfast1.verbose = vb
	rfast1.rootdir = rootdir
	rfast1.destdir = ""
	set clobber = yes

#  Process data files from RFN or file of RFN's
	tchar = substr (rfile,1,1)
	if (tchar != '@') {
	    rfn_temp = mktemp ("arcrfn")
	    print (rfile,>rfn_temp)
	    listfile = rfn_temp
	    }
	else
	    listfile = substr(rfile,2,64)

	if (vb)
	    print ("RFNs from ",listfile)
 
	obnobj.root_dir = rootdir
	obnobj.verbose = no

#  Loop through list of reduced files
	list = listfile
	i = 0
	while (fscan (list, line) != EOF) {
	    i = i + 1
	    rfast1 (line)
	    localfile = rfast1.destpath

	# If the reduced file is found, process a local copy of it
	    if (localfile != "") {

	# Plot spectrum
		splot (localfile, band=b)

	# Delete IRAF file
		if (delf)
		    imdelete (localfile)
		}
	    }

	if (tchar != '@')
	    delete (rfn_temp)
end
# Jul 29 1998	New task
