# File archive/Scripts/qplotf.cl
# August 24, 1999
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# QPLOTF -- Plot FAST spectra from multispec spectrum in FAST archive

procedure qplotf (rfnfile)

string	rfnfile=""	{prompt="RFN or file"}
string	rootdir="/ret/ret7/fast/"	{prompt="Root directory"}
int	band = 1	{prompt="Band of multispec image to read"}
string	qtask="xcsao"	{prompt="program to run (xcsao or emsao)"}
string	velplot="combination"	{prompt="Velocity to plot",
				 enum="combination|emission|correlation"}
int	nsmooth=5	{prompt="Number of times to smooth spectrum"}
bool	delfile=yes	{prompt="Delete IRAF copy of archive file (y or n)"}
bool	verbose=no	{prompt="Print what's happening (y or n)"}
bool	debug=no	{prompt="Debugging mode (y or n)"}

begin

bool	vb, delf
int	i, ns
file	iraffile, irafhead, irafpix, rfn_temp
file	localfile, localband, localpix, localhead, newpix,newpath
string	line1, line2
file	listfile, obsdir, irafpath, outfile
string	tchar, arg, arg1, rfile, qt, vplot

	rfile = rfnfile
	vb = verbose
	delf = delfile
#	rfast1.verbose = vb
	rfast1.rootdir = rootdir
	rfast1.destdir = ""
	qt = qtask
	vplot = velplot
	ns = nsmooth

	set clobber = yes

#  Process data files from RFN or file of RFN's
	tchar = substr (rfile,1,1)
	if (tchar != '@') {
	    rfn_temp = mktemp ("arcrfn")
	    print (rfile,>rfn_temp)
	    listfile = rfn_temp
	    }
	else
	    listfile = substr(rfile,2,64)

	if (vb)
	    print ("RFNs from ",listfile)
 
	obnobj.root_dir = rootdir
	obnobj.verbose = no

#  Loop through list of reduced files
	list = listfile
	i = 0
	while (fscan (list, line) != EOF) {
	    i = i + 1
	    rfast1 (line)
	    localfile = rfast1.destpath

	# If the reduced file is found, process a local copy of it
	    if (localfile != "") {

	    # Output file name is full FAST observation sequence number
		outfile = substr (localfile,1,14)
		if (band > 1)
		    localband = localfile // "[" // band // "]"
		else
		    localband = localfile
		if (vb)
		    print ("QPLOTF ",i,": ",localband," -> ", outfile)

	    # QPLOT this file
		if (qtask == "emsao") {
		    emsao (irafhead,vel_init="combination",linefit=no,
			   curmode=yes,save_vel=yes,vel_plot=vplot,nsmooth=ns)
		    }
		else {
		    xcsao (irafhead,correlate=no,curmode=yes,dispmode=2,
			   save_vel=yes,vel_plot=vplot,nsmooth=ns)
		    }

	    # Delete IRAF file
		if (delf)
		    imdelete (localfile)
		}
	    else
		print ("QPLOTF ",i,": ",substr(line,1,30)," not found",>>"missing")
	    }

	if (tchar != '@')
	    delete (rfn_temp)
end

# May 14 1997	New task

# Aug 24 1999	Add vel_plot and nsmooth; no longer call rvsao.qplot
