# File archive/Scripts/rebin2d.cl
# December 18, 1998
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# REBIN2D -- Rebin spectra from a 2D file into another 2D file

procedure rebin2d (infile, outfile)

string	infile=""	{prompt="2-D spectrum file"}
string	outfile=""	{prompt="2-D spectrum file"}
string	rootdir="/ret/ret7/fast/"	{prompt="Root directory"}
real	wl1 = 3500.0	{prompt="Starting wavelength in Angstroms"}
real	wl2 = 7000.0	{prompt="Ending wavelength in Angstroms"}
int	npix=2000	{prompt="Number of pixels in output spectra"}
int	snum1 = 1	{prompt="First spectrum to rebin"}
int	snum2 = 1	{prompt="Last spectrum to rebin"}
bool	newxcor=no	{prompt="Run XCSAO to get new correlation velocity"}
bool	newemis=no	{prompt="Run EMSAO to get new emission line velocity"}
bool	verbose=no	{prompt="Print what's happening (y or n)"}
bool	debug=no	{prompt="Debugging mode (y or n)"}

begin

bool	vb, delf, newxc, newem, fitsw
int	i
file	iraffile, irafhead, irafpix, rfn_temp, fitsfile
file	localfile, localpix, localhead, newpix,newpath
string	line1, line2
file	listfile, obsdir, irafpath, outfile
string	tchar, arg, arg1, rfile

	rfile = rfnfile
	vb = verbose
	newxc = newxcor
	newem = newemis
	fitsw = fitsout
#	rfast1.verbose = vb
	rfast1.rootdir = rootdir
	rfast1.destdir = ""

	set clobber = yes

#  Process data files from RFN or file of RFN's
	tchar = substr (rfile,1,1)
	if (tchar != '@') {
	    rfn_temp = mktemp ("arcrfn")
	    print (rfile,>rfn_temp)
	    listfile = rfn_temp
	    }
	else
	    listfile = substr(rfile,2,64)

	if (vb)
	    print ("RFNs from ",listfile)
 
	obnobj.root_dir = rootdir
	obnobj.verbose = no

	sumspec.specband = band
	sumspec.st_lambda = wl1
	sumspec.end_lambda = wl2
	sumspec.npts = npix
#	sumspec.velcomp = INDEF
#	sumspec.zcomp = 0.0

#  Loop through list of reduced files
	list = listfile
	i = snum1
	while (fscan (list, line) != EOF) {

	# Get new correlation velocity if desired
	    if (newxc) {
		xcsao.specband = 0
		xcsao.specnum = i
		xcsao (localfile)
		}

	# Get new emission line velocity if desired
	    if (newem) {
		emsao.specband = 0
		emsao.specnum = i
		emsao (localfile)
		}

	    print ("REBINF: ",localfile,"[",i,"] -> ", outfile,"[",i,"]")

	# Rebin this file into output file
	    sumspec (infile,outfile)
	    i = i + 1
	    }
end
# Dec 18 1998	New task
