#  File archive/Scripts/redfits.cl
#  February 12, 1993
#  By Doug Mink

#  Combine MMT Red Channel object and sky files into single FITS files

procedure redfits (imagelist)

file	imagelist=""	{prompt="Image file name or @list file"}
int	rfnlast=0	{prompt="Last reduced file number assigned (RETURNED)"}
int	rfninc=1	{prompt="RFN increment between objects"}
bool	write_fits=no	{prompt="Write FITS file after combining (y or n)"}
file	outdir="fits/"	{prompt="Directory for FITS files"}
bool	del_iraf=yes	{prompt="Delete IRAF object+sky files (y or n)"}

begin

bool	wrfits, diraf, eso, readfile
file	imf,imfa,outfile,aps,outpath, iml,outd
file	imsky,imobj
int	ispec, iobj, rfn, i, ifib, ioff
int	drfn, ispec1, ifile, nfiles, naxis, ndim
string	srfn, imlist, arg
char	tchar

	wrfits = write_fits
	diraf = del_iraf
	drfn = rfninc
	iml = imagelist
	outd = outdir

	dataio

#  If first character of imagelist is @, get number of images in list
	tchar = substr (iml,1,1)
	if (tchar == "@") {
	    rlist (iml,0)
	    nfiles = rlist.nlist
	    nfiles = nfiles - 1
	    print ("Reading ",nfiles," lines from ",iml)
	    list = substr (iml,2,64)
	    }

#  Otherwise, read only one file
	else {
	    imf = iml
	    nfiles = 1
	    }

	readfile = yes
	while (readfile) {

	    if (tchar == "@") {
		if (fscan (list,imf) == EOF)
		    readfile = no
		}
	    if (!readfile)
		break

	# Set up object and sky image sections for stacking
	    imgetp (imf,"i_naxis")
	    naxis = int (imgetp.value)
	    print ("Input file is ",imf," x ",naxis)
	    if (naxis == 3) {
		imobj = imf // "[*,1,1]"
		imsky = imf // "[*,1,3]"
		}
	    else {
		imobj = imf
		imsky = imf
		}
	    imlist = imobj // "," // imsky

	# Set up reduced file number part of output file name
	    rfn = rfnlast + drfn
	    srfn = rfn
	    if (rfn < 10)
		srfn = "000" // srfn
	    else if (rfn < 100)
		srfn = "00" // srfn
	    else if (rfn < 1000)
		srfn = "0" // srfn
	    else
		srfn = srfn

	# Add object name to output file name
	    imgetp (imf,"i_title")
	    outfile = srfn // "." // imgetp.value
	    namefilt (outfile)
	    outfile = namefilt.newname
	    print ("Output file is ",outfile)

	# Stack object and sky files into output file
	    imstack (imlist,outfile)

	# Remove IRAF stuff from header
	    impdel (outfile,"IRAFTYPE")
	    impdel (outfile,"IRAF-B/P")
	    impdel (outfile,"IRAF-MAX")
	    impdel (outfile,"IRAF-MIN")
	    if (naxis == 3) {
		impdel (outfile,"WAT0_001")
		impdel (outfile,"WAT1_001")
		impdel (outfile,"WAT2_001")
		imgetp (outfile,"WCSDIM")
		ndim = int (imgetp.value)
		impdel (outfile,"WCSDIM")
		impdel (outfile,"WAT0_001")
		for (i = 1; i<=ndim; i = i + 1) {
		    arg = "CD"//i//"_"//i
		    impdel (outfile,arg)
		    arg = "LTM"//i//"_"//i
		    impdel (outfile,arg)
		    arg = "CTYPE"//i
		    impdel (outfile,arg)
		    arg = "WAT"//i//"_001"
		    impdel (outfile,arg)
		    }
		hedit.add = yes
		hedit.verify = no
		hedit.show = no
		hedit.update = yes
		hedit (outfile,"i_naxis",2)
		hedit (outfile,"i_naxis2",2)
		}

	# Write FITS file
	    if (wrfits) {
		outpath = outd // outfile
		wfits (outfile,outpath)
		}

	# Delete object+sky IRAF file
	    if (diraf)
		imdel (outfile)

	# Update last RFN parameter
	    rfnlast = rfn
	if (tchar != "@")
	    readfile = no
	    }

end
# Feb 11 1993	Read object and sky spectra from same multispec file
