# File archive/Scripts/rfast.cl
# October 17, 1996
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# RFAST -- Transfer a list of FAST observations from the archive

procedure rfast (obdate,obnum)

string	obdate=""	{prompt="RFN or file"}
string	obnum=""	{prompt="Observation sequence number range"}
string	rootdir="/ret/ret11/fast/onedtemp/"	{prompt="Root directory"}
file	destdir=""	{prompt="Destination directory pathname"}
bool	datedir=no	{prompt="Destination subdirectories by date (y or n)"}
bool	verbose=no	{prompt="Print what's happening (y or n)"}

begin

bool	vb
int	nobs, iob1, iob2, iob3, idot, isl
string	date,date1,date2
file	rfn_temp
file	listfile
string	tchar, obsdate, rfile

	rfile = obdate
	vb = verbose
	rfast1.verbose = vb
	rfast1.rootdir = rootdir
	rfast1.datedir = datedir
	rfast1.destdir = destdir

	set clobber = yes

#  Process date string
	tchar = substr (rfile,1,1)

# Read date/sequence number strings from a file
	if (tchar == '@')
	    listfile = substr(rfile,2,64)

# Separate out number from date if one string
	else {
	    date = obdate
	    iob1 = stridx ('.',date)
	    date1 = substr (date,iob1+5,64)
	    date = substr (date,iob1-4,iob1+4)
	    idot = stridx ('.',date1)
	    isl = stridx ('/',date1)
	    if (idot > 0 || isl > 0) {
		if (idot > 0) {
		    if (isl > 0 && isl < idot)
			iob2 = isl
		    else
			iob2 = idot
		    }
		else
		    iob2 = isl
		date2 = substr (date1,iob2+1,64)
		date = substr (date,1,iob1+iob2+4)
		iob3 = stridx ('.',date2)
		if (iob3 > 0)
		    nobs = int (substr (date2,1,iob3-1))
		else
		    nobs = int (substr (date2,1,64))
		}

# Read separate sequence number
	    else {
		date = obdate
		nobs = int (obnum)
		}
	    rfn_temp = mktemp ("arcrf")
	    print (date," ",nobs,>rfn_temp)
	    listfile = rfn_temp
	    }
 
#  Loop through list of reduced files
	list = listfile
	while (fscan (list,line) != EOF) {
	    rfpath (line)
	    nobs = rfpath.nobs
	    if (nobs == 0)
		next
	    obsdate = rfpath.obsdate
	    rfast1 (obsdate, nobs)
	    }

	if (tchar != '@')
	    delete (rfn_temp)
end
# May  9 1995	Task written
# Jul 17 1995	Parse date and observation number from FAST filename
# Nov 21 1995	Use rfast1 to copy individual files
# Dec 22 1995	Add option of writing to a date-specific directory

# Oct 17 1996	Change default root directory
