# File archive/Scripts/rfast1.cl
# May 13, 1997
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# RFAST1 -- Make a copy of one reduced file from the FAST archive

procedure rfast1 (obdate,obn)

string	obdate="1994.0101"	{prompt="Date (yyyy.mmdd)"}
int	obn=1			{prompt="Observation sequence number on date"}
string	rootdir="/ret/ret11/fast/onedtemp"	{prompt="Root directory"}
file	destdir=""		{prompt="Destination directory pathname (no /)"}
file	arcfile=""		{prompt="File name in archive (returned)"}
file	destpath=""		{prompt="Destination file name (returned)"}
bool	datedir=no	{prompt="Destination subdirectories by date (y or n)"}
bool	verbose=no		{prompt="Print what's happening (y or n)"}

begin

bool	vb, dd
string	obsdate,date,date1,date2
int	npix, nobs, jd, obnum, iob1, iob2, iob3
string	obsfile, obsdir, outfile, realpix, outd
string	obspath, outhead, outpix, outdir, outpath

	vb = verbose
	dd = datedir
	arcfile = ""

	set clobber = yes

#  Separate out number from date if one string
	date = obdate
	iob1 = stridx ('.',date)
	date1 = substr (date,iob1+5,64)
	date = substr (date,iob1-4,iob1+4)
	iob2 = stridx ('.',date1)
	if (iob2 == 0)
	    iob2 = stridx ('/',date1)
	if (iob2 == 0)
	    iob2 = stridx (' ',date1)
	if (iob2 > 0) {
	    date2 = substr (date1,iob2+1,64)
	    date = substr (date,1,iob1+iob2+4)
	    iob3 =stridx ('.',date2)
	    if (iob3 > 0)
		obnum = int (substr (date2,1,iob3-1))
	    else
		obnum = int (substr (date2,1,64))
	    }
	else
	    obnum = obn

# Set up destination directory
	outd = destdir

# Convert filename date to directory date
	vtoj.frac_day = 0.5
	vtoj (date)
	jd = vtoj.julian_day
	jtov (jd)
	obsdate = jtov.date
	obnobj.date = obsdate
	obnobj.root_dir = rootdir
#	obnobj.verbose = vb
	nobs = obnum
	obnobj (nobs)
	obsfile = obnobj.arcfile
	obsdir = obnobj.arcdir

# If reduced file is found, copy it to the destination directory
	if (obsfile != "") {
	    if (dd) {
		outfile = obsfile
		if (outd == "")
		    outdir = obsdate // "/"
		else
		    outdir = outd // "/" // obsdate // "/"
		if (!access (outdir))
		    mkdir (outdir)
		}
	    else {
		outfile = obsdate
		outfile = outfile // "." // obsfile
		if (outd == "")
		    outdir = outd
		else
		    outdir = outd // "/"
		}
	    outhead = outdir // outfile // ".imh"
	    outpath = outdir // outfile
	    obspath = obsdir // obsfile
	    if (!access (outhead)) {
		if (vb)
		    print (obspath," -> ",outhead)
		imcopy (obspath,outpath)
		if (!access (outhead)) {
		    if (vb)
			print ("RFAST1: No IRAF header file ",outhead)
		    return
		    }
		demach (outpath)
		}
	    else if (vb)
		print (outpath," already exists")
	    outpix = outdir // outfile // ".pix"
	    realpix = outpath // ".pix"
	    if (!access (realpix)) {
		realpix = outpath // ".pi"
		if (!access (realpix)) {
		    realpix = outpath // ".p"
		    if (!access (realpix)) {
			realpix = outpath // "."
			if (!access (realpix)) {
			    realpix = outpath
			    if (!access (realpix)) {
				print ("RFAST1: No pixel file ",realpix)
				if (access (outhead))
				    imdel (outhead)
				return
				}
			    }
			}
		    }
		if (vb)
		    print ("RFAST1: ",realpix," -> ",outpix)
		rename (realpix,outpix)
		}
	    if (vb)
		print ("RFAST1: ",realpix," -> ",outpix)
	    imgetp (outpath,"i_naxis1")
	    npix = int (imgetp.value)
	    if (npix < 1) {
		imdel (outhead)
		if (vb)
		    print ("RFAST1:  No pixels in file ",outpath)
		return
		}
	    arcfile = obsfile
	    destpath = outpath
	    }
	else if (vb) {
	    if (obsdir == "")
		print ("RFAST1:  Directory for observation date ",obsdate," not found")
	    else
		print ("RFAST1:  File for observation ",nobs," not found in ",obsdir)
	    }
end
# Nov 21 1995	New task
# Dec 22 1995	Add option of writing to a date-specific directory

# May 13 1997	Change outfile to outpath in pixel name checking
