# SETINST -- Set RARC and XCOR parameters for one SAO TDC archive instrument.
#	    January 21, 1999
#           By Doug Mink, CfA TDC

procedure setinst (instrument)

string instrument="zmach"	{prompt="SAO instrument"}
file default_dir="archive$Inst_defaults/"	{prompt="default directory"}
bool verbose=yes		{prompt="print default file names (yes or no)"}

begin

bool vb
file rfile,xfile
string inst,arg,ddir

	inst = instrument
	ddir = default_dir
	vb = verbose

	rfnobj.instrument = inst
	rfnsky.instrument = inst
	objrfn.instrument = inst
	zprint.instrument = inst
	emspec.instrument = inst
	rfnobj.arc_dir = "/ret"

#  Defaults for PSPEC archive plotting program
	arg = "-d " // rfnobj.arc_dir // " -inst " // inst // " -stop"
#	pspec (arg)
#	cspec (arg)
#	espec (arg)
#	rspec (arg)

#  Defaults for RARC archive reading task
	rfile = ddir // inst // ".rarc"
	if (vb)
	    print ("Reading RARC parameters from ",rfile)
	if (access (rfile))
	    cl (<rfile)
	else
	    print ("*** No RARC defaults for ",inst)

#  Defaults for XCSAO cross-correlation task
	xfile = ddir // inst // ".xcor"
	if (vb)
	    print ("Reading XCSAO parameters from ",xfile)
	if (access (rfile))
	    cl (<xfile)
	else
	    print ("*** No XCSAO defaults for ",inst)

end

# Mar  2 1998	New task
# Mar 13 1998	Do not initialize non-IRAF tasks pspec, cspec, espec, rspec

# Jan 21 1999	Set archive root directory to /ret
