# File archive/Scripts/slistf.cl
# May 14, 1997
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# SLISTF -- List information from archived FAST using onedspec.slist

procedure slistf (rfnfile)

string	rfnfile=""	{prompt="RFN or file"}
string	rootdir="/ret/ret7/fast/"	{prompt="Root directory"}
bool	delfile=yes	{prompt="Delete IRAF copy of archive file (y or n)"}
bool	verbose=no	{prompt="Print what's happening (y or n)"}
bool	debug=no	{prompt="Debugging mode (y or n)"}

begin

bool	vb, delf
int	i
file	iraffile, irafhead, irafpix, rfn_temp
file	localfile, localpix, localhead, newpix,newpath
string	line1, line2
file	listfile, obsdir, irafpath, outfile
string	tchar, arg, arg1, rfile

	rfile = rfnfile
	vb = verbose
	delf = delfile
#	rfast1.verbose = vb
	rfast1.rootdir = rootdir
	rfast1.destdir = ""

	set clobber = yes

#  Process data files from RFN or file of RFN's
	tchar = substr (rfile,1,1)
	if (tchar != '@') {
	    rfn_temp = mktemp ("arcrfn")
	    print (rfile,>rfn_temp)
	    listfile = rfn_temp
	    }
	else
	    listfile = substr(rfile,2,64)

	if (vb)
	    print ("RFNs from ",listfile)
 
	obnobj.root_dir = rootdir
	obnobj.verbose = no

#  Loop through list of reduced files
	list = listfile
	i = 0
	while (fscan (list, line) != EOF) {
	    i = i + 1
	    rfast1 (line)
	    localfile = rfast1.destpath

	# If the reduced file is found, process a local copy of it
	    if (localfile != "") {

	    # Output file name is full FAST observation sequence number
		outfile = substr (localfile,1,14)
		if (vb)
		    print ("SLISTF ",i,": ",localfile," -> ", outfile)

	# List this file
		slist (localfile)

	# Delete IRAF file
		if (delf)
		    imdelete (localfile)
		}
	    else
		print ("SLISTF ",i,": ",substr(line,1,30)," not found",>>"missing")
	    }

	if (tchar != '@')
	    delete (rfn_temp)
end
# May 14 1997	New task
