# File saotdc/archive/Scripts/tdelay.cl
# May 17, 1994
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# TDELAY -- Wait until a specified time or for a specified number of seconds

procedure tdelay (dtime)

string	dtime="0"	{prompt="Delay until time nn:nn:nn or for n sec"}
bool	verbose=yes	{prompt="Print start time and duration"}

begin

int	nsec,csec,dsec,i,ihr,imin,isec,nmin,nhr
string	ctime,day,date
file	timefile

#  Get current time
	timefile = mktemp ("delay")
	time (>timefile)
	list = timefile
	i = fscan (list,day,ctime,date)
	delete (timefile)

#  Get current time in seconds of day
	ihr = int (substr (ctime,1,2))
	imin = int (substr (ctime,4,5))
	isec = int (substr (ctime,7,8))

#  See whether delay is in seconds or time format
	i = stridx (dtime,':')

#  If it is in seconds, sleep
	if (i == 0) {
	    nsec = int (dtime)
	    isec = isec + nsec
	    nmin = isec / 60
	    isec = isec - (nmin * 60)
	    imin = imin + nmin
	    nhr = nmin / 60
	    imin = imin - (nhr * 60)
	    ihr = ihr + nhr
	    if (ihr > 24)
		ihr = ihr - 24
	    dtime = str (ihr) // ":" // str (imin) // ":" // str (isec)
	    }

#  If it is in time, compute time to sleep
	else {

#	Get destination time in seconds of day
	    ihr = int (substr (dtime,1,2))
	    imin = int (substr (dtime,4,5))
	    isec = int (substr (dtime,7,8))
	    dsec = isec + (imin * 60) + (ihr * 3600)
	    csec = isec + (imin * 60) + (ihr * 3600)

#  Handle delay past 24:00:00
	    if (dsec < csec)
		dsec = dsec + 86400

# Compute number of seconds to delay
	    nsec = dsec - csec
	    }

	if (verbose)
	    print ("Waiting ",nsec," seconds to ",dtime," from ",ctime," ",day," ",date)

#  Delay
	sleep (nsec)
end
# Nov 20 1992	Task written

# May 17 1994	Name changed to TDELAY to avoid name conflict
