# TEMPSET - Set XCSAO templates from spectrum file header
#           By Doug Mink, CfA
#           November 2, 1990

procedure tempset (image)

string	image	{prompt="image from which to set templates"}
bool	verbose=no	{prompt="Log progress (y or n)?"}
bool	success=yes	{prompt="Found all templates (y or n)?"}

begin

	bool	vb
	int	ntemp,itemp
	int	exposure, framerat, iexp, ifrr
	real	tvel
	char	val,pname,pnum,rfn
	file	tempname, tempfile
	file	outfile,infile
	char	templist

	infile = image
	vb = verbose

	imgets (infile, "ntemp")
	val = imgets.value
	ntemp = int (val)
	templist = ""
	if (vb)
	    print ("TEMPSET: ",ntemp," templates in header of ",infile)
	success = no
	if (ntemp > 0) {

	#  Set up header editor
	    hedit.verify = no
	    hedit.show = yes
	    hedit.delete = no
	    hedit.add = yes
	    hedit.update = yes
	    success = yes

	    for (itemp=1; itemp <= ntemp; itemp=itemp+1) {
		rfn = itemp
		pname = "TEMPL" // rfn
		imgets (infile, pname)
		if (imgets.value != "0") {
		    tempname = imgets.value
		    tempfile = tempname // ".imh"
		    if (access (tempfile)) {
			templist = templist // " " // tempname
			pname = "TSHIFT" // rfn
			imgets (infile, pname)
			tvel = real (imgets.value)
			tshift.verbose = verbose
			tshift (tempname,tvel)
			}
		    else {
			success = no
			print ("TEMPSET: cannot find template file ",tempfile)
			}
		    }
		}
	    }
end
