# TXCOR -- Cross-correlate a range of reduced file numbers
#	    November 18, 1991
#           By Doug Mink, Center for Astrophysics TDC

procedure txcor (rfnrange)

string rfnrange=""	{prompt="RFN range or file"}

file rfn_file="temp.rfn" {prompt="Output file name"}
bool delfile=no		{prompt="Delete IRAF copy of archive file (y or n)"}
bool verbose=no		{prompt="Print what's happening (y or n)"}

begin

bool firstrfn, oldfile, vb, delf
int irfn, nrfn
file rfnlist, rfnfile, rfntemp, iraffile, irafhead, arcdir
string rfn,tchar, xcspectra, inst

	vb = verbose
	delf = delfile
	rfntemp = mktemp ("txcor")
	rfn = rfnrange
	inst = rarc.instrument
	arcdir = rarc.arc_dir

	rfnfile = rfn
	rfsub (rfn,1,1)
	tchar = rfsub.outstring
	firstrfn = yes
	if (tchar == '@') {
	    rflist (rfn,0)
	    nrfn = rflist.nlist
	    if (vb)
		print (nrfn," rfns = ",rflist.rfile)
 
	    for (irfn=1; irfn <= nrfn; irfn=irfn+1) {
		rflist (rfnfile,irfn)
		rfn = rflist.rfn
		rfnobj (rfn, list_file=rfntemp,
			instrument=inst,arc_dir=arcdir,verbose=no)
		if (rfnfile != "") {
		    if (firstrfn) {
			set clobber = yes
			type (rfntemp, >rfn_file)
			set clobber = no
			firstrfn = no
			}
		    else
			type (rfntemp, >>rfn_file)
		    }
		if (vb)
			type (rfntemp)
		delete (rfntemp)
		}
	    rfnfile = "@" // rfn_file
	    }
	else {
	    rfnobj (rfn, list_file=rfn_file,
		    instrument=inst,arc_dir=arcdir,verbose=no)
	    nrfn = rfnobj.nfiles
	    rfnfile = "@" // rfn_file
	    if (vb)
		type (rfn_file)
	    }

	redshift

	if (vb)
	    print (nrfn," rfns = ",rflist.rfile)
 
	for (irfn=1; irfn <= nrfn; irfn=irfn+1) {

	    rflist (rfnfile,irfn)
	    iraffile = rflist.rfile
	    rfn = rflist.rfn
	    irafhead = rflist.rfile // ".imh"
	    oldfile = access (irafhead)
	    if (vb)
		print (irfn, iraffile," ", rfn)
	    if (!oldfile) {
		rarc (rfn)
		demach (iraffile)
		tempset (iraffile)
		if (tempset.success) {
		    xcsao (iraffile)
		    }
		}
	    else {
		tempset (iraffile)
		if (tempset.success) {
		    xcsao (iraffile)
		    }
		xcsao (iraffile)
		}
	    if (delf)
		imdelete (iraffile)
	    }
end
# Nov 18 1991	Always call demach when rarc creates a file
