
# EMCHOP calls Bill Wyatt's fchopper routine which finds and removes
# emission lines from a dispersion-corrected spectrum.

	procedure emchop (out, w1, dw, nw, log)

real	out[nw]			# Output spectrum
double	w1			# Starting wavelength
double	dw			# Wavelength per pixel
int	nw			# Number of output pixels
bool	log			# Log scale?

double	w2
real	cwl, cwl1, cwl2, pix1, pix2
int	nchop, choplist[2,10]

begin

	cwl = 5577.0
	w2 = w1 + ((nw - 1) * dw)
	if (cwl >= w1 && cwl <= w2) {
	    cwl1 = 5573.d0
	    cwl2 = 5581.d0
	    if (log) {
		cwl = log10 (cwl)
		cwl1 = log10 (cwl1)
		cwl2 = log10 (cwl2)
		}
	    choplist[1,1] = ((cwl - w1) / dw) - 0.5
	    pix1 = ((cwl1 - w1) / dw) - 0.5
	    pix2 = ((cwl2 - w1) / dw) - 0.5
	    choplist[2,1] = (pix2 - pix1) / 2.
	    nchop = 1
	    }
	else
	    nchop = 0

	call fchopper (out, nw, choplist, nchop)

	return
end
