
# SAO archive file definitions

# 1.  8 bits / byte
# 2.  ASCII character code
# 3.  16 bin signed twos complement integers with most significant bytes first.

define	ARC_BYTE	8	# Bits in an archive data byte
define	ARC_SHORT	16	# Bits in an archive data short
define	ARC_LONG	32	# Bits in an archive data long
define	ARC_REAL	32	# Bits in an archive data real
define	ARC_DOUBLE	64	# Bits in an archive data double
define	LEN_HEADER	48	# Length of ARC image file header in bytes

# Archive file Definitions

# The SAO Telescope Data Center Archive file meets this basic definition:
# 
# 1.  8 bits / byte
# 2.  ASCII character code
# 3.  MII data format (i.e. 8 bit unsigned integers and 16 and 32 bit signed
#     twos complement integers with most significant bytes first.)
#     See mii.h.
# 4.  Each variable length record is headed by a 48-character descriptor
#     containing an identifying keyword and the length in bytes plus
#     possible additional information.
# 5.  The information in the variable length record is defined for each
#     header keyword.

# Additional IRAF header parameters

define	PIXTYPE		IM_PIXTYPE($1)
define	NBPIX		IM_NBPIX($1)
define	IRAFMAX		IM_MAX($1)
define	IRAFMIN		IM_MIN($1)
define	LIMTIME		IM_LIMTIME($1)

# Mapping of FITS Keywords to IRAF image header

define	NAXIS	 IM_NDIM($1)
define	NAXISN	 IM_LEN($1,$2)
define	OBJECT	 IM_TITLE($1)
define	HISTORY	 IM_HISTORY($1)
define	UNKNOWN	 Memc[($1+IMU-1)*SZ_STRUCT+1]	# All unrecognized keywords
						# are stored here

define	SZ_OBJECT	SZ_IMTITLE
define	SZ_HISTORY	SZ_IMHIST
define	SZ_FCTYPE	SZ_CTYPE

# FITS cards not recognized by this header are stored in the USER AREA of
# the image header (UNKNOWN) up to a maximum of:
