#*** File datio/archive/arc_head.x
#*** January 29, 1993
#*** By Doug Mink, Center for Astrophysics

include <error.h>
include <imhdr.h>
include <imset.h>
include "arc.h"

procedure arc_head (hstring,lrec)

#  Decode archive file header

char	hstring[ARB]	# Archive record header string (returned unpacked)
int	lrec		# Length of rest of data record (returned)

char	tstring[LEN_HEADER]
int	i

include "head.com"
include "rarc.com"

begin

	do i = 1, LEN_HEADER {
	    tstring[i] = EOS
	    }
	call f77upk (hstring,tstring,LEN_HEADER,LEN_HEADER)
	do i = 1, LEN_HEADER {
	    hstring[i] = EOS
	    }
	call strcpy (tstring,hstring,LEN_HEADER)

	call tokenize (tstring, LEN_HEADER)
	call ctoi (tstring,tok0[2],lrec)

	if (debug == YES) {
	    call printf ("ARC_HEAD:  Record '%s' = %d bytes\n")
	    call pargstr (hstring)
	    call pargi (lrec)
	    }

	return
end


#  Subroutine to tokenize short header for easy decoding

procedure tokenize (tstr,lstr)

char tstr[ARB]	# Character string to tokenize
int lstr	# Length of string to tokenize

int isp, isp0
int i,nc,j
char temp[30]

include "head.com"
include "rarc.com"

define SPACE 32

begin
	isp = 1
	isp0 = 1
	ntok = 0

	while (isp < lstr) {
	    while (isp <= lstr && tstr[isp] != SPACE) isp = isp + 1
	    if (isp > 1) {
		ntok = ntok + 1
		tok0(ntok) = isp0
		tok1(ntok) = isp - 1
		}
	    else if (ntok > 0 && tok1(ntok) < lstr) {
		ntok = ntok + 1
		tok0(ntok) = isp0
		tok1(ntok) = lstr
		}
	    nc = tok1(ntok) - tok0(ntok) + 2
	    if (nc > 30) nc = 30
	    j = tok0(ntok)
	    i = 1
	    while (i < nc) {
		temp[i] = tstr[j]
		j = j + 1
		i = i + 1
		}
	    temp[nc] = EOS
	    isp0 = isp + 1
	    isp = isp + 1
	    if (ntok == 10) break
	    }

	return
end

# Jan 29 1993	Zero tstring before unpacking hstring into it
#		Check token number limit and boost it from 20 to 30
