#*** File archive/src/arc_name.x
#*** November 10, 1998
#*** By Doug Mink, Center for Astrophysics

#--- Make archive file pathname from instrument and reduced file number

procedure arc_name (rootpath,instrument,rfn,arcout,specdir,specfile,debug)

char rootpath[ARB]	# Pathname of root of archive directory
char instrument[ARB]	# Instrument name (mmt, zmach)("" for local file)
int rfn			# Reduced file number
int arcout		# if YES, assume file out of archive
char specdir[ARB]	# Archive directory pathname (returned)
char specfile[ARB]	# Archive file name (returned)
bool debug		# True to print additional information

int dirno, access()
int ldir, strlen()
char rfdir[20],rfname[20]

begin

#  If no instrument, assume file out of archive

	if (arcout == YES) {
	    call strcpy (rootpath,specdir,SZ_FNAME)
	    call strcat ("/",specdir,SZ_FNAME)
	    rfdir[1] = EOS
	    }

#  Make instrument directory name

	else {
	    call strcpy (rootpath,specdir,SZ_FNAME)
	    ldir = strlen (specdir)
	    if (specdir[ldir] != '/')
		call strcat ("/",specdir,SZ_FNAME)
	    call strcat (instrument,specdir,SZ_FNAME)
	    call strcat ("/rfdir/",specdir,SZ_FNAME)
	    }

#  Add name of correct 100-number subdirectory

	dirno = rfn / 100
	if (rfn < 10) {
	    call sprintf (rfdir,20,"r00%d")
		call pargi (dirno)
	    call sprintf (rfname,20,"0000%d")
		call pargi (rfn)
	    }
	else if (rfn < 100) {
	call sprintf (rfdir,20,"r00%d")
	    call pargi (dirno)
	call sprintf (rfname,20,"000%d")
	    call pargi (rfn)
	    }
	else if (rfn < 1000) {
	    call sprintf (rfdir,20,"r00%d")
		call pargi (dirno)
	    call sprintf (rfname,20,"00%d")
		call pargi (rfn)
	    }
	else if (rfn < 10000) {
	    call sprintf (rfdir,20,"r0%d")
		call pargi (dirno)
	    call sprintf (rfname,20,"0%d")
		call pargi (rfn)
	    }
	else {
	    call sprintf (rfdir,20,"r%d")
		call pargi (dirno)
	    call sprintf (rfname,20,"%d")
		call pargi (rfn)
	    } 
	if (arcout == NO) {
	    call strcat (rfdir,specdir,SZ_FNAME)
	    call strcat ("/",specdir,SZ_FNAME)
	    }

#  Get name of file given reduced file number

	if (debug) {
	    call printf ("ARC_NAME:  dir: %s, rfn: %s \n")
		call pargstr (specdir)
		call pargstr (rfname)
	    }

	specfile[1] = EOS
	if (access (specdir,0,0) == YES) {
	    if (rfn < 100000)
		call dirtemp (specdir,rfname,5,specfile)
	    else
		call dirtemp (specdir,rfname,6,specfile)
	    }
	else {
	    call printf ("ARC_NAME: directory %s not found for rfn %d\n")
		call pargstr (specdir)
		call pargi (rfn)
	    }

end
# Oct 12 1990	Subroutine written
# Feb  2 1994	Add debug option and avoid adding extra slash

# Nov 10 1998	Use 6-character template if rfn >= 100000
