#*** File saotdc/archive/Src/arc_utilities.x
#*** April 4, 2002
#*** By Doug Mink

include <imhdr.h>

# ARC_GET_IMAGE_TYPE -- Convert a character to an IRAF image type.

int procedure arc_get_image_type (c)

char	c
int	type_codes[7], i
int	stridx()
string	types "usilrdx"			# supported image data types
data	type_codes /TY_USHORT, TY_SHORT, TY_INT, TY_LONG, TY_REAL,
		    TY_DOUBLE, TY_COMPLEX/
begin
	i = stridx (c, types)
	if (i == 0)
	    i = 5
	return (type_codes[i])
end


# ARC_NEWFILE -- Make output filename from input filename

procedure arc_newfile (arcfile,rfn,outfile,maxchars)
char	arcfile[ARB]	# Reduced file name
int	rfn		# Reduced file number
char	outfile[ARB]	# IRAF file name
int	maxchars	# Length of IRAF file name

char	jsp, jdot
bool	keepname, clgetb()
int	lfn, idot, i, strlen(), stridx()
begin
	jsp = ' '
	jdot = '.'
	keepname = FALSE
	keepname = clgetb ("keep_name")
	if (keepname) {
	    call strcpy (arcfile,outfile,maxchars)
	    lfn = strlen (outfile)
	    for (i=1; i<=lfn; i=i+1) {
		if (outfile[i] == jsp) outfile[i] = '_'
		}
	    }
	else {
	    idot = stridx (jdot, arcfile)
	    call strcpy (arcfile, outfile,idot-1)
	    outfile[idot] = EOS
	    }
	return
end


# ARC_OUTFILE -- Make output filename from input filename

procedure arc_outfile (arcfile,rfn,outfile,maxchars)
char    arcfile[ARB]    # Reduced file name
int     rfn             # Reduced file number
char    outfile[ARB]    # IRAF file name
int     maxchars        # Length of IRAF file name

char    jsp
bool    keepname,clgetb()
int     lfn,strlen(),i
begin
	jsp = ' '
	keepname = FALSE
	keepname = clgetb ("keep_name")
	if (keepname) {
	    call strcpy (arcfile,outfile,maxchars)
	    lfn = strlen (outfile)
	    for (i=1; i<=lfn; i=i+1) {
		if (outfile[i] == jsp) outfile[i] = '_'
		}
	    }
	else {
	    call itoc (rfn,outfile,maxchars)
	    }
	return
end


# ARC_MAKE_REAL -- Procedure to change a line of archive numbers to reals

procedure arc_make_real (inbuf, outbuf, npix, in_type)

pointer	inbuf			# pointer to archive data line
pointer	outbuf			# pointer to IRAF image line
int	npix			# number of pixels
int	in_type			# input pixel type

begin
#	call printf ("ARC_MAKE_REAL:  Type is %d, %d pixels\n")
#	    call pargi (in_type)
#	    call pargi (npix)

	switch (in_type) {
	    case TY_SHORT, TY_USHORT:
		call achtsr (Mems[inbuf], Memr[outbuf], npix)
	    case TY_INT, TY_LONG:
		call achtlr (Memi[inbuf], Memr[outbuf], npix)
	    case TY_REAL:
		call amovr (Memr[inbuf], Memr[outbuf], npix)
	    case TY_DOUBLE:
		call achtdr (Memd[inbuf], Memr[outbuf], npix)
	    default:
		call error (10, "ARC_MAKE_REAL: Illegal archive type")
	    }
	return
end
# Jul 13 1992	arc_make_real from t_rarc.x
#		arc_get_image_type and arc_outfile from arc_dispcor.x

# Oct 20 1992	Make arc_outfile regual procedure, not int

# Apr  2 2002	Add arc_newfile to make 0-padded rfn files
