# analysis summary record

int	qcstat		# Quality controll status
			#   0 - not reviewed
			#   1 - inconclusive velocity determination
			#   2 - insufficient wavelength coverage
			#   3 - incorrect redshift velocity
			#   4 - correct redshift velocity

real	cz		# Overall radial velocity (Cz)
real	czerr		# Overall Cz error
real	czconf		# Overall Cz confidence
real	czxc		# correlation radial velocity
real	czxcerr		# correlation Cz error
real	czxcr		# correlation R value
real	czem		# emission line radial velocity
real	czemerr		# emission line radial velocity error
real	czemscat	# emission line velocity scatter (chi-square)

common/ansum/ qcstat,cz,czerr,czconf, czxc,czxcerr,czxcr,
	      czem,czemerr,czemscat

# correlation record

common/correl/ templw1,templw2,objrms,ntemp,nchop

real	templw1		# blue end of spectrum for best fit template
real	templw2		# red end of spectrum for best fit template
real	objrms		# rms of prepared object spectrum
int	ntemp		# number of templates in record
int	nchop		# number of emission lines chopped from spectrum
data nchop/0/


#  chopped emission line structure (one per line chopped)

common/temchop/ cchop,rchop

short	cchop		# log lambda of line center
short	rchop		# half-width of pixels chopped


#  template correlation structure (one per template)

common/tempcor/ tcenter,theight,twidth,trmsa,trmss,tshft,tpw

real	tcenter		# center of correlation peak (ln lambda)
real	theight		# height of correlation peak
real	twidth		# width (fwhm) of correlation peak
real	trmsa		# antisymmetric rms
real	trmss		# symmetric rms
real	tshft		# template shift (km/sec)
real	tpw		# pixels per log wavelength
