#*** File archive/Src/t_degdms.x
#*** April 10, 1992
#*** By Doug Mink

# DEGDMS -- Convert an angle from degrees to a character string
#           degrees:minutes:seconds.

procedure t_degdms()

pointer	sp
pointer	value
pointer degstr
double	degrees,seconds, ctod()
int	ih,im,is,isec
bool	clgetb(), keepfrac, verbose

begin
	call smark (sp)
	call salloc (value, SZ_LINE,  TY_CHAR)
	call salloc (secstr, SZ_LINE,  TY_CHAR)

	call clgstr ("degrees",Memc[degstr],SZ_LINE)
	degrees = ctod (Memc[degstr])
	seconds = degrees * 3600.d0
	ih = seconds / 3600.d0
	seconds = seconds - double (ih * 3600)
	im = seconds / 60.d0
	seconds = seconds - double (im * 60)

	keepfrac = clgetb ("fraction")
	if (!keepfrac) {
	    is = seconds + 0.5d0
	    call sprintf (Memc[value], SZ_LINE, "%02.2d:%02.2d:%02.2d")
		call pargi (ih)
		call pargi (im)
		call pargi (is)
	    }

	else {
	    is = seconds
	    isec = (seconds - double (is)) * 1.d4 + 0.5d0
	    if (isec > 9994) {
		seconds = 0.d0
		im = im + 1
		if (im > 59) {
		    im = im - 60
		    ih = ih + 1
		    }
		}
	    call sprintf (Memc[value], SZ_LINE, "%02.2d:%02.2d:%06.3f")
		call pargi (ih)
		call pargi (im)
		call pargd (seconds)
	    }

	call clpstr ("value", Memc[value])

	verbose = clgetb ("verbose")
	if (verbose) {
	    call printf ("DEGDMS: %s -> $s\n")
		call pargd (Memc[degstr])
		call pargstr (Memc[value])
	    }

	call sfree (sp)
	return
end
