#*** File archive/src/obs_name.x
#*** November 21, 1995
#*** By Doug Mink, Center for Astrophysics

#--- Make archive file pathname from instrument and reduced file number

procedure obs_name (rootpath, obsdate, rfn, specdir, specfile, debug)

char	rootpath[ARB]	# Pathname of root of archive directory
char	obsdate[ARB]	# Date as yyyy.mmdd
int	rfn		# Reduced file number
char	specdir[ARB]	# Archive directory pathname (returned)
char	specfile[ARB]	# Archive file name (returned)
bool	debug		# True to print additional information

int	access()
int	ldir, strlen()
char	rfname[20]

begin

#  Make directory name
	call strcpy (rootpath,specdir,SZ_FNAME)
	ldir = strlen (specdir)
	if (ldir > 0 && specdir[ldir] != '/' && specdir[ldir] != '$')
	    call strcat ("/",specdir,SZ_FNAME)
	call strcat (obsdate,specdir,SZ_FNAME)
	call strcat ("/",specdir,SZ_FNAME)

#  Set observation sequence number part of file name
	if (rfn < 10) {
	    call sprintf (rfname,20,"000%d")
		call pargi (rfn)
	    }
	else if (rfn < 100) {
	    call sprintf (rfname,20,"00%d")
		call pargi (rfn)
	    }
	else if (rfn < 1000) {
	    call sprintf (rfname,20,"0%d")
		call pargi (rfn)
	    }
	else {
	    call sprintf (rfname,20,"%d")
		call pargi (rfn)
	    } 

	if (debug) {
	    call printf ("OBS_NAME:  dir: %s, rfn: %s \n")
		call pargstr (specdir)
		call pargstr (rfname)
	    }

#  Get name of file given reduced file number
	specfile[1] = EOS
	if (access (specdir,0,0) == YES)
	    call dirtemp (specdir,rfname,4,specfile)
	else {
	    if (debug) {
		call printf ("OBS_NAME: directory %s not found for rfn %d\n")
		    call pargstr (specdir)
		    call pargi (rfn)
		}
	    specdir[1] = EOS
	    }
end
