#*** File archive/Src/t_degdms.x
#*** April 17, 1992
#*** By Doug Mink

# DEGDMS -- Convert an angle from degrees to a character string
#           degrees:minutes:seconds.

procedure t_degdms()

pointer	sp
pointer	value
pointer degstr
double	deg0,seconds
int	ih,im,is,isec,i1
bool	clgetb(), keepfrac, verbose, hours
char	dsgn

begin
	call smark (sp)
	call salloc (value, SZ_LINE,  TY_CHAR)
	call salloc (degstr, SZ_LINE,  TY_CHAR)

	call clgstr ("degrees",Memc[degstr],SZ_LINE)
	i1 = 1
	call ctod (Memc[degstr],i1,deg0)

#  Select hours or degrees
	hours = clgetb ("hours")
	if (hours)
	    deg0 = deg0 / 15.d0

#  Sign
	if (deg0 < 0) {
	    deg0 = -deg0
	    dsgn = '-'
	    }
	else
	    dsgn = '+'

#  Degrees or hours
	seconds = deg0 * 3600.d0
	ih = seconds / 3600.d0

#  Minutes of arc or time
	seconds = seconds - double (ih * 3600)
	im = seconds / 60.d0

#  Seconds of arc or time
	seconds = seconds - double (im * 60)

#  Round if not keeping fractional seconds
	keepfrac = clgetb ("fraction")
	if (!keepfrac) {
	    is = seconds + 0.5d0
	    call sprintf (Memc[value], SZ_LINE, "%c%d:%02.2d:%02.2d")
		call pargc (dsgn)
		call pargi (ih)
		call pargi (im)
		call pargi (is)
	    }

	else {
	    is = seconds
	    isec = (seconds - double (is)) * 1.d4 + 0.5d0
	    if (isec > 9994) {
		seconds = 0.d0
		im = im + 1
		if (im > 59) {
		    im = im - 60
		    ih = ih + 1
		    }
		}
	    call sprintf (Memc[value], SZ_LINE, "%c%d:%02.2d:%06.3f")
		call pargc (dsgn)
		call pargi (ih)
		call pargi (im)
		call pargd (seconds)
	    }

	call clpstr ("value", Memc[value])

	verbose = clgetb ("verbose")
	if (verbose) {
	    call printf ("DEGDMS: %f -> %s\n")
		call pargd (deg0)
		call pargstr (Memc[value])
	    }

	call sfree (sp)
	return
end
