# File archive/Src/harith.x
# October 5, 1992
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

include	<error.h>
include	<ctype.h>

# HARITH -- Get the value of an image header parameter as a character string.
# Convert it to double and add or subtract the double value of another parameter

procedure t_harith ()

pointer	sp, im
pointer	image, param, value
pointer	immap()
bool	verbose, clgetb()
char	outform[16]
double	dval1, dval2, clgetd()
char	op, clgetc()
int	ip

errchk imgstr, immap, imunmap

begin
	call smark (sp)
	call salloc (image, SZ_FNAME, TY_CHAR)
	call salloc (param, SZ_FNAME, TY_CHAR)
	call salloc (value, SZ_LINE,  TY_CHAR)

	call clgstr ("image", Memc[image], SZ_FNAME)
	call clgstr ("param1", Memc[param], SZ_FNAME)
	call clgstr ("format", outform, 16)
	op = clgetc ("operation")
	dval2 = clgetd ("inval")
	verbose = clgetb ("verbose")
	call strcpy ("0", Memc[value], SZ_LINE)

	if (op != 'p') {
	    iferr (im = immap (Memc[image], READ_ONLY, 0)) {
		if (verbose) call erract (EA_WARN)
		call clpstr ("outval", "0")
		}

	    iferr (call imgstr (im, Memc[param], Memc[value], SZ_LINE)) {
		if (verbose) call erract (EA_WARN)
		call clpstr ("outval", "0")
		}
	    else
		call clpstr ("outval", Memc[value])

	    iferr (call imunmap (im)) {
		if (verbose) call erract (EA_WARN)
		}
	    }

	ip = 1
	call ctod (Memc[value], ip, dval1)

	if (op == '+')
	    dval1 = dval1 + dval2
	else if (op == '-')
	    dval1 = dval1 - dval2
	else if (op == '/')
	    dval1 = dval1 / dval2
	else if (op == '*')
	    dval1 = dval1 * dval2
	else
	    dval1 = dval2
	call sprintf (Memc[value], 20, outform)
	    call pargd (dval1)

	if (op != 'p') {
	    }

	call clpstr ("outval", Memc[value])

	if (verbose) {
	    call printf ("%s \n")
		call pargstr (Memc[value])
	    }

	call sfree (sp)
end
