#*** File archive/Src/t_rfline.x
#*** February 9, 1995
#*** By Doug Mink, Center for Astrophysics

# RFLINE -- Get information from one line of a list file

include <error.h>
include <fset.h>

procedure t_rfline()

bool	verbose, clgetb()
char	line[SZ_LINE]		# list entry
char	temp[SZ_LINE]		# temporary string
char	nums[16]		# digits
char	jdot, jtab, jspace
int	ip, ip1, ctoi()
int	nc, num, rfn, nd, nsp, ntab, nfile, nnum
int	stridx(), strlen(), stridxs()

begin
	jdot = '.'
	jtab = char (9)
	jspace = char (32)
	call strcpy ("1234567890",nums,16)

#  Set up the standard output to flush on a newline
	call fseti (STDOUT, F_FLUSHNL, YES)

#  Get line to decode
	call clgstr ("list_line", line, SZ_LINE)
	verbose = clgetb ("verbose")

	num = 0

	nd = stridx (jdot,line)
	nnum = stridxs (nums,line)
	nsp = stridx (jspace,line[nnum])
	if (nsp > 0)
	    nsp = nsp + nnum - 1
	ntab = stridx (jtab,line[nnum])
	if (ntab > 0)
	    ntab = ntab + nnum - 1

#  Find length of first token in line
	if (nsp > 0) {
	    if (ntab > 0) {
		if (ntab < nsp)
		    nfile = ntab - 1
		else
		    nfile = nsp - 1
		}
	    else
		nfile = nsp - 1
	    }
	else if (ntab > 0)
	    nfile = ntab - 1
	else
	    nfile = strlen (line)

#  RFN is the first token or everything up to the "." within that token
	nc = nd - 1
	if (nd > 0 && nd < nfile)
		nc = nd - 1
	else
	    nc = nfile

	if (verbose) {
	    call printf ("RFLINE: dot: %d, space: %d, tab: %d\n")
		call pargi (nd)
		call pargi (nsp)
		call pargi (ntab)
	    call printf ("RFLINE: number is %d chars, file is %d chars\n")
		call pargi (nc)
		call pargi (nfile)
	    }

#  Return RFN as a number
	call strcpy (line, temp, nc)
	ip = 1
	ip1 = ctoi (temp, ip, rfn)
	call clputi ("rfn", rfn)

#  Return first token as the file name
	call strcpy (line, temp, nfile)
	call clpstr ("rfile", temp)

	if (verbose) {
	    call printf ("RFLINE: number is %d, file is %s\n")
		call pargi (rfn)
		call pargstr (temp)
	    }

end

# Feb  9 1995	New program
