#*** File archive/Src/t_rflist.x
#*** February 9, 1995
#*** By Doug Mink, Center for Astrophysics

# RFLIST -- Get information from list file

include <error.h>
include <fset.h>

define	MAX_RANGES	100
define	NTYPES	7
define	SZ_LIST	3000

procedure t_rflist()

bool	verbose, clgetb()
int	list[SZ_LIST]		# list
char	listfile[SZ_FNAME]	# file containing list
char	line[SZ_LINE]		# list entry
char	cnum[SZ_LINE]		# list entry
char	jdot, jdash, jcomma, jspace
int	i, ilist, clgeti(), ip, ip1, ctoi()
int	nc, nd, nx, num, nfiles, rfn, nh, nsp
int	get_next_number(), decode_ranges(), stridx()
int	rfn_range[MAX_RANGES*2+1]
pointer	fntopnb(), list_ptr
int	fntlenb(),fntgfnb(),junk, nlist

begin
	jdot = '.'
	jdash = '-'
	jcomma = ','
	jspace = ' '

	# Set up the standard output to flush on a newline
	call fseti (STDOUT, F_FLUSHNL, YES)

	# Get file name
	call clgstr ("list_file", listfile, SZ_LINE)
	ilist = clgeti ("ilist")
	verbose = clgetb ("verbose")

	list_ptr = fntopnb (listfile,NO)
	nlist = fntlenb (list_ptr)
	list[1] = 0
	num = 0
	for (i=1; i <= nlist; i=i+1) {
	    junk = fntgfnb (list_ptr,line,SZ_LINE)

#	If this is a range rather than a single number, expand it
	    nd = stridx (jdot,line)
	    nh = stridx (jdash,line)
	    nx = stridx (jcomma,line)
	    nsp = stridx (jspace,line)
	    if (nd == 0 && (nh > 0 || nx > 0)) {
		if (decode_ranges (line, rfn_range, MAX_RANGES, nfiles) == ERR)
       		    call error (1, "RFLIST: Illegal number list")
		else {
		    while (get_next_number (rfn_range, rfn) != EOF) {
			num = num + 1
			if (ilist > 0 && num == ilist) {
			    call clputi ("rfn",rfn)
			    break
			    }
			}
		    }

		}

	    else {

#	If this is a file name, drop everything after the "."
		nc = nd - 1
		if (nc <= 0) {
		    if (nsp > 0)
			nc = nsp - 1
		    else
			nc = SZ_LINE
		    }
		num = num + 1
		if (ilist > 0 && num == ilist) {
		    call strcpy (line,cnum,nc)
		    ip = 1
		    ip1 = ctoi (cnum,ip,rfn)
		    call clputi ("rfn",rfn)
		    call clpstr ("rfile",line)
		    break
		    }
		}
	    }
	if (verbose) {
	    call printf ("%d %d %s\n")
	    call pargi (ilist)
	    call pargi (nlist)
	    call pargstr (list)
	    }
	call fntclsb (list_ptr)
	call clputi ("nlist",num)

end
# Oct  9 1990	New program

# Feb  9 1995	Add code to deal with space-terminated RFN
