#*** File archive/Src/t_rfpath.x
#*** November 21, 1995
#*** By Doug Mink, Center for Astrophysics

# RFPATH -- Get FAST date and observation sequence number from line of list file
#           Date can be terminated by ".", space, or "/"

include <error.h>
include <fset.h>

procedure t_rfpath()

bool	verbose, clgetb()
char	line[SZ_LINE]		# list entry

char	temp[SZ_LINE]		# temporary string
char	nums[16]		# digits
char	jdot, jtab, jspace, jbracket, jslash
int	ip, ip1, ctoi()
int	ncd, num, nobs, nd, nsp, ntab, nbr, nnum, nsl, nd2, nd3, ncr
int	stridx(), stridxs(), strlen()

begin
	jdot = '.'
	jbracket = '['
	jslash = '/'
	jtab = char (9)
	jspace = char (32)
	call strcpy ("1234567890",nums,16)

#  Set up the standard output to flush on a newline
	call fseti (STDOUT, F_FLUSHNL, YES)

#  Get line to decode
	call clgstr ("list_line", line, SZ_LINE)
	verbose = clgetb ("verbose")

	num = 0

#  Find end of date
	nnum = stridxs (nums,line)
	if (verbose) {
	    call printf ("RFPATH: %s\n")
		call pargstr (line)
	    call printf ("RFPATH: nnum=%d\n")
		call pargi (nnum)
	    }

# Find first space in line
	nsp = stridx (jspace,line[nnum+1])
	if (nsp > 0)
	    nsp = nsp + nnum

# Find first bracket in line
	nbr = stridx (jbracket,line[nnum+1])
	if (nbr > 0) {
	    if (nsp == 0 || nbr < nsp)
		nsp = nbr + nnum
	    }

# Find first slash in line
	nsl = stridx (jslash,line[nnum+1])
	if (nsl > 0) {
	    if (nsp == 0 || nsl < nsp)
		nsp = nsl + nnum
	    }

# Find first tab in line
	ntab = stridx (jtab,line[nnum+1])
	if (ntab > 0) {
	    if (nsp == 0 || ntab < nsp)
		nsp = ntab + nnum
	    }
	if (verbose) {
	    call printf ("RFPATH: nsp=%d, nbr=%d, nsl=%d, ntab=%d\n")
		call pargi (nsp)
		call pargi (nbr)
		call pargi (nsl)
		call pargi (ntab)
	    }

#  Set end of date and start of RFN
	nd = stridx (jdot,line)
	nd2 = stridx (jdot,line[nd+1])
	if (nd2 > 0)
	    nd2 = nd2 + nd

#  Set start of sequence number after first slash, space, tab, or bracket
	if (nsp > 0) {
	    nd2 = nsp
	    nd2 = stridxs (nums,line[nsp+1])
	    nd2 = nd2 + nsp
	    }
	else if (nd2 > 0) {
	    nsp = nd2
	    nd2 = nsp + 1
	    }

#  Set end of RFN
	nd3 = stridx (jdot,line[nd2+1])
	if (nd3 <= 0)
	    nd3 = stridx (jspace,line[nd2+1])
	if (nd3 > 0)
	    nd3 = nd3 + nd2 - 1
	else
	    nd3 = strlen (line)
	if (verbose) {
	    call printf ("RFPATH: nd1=%d, nd2=%d, nd3=%d, nsp=%d\n")
		call pargi (nd)
		call pargi (nd2)
		call pargi (nd3)
		call pargi (nsp)
	    }

# Set RFN string
	ncr = nd3 - nd2 + 1
	call strcpy (line[nd2],temp,ncr)

#  Get RFN as a number
	ip = 1
	ip1 = ctoi (temp, ip, nobs)
	call clputi ("nobs", nobs)

# Set date string
	ncd = nsp - nnum
	call strcpy (line[nnum],temp,ncd)

#  Return date as string
	call clpstr ("obsdate", temp)

	if (verbose) {
	    call printf ("RFPATH: date is %s, number is %d\n")
		call pargstr (temp)
		call pargi (nobs)
	    }
end

# Feb 24 1995	New program
# Nov 21 1995	Handle more date/number formats
