#*** File archive/Src/t_rflist.x
#*** July 6, 1992
#*** By Doug Mink, Center for Astrophysics

# RLIST -- Get line at a time from file

include <error.h>
include <fset.h>

procedure t_rlist()

bool	verbose, clgetb()
char	listfile[SZ_FNAME]
char	next_line[SZ_FNAME]
char	out_line[SZ_FNAME]
int	ilist, llist, iline, nlist, clgeti()
int	fd, open(), getline(), strlen()

begin
	# Set up the standard output to flush on a newline
	call fseti (STDOUT, F_FLUSHNL, YES)

	# Get file name
	call clgstr ("list_file", listfile, SZ_LINE)

	# If first character is a @, drop it
	if (listfile[1] == '@') {
	    llist = strlen [listfile]
	    do ilist = 1, llist {
		listfile[ilist] = listfile[ilist+1]
		}
	    }
	    
	ilist = clgeti ("ilist")
	verbose = clgetb ("verbose")

	fd = open (listfile,READ_ONLY,TEXT_FILE)
	iline = 1
	if (ilist <= 0)
	    ilist = 1000
	while (getline (fd,next_line) > 0) {
	    if (iline == ilist)
		call strcpy (next_line, out_line, SZ_LINE)
	    iline = iline + 1
	    }
	nlist = iline
	if (verbose) {
	    call printf ("%d %d %s\n")
	    call pargi (ilist)
	    call pargi (nlist)
	    call pargstr (out_line)
	    }
	call close (fd)
	call clpstr ("line",out_line)
	call clputi ("nlist",nlist)

end

# Jul  6 1992	Need only READ_ONLY access, not READ_WRITE
