
#  Common for appropriate order wavelength fit

double wblue		# bluest wavelength line defined
double wred		# reddest wavelength line defined
real wdum		# Pad for RISC machines
long wdim		# dimension of pixel to wavelength polynomial
double wmid		# midpoint of independent variable in pixels
double wscale		# scaling factor for pixels
double wcoeff[8]	# coefficients for pixel to wavelength polynomial
double pblue		# bluest pixel in fit
double pred		# reddest pixel in fit
real pdum		# pad for RISC machines
long pdim		# dimension of wavelength to pixel polynomial
double pmid		# midpoint of independent variable in angstroms
double pscale		# scaling factor for wavelength
double pcoeff[8]	# coefficients for wavelength to pixel polynomial
int dispoff		# Pixel offset for dispersion (1=new, 0=old)


common /wpconv/ wblue,wred,wdum,wdim,wmid,wscale,wcoeff,
		pblue,pred,pdum,pdim,pmid,pscale,pcoeff,dispoff

#  Common for 5th order wavelength fit

real w5dum
real w5blue		# bluest wavelength line defined
real w5red		# redest wavelength line defined
real w5rmsang		# rms of wavelength fit in angstroms
real w5rmspix		# rms of wavelength fit in pixels
long w5nlin		# number of lines in fit
long w5dim		# dimension of pixel to wavelength polynomial
long w5point		# unused pointer
double w5mid		# midpoint of independent variable in pixels
double w5scale		# scaling factor for pixels
double w5coeff[6]	# coefficients for pixel to wavelength polynomial
long p5dim		# dimension of wavelength to pixel polynomial
long p5point		# unused pointer
double p5mid		# midpoint of independent variable in angstroms
double p5scale		# scaling factor for wavelength
double p5coeff[6]	# coefficients for wavelength to pixel polynomial

common /waver5/ w5dum,w5blue,w5red,w5rmsang,w5rmspix,w5nlin,w5dim,w5point,
		w5mid,w5scale,w5coeff,p5dim,p5point,p5mid,p5scale,p5coeff

#  Common for 7th order wavelength fit

real w7dum
real w7blue		# bluest wavelength line defined
real w7red		# redest wavelength line defined
real w7rmsang		# rms of wavelength fit in angstroms
real w7rmspix		# rms of wavelength fit in pixels
long w7nlin		# number of lines in fit
long w7dim		# dimension of pixel to wavelength polynomial
long w7point		# unused pointer
double w7mid		# midpoint of independent variable in pixels
double w7scale		# scaling factor for pixels
double w7coeff[10]	# coefficients for pixel to wavelength polynomial
long p7dim		# dimension of wavelength to pixel polynomial
long p7point		# unused pointer
double p7mid		# midpoint of independent variable in angstroms
double p7scale		# scaling factor for wavelength
double p7coeff[10]	# coefficients for wavelength to pixel polynomial

common /waver7/ w7dum,w7blue,w7red,w7rmsang,w7rmspix,w7nlin,w7dim,w7point,
		w7mid,w7scale,w7coeff,p7dim,p7point,p7mid,p7scale,p7coeff

# Jan 29 1993	Add dispoff to /wpconv/ common
# Jul 11 2005	Increase coefficient buffer to avoid overwriting scale factors
