#{ SPECRED package definition

s1 = envget ("min_lenuserarea")
if (s1 == "")
    reset min_lenuserarea = 100000
else if (int (s1) < 100000)
    reset min_lenuserarea = 100000
 
package fastred

task	fparams		= "fastred$sparams.par"

# Onedspec tasks
task	autoidentify,
	calibrate,
	continuum,
	deredden,
	dispcor,
	dopcor,
	fitprofs,
	identify,
	refspectra,
	reidentify,
	sapertures,
	sarith,
	scombine,
	sensfunc,
	sfit,
	sflip,
	slist,
	specplot,
	specshift,
	splot,
	standard	= "onedspec$x_onedspec.e"
task	aidpars		= "onedspec$aidpars.par"
task	bplot		= "onedspec$bplot.cl"
task	scopy		= "onedspec$scopy.cl"
task	dispcor1	= "onedspec$dispcor1.par"
 
# Apextract tasks
task	apall,
	apedit,
	apfind,
	apfit,
	apflatten,
	apmask,
	apnormalize,
	aprecenter,
	apresize,
	apscatter,
	apsum,
	aptrace		= "apextract$x_apextract.e"
task	apparams	= "apextract$apparams.par"
task	apall1		= "apextract$apall1.par"
task	apfit1		= "apextract$apfit1.par"
task	apflat1		= "apextract$apflat1.par"
task	apnorm1		= "apextract$apnorm1.par"
task	apdefault	= "apextract$apdefault.par"
task	apscat1		= "apextract$apscat1.par"
task	apscat2		= "apextract$apscat2.par"

# Longslit tasks
task	illumination,
	response	= "twodspec$longslit/x_longslit.e"
task	background	= "generic$background.cl"

# Astutil tasks
task	setairmass,
	setjd		= "astutil$x_astutil.e"

# Rvsao tasks
task	xcsao,
	bcvcorr,
	emsao		= "rvsao$x_rvsao.e"

# Itools tasks
task	demach		= "itools$x_itools.e"

# Archive tasks
task	emcorf		= "archive$Scripts/emcorf.cl"
task	emrangf		= "archive$Scripts/emrangf.cl"
task	fastseq		= "archive$Scripts/fastseq.cl"
task	fastseq1	= "archive$Scripts/fastseq1.cl"
task	fastseqr	= "archive$Scripts/fastseqr.cl"
task	rfast		= "archive$Scripts/rfast.cl"
task	rfast1		= "archive$Scripts/rfast1.cl"
task	obnobj,
	vtoj,
	jtov,
	rfpath		= "archive$x_archive.e"

task	imgetp		= "procdata$x_procdata.e"

# Hide tasks from the user
hidetask apparams, apall1, apfit1, apflat1, apnorm1, apscat1, apscat2, dispcor1
hidetask sparams, rfast1
hidetask apscript, proc, batch, arcrefs, doarcs, getspec, listonly, fibresponse

clbye
