	subroutine aperts

	call apert
	
	return
	end

	subroutine apert
C
C	program to determine the flux in elliptical annuli
C
C	Reynier Peletier 2 August 1990
C
	parameter (MAXNPIX=512*512)
C
C	New Declarations
C
	character*128 string,infile,maskfile
	character*60 object,objmask,datafile
	integer profs1,profs2,posonly,fixsky
	real pixi(MAXNPIX),maskf(MAXNPIX)
	real cen(2),dmin,dmax,factor,xc,yc,ell,posang,scale
	real bmin,bmax,sky,pcon,tint,pcon1,pcon2
	logical negative,isophotal,selap

C	read in parameters

	call gproms('inputfile',' ',' ',infile,ierr)
	call gproms('maskfile',' ',' ',maskfile,ierr)
	call gpromr('dmin',1.,' ',dmin,ierr)
	call gpromr('dmax',100.,' ',dmax,ierr)
	call gpromr('factor',1.1,' ',factor,ierr)
	call gpromr('xc',1.,' ',xc,ierr)
	call gpromr('yc',1.,' ',yc,ierr)
	call gproml('isophotal',.FALSE.,' ',isophotal,ierr)
	call gpromr('ell',0.,' ',ell,ierr)
	call gpromr('posang',0.,' ',posang,ierr)
	call gpromr('scale',1.,' ',scale,ierr)
	call gpromr('bmin',50.,' ',bmin,ierr)
	call gpromr('bmax',100.,' ',bmax,ierr)
	call gpromi('fixsky',0.,' ',fixsky,ierr)
	call gpromr('sky',0.,' ',sky,ierr)
	call gpromr('pcon',26.,' ',pcon,ierr)
	call gpromr('tint',30.,' ',tint,ierr)
	call gpromr('se',10.,' ',se,ierr)
	call gpromr('pe',0.,' ',pe,ierr)
	call gproms('datafile',' ',' ',datafile,ierr)
	call gproml('negative',.FALSE.,' ',negative,ierr)
	call gproml('selap',.FALSE.,' ',selap,ierr)

	call gimopen(1,infile,ierr)
	if (ierr.ne.0) then
	   write (string,'('' APERT: Error opening '',a)') infile(1:80)
	   call gwrits(string,2)
	   return
	end if
	call gimhead(1,object,nx,ny,ierr)
	if (ierr.ne.0) then
	   write (string,'('' APERT: Error opening header of'',a)') 
     1            infile(1:80)
	   call gwrits(string,2)
	end if
	write (string,'('' Dimensions of inputfile  '',2I)') nx,ny
	call gwrits(string,2)
C
C	Read in pixel data
C
	call readin(1,nx,ny,pixi,ierr)
C
C	now the mask file
C
	call gimopen(2,maskfile,ierr)
	if (ierr.ne.0) then
	   write (string,'('' APERT: Error opening '',a)') maskfile(1:80)
	   call gwrits(string,2)
	   return
	end if
	call gimhead(2,objmask,nx,ny,ierr)
	if (ierr.ne.0) then
	   write (string,'('' APERT: Error opening header of'',a)') 
     1            maskfile(1:80)
	   call gwrits(string,2)
	end if
C
C	Read in mask file
C
	call readin(2,nx,ny,maskf,ierr)
	cen(1)=xc
	cen(2)=yc
C
C	now call subroutine to do all the work
C
	call apwork(pixi,nx,ny,maskf,dmin,dmax,factor,cen,ell,
     1		    posang,scale,bmin,bmax,sky,fixsky,pcon,tint,
     2		    datafile,negative,isophotal,pe,se,selap)
	close(11)
100	return
	end

	subroutine apwork(pixi,nx,ny,maskf,dmin,dmax,factor,cen,ell,
     1		    posang,scale,bmin,bmax,sky,fixsky,pcon,tint,
     2		    datafile,negative,isophotal,pe,se,selap)
	
	real pixi(nx,ny),maskf(nx,ny)
	real dmin,dmax,factor,cen(2),ell,posang,scale,bmin,bmax
	logical negative,apmask,isophotal,selap
	real sky,pcon,tint,back(10000),pe,se
	real ap(100),xout,yout,xerr,yerr,xsig,ysig
	integer imap(4),nx,ny,istat,fixsky
	character*128 string
	character*60 datafile

	if (negative) then
	   do i=1,nx
	      do j=1,ny
		 pixi(i,j)=-pixi(i,j)
	      enddo
	   enddo
	end if
C
C	first determine the centre carefully
C
	open(unit=11,file=datafile,status='new',err=100)
	imap(1)=int(cen(1)+0.5)-5
	imap(2)=int(cen(1)+0.5)+5
	imap(3)=int(cen(2)+0.5)-5
	imap(4)=int(cen(2)+0.5)+5
	if (imap(1).lt.1) imap(1)=1
	if (imap(2).gt.nx) imap(2)=nx
	if (imap(3).lt.1) imap(3)=1
	if (imap(4).gt.ny) imap(4)=ny
	istat=0
	call starcen(pixi,nx,ny,'M',imap,xout,yout,xerr,yerr,
     1               xsig,ysig,istat)
	if ((xsig.lt.0.001).and.(ysig.lt.0.001)) then
	   xout=cen(1)
	   yout=cen(2)
	end if
	write (string,'('' STARCEN: '',4F10.3)') xout,yout,xsig,ysig
	call gwrits(string,2)
C
C	now determine the sky background
C
	pi=3.1415926535897
	ca=cos(posang*pi/180.)
	sa=sin(posang*pi/180.)
	if (fixsky.gt.0) then
	   bkgd=sky
	else
	   sum=0.
	   np=0
	   ib=0
	   bmin=bmin*bmin
	   bmax=bmax*bmax
	   do i=1,nx
	      do j=1,ny
		 d=(ca*(i-xout)+sa*(j-yout))**2. + 
     1		   ((ca*(j-yout)-sa*(i-xout))/(1.-ell))**2.
	         if ((maskf(i,j).gt.0.5).and.(d.ge.bmin)
     1		   .and.(d.le.bmax)) then
		    ib=ib+1
		    back(ib)=pixi(i,j)
		 end if
	      enddo
	   enddo
	   if (ib.gt.0.) then
C
C	sort back
C
	      do i=1,ib-1
	         do j=i+1,ib
		    if (back(i).gt.back(j)) then
		       h=back(i)
		       back(i)=back(j)
		       back(j)=h
		    end if
		 enddo
	      enddo
	      bkgd=back(ib/2)
	   write (string,'('' Sky determined from '',I4,'' pixels '',F)') ib,
     1		 bkgd
	   call gwrits(string,2)
	   else
	      bkgd=sky
	   write (string,'('' no pixels available for sky '')') 
	   call gwrits(string,2)
	   end if
	end if
C
C	now calculate apertures
C
	if (scale.le.0.) scale=1.
	rmin=dmin/(2.*scale)
	rmax=dmax/(2.*scale)
	corr1=2.*alog10(scale)/alog10(2.50)
	corr2=alog10(tint)/alog10(2.50)
	if (isophotal) then
C
C	now calculate isophotal magnitudes within r=rmax
C
	   write (11,780) ' *** ISOPHOTAL MAGNITUDES ***   ',
     1            datafile(1:20),xout,yout
780	   format (A,A,2F9.3)
	   write (11,99999) ' '
	   write (11,786) '     Mag    Npix ', 
     1      '    Flux   Flux(Mag)   Bkgd      SB      Pcon     Tint   '
	   write (string,786) '     Mag    Npix ', 
     1      '    Flux   Flux(Mag)   Bkgd      SB          Errors      '
786	   format (A,A)
	   call gwrits(string,2)
	   write (string,'(''                                       '',
     1         ''                                            '')')
	   call gwrits(string,2)
	   write (11,99999) ' '
	   pcon1=26-pcon
	   do nh=1,23
	      h=13.5+nh*0.5
	      cst=10.**(-0.4*(h-pcon1-corr1-corr2))
	      sum=0.
	      np=0
	      nq=0
	      do i=1,nx
		 do j=1,ny
		    d2=((i-xout)**2.+(j-yout)**2.)
		    if ((d2.le.rmax*rmax).and.(maskf(i,j).gt.0.5)) then
		       if ((pixi(i,j)-bkgd).ge.cst) then
		          sum=sum+pixi(i,j)-bkgd
		          np=np+1
			  if ((pixi(i,j)-bkgd).lt.se) nq=nq+1
		       end if
		    end if
		 enddo
	      enddo
C
C	correction to apply since only points above a certain threshold are
C	taken
C
	      sum=sum-nq*se
	      if (sum.gt.0.) then
	         smag=pcon1+corr2-2.5*log10(sum)
	      else
		 smag=99.99
	      end if
	      if (np.gt.0) then
	         tl=alog10(np*1.)/alog10(2.5)
	         sb=smag+tl+corr1
	      else
	         sb=99.99
	      end if
	      sum1=0.
	      np1=0
	      nq1=0
	      do i=1,nx
		 do j=1,ny
		    d2=((i-xout)**2.+(j-yout)**2.)
		    if ((d2.le.rmax*rmax).and.(maskf(i,j).gt.0.5)) then
		       if ((pixi(i,j)-bkgd+se).ge.cst) then
		          sum1=sum1+pixi(i,j)-bkgd+se
		          np1=np1+1
			  if ((pixi(i,j)-bkgd+se).lt.se) nq1=nq1+1
		       end if
		    end if
		 enddo
	      enddo
C
C	correction to apply since only points above a certain threshold are
C	taken
C
	      sum1=sum1-nq1*se
	      if (sum1.gt.0.) then
	         smag1=pcon1+corr2-2.5*log10(sum1)
	      else
		 smag1=99.99
	      end if
	      sum2=0.
	      np2=0
	      nq2=0
	      do i=1,nx
		 do j=1,ny
		    d2=((i-xout)**2.+(j-yout)**2.)
		    if ((d2.le.rmax*rmax).and.(maskf(i,j).gt.0.5)) then
		       if ((pixi(i,j)-bkgd-se).ge.cst) then
		          sum2=sum2+pixi(i,j)-bkgd-se
		          np2=np2+1
			  if ((pixi(i,j)-bkgd-se).lt.se) nq2=nq2+1
		       end if
		    end if
		 enddo
	      enddo
	      sum2=sum2-nq2*se
	      if (sum2.gt.0.) then
	         smag2=pcon1+corr2-2.5*log10(sum2)
	      else
		 smag2=99.99
	      end if
C
C	now calculate errors
C
C
C	2. as a result of pixel-pixel variations
C
	      sumb1=sum + sqrt(np*1.)*pe
	      sumb2=sum - sqrt(np*1.)*pe
	      if (sumb1.gt.0.) then
	         smagb1=pcon1+corr2-2.5*log10(sumb1)
	      else
		 smagb1=99.99
	      end if
	      if (sumb2.gt.0.) then
	         smagb2=pcon1+corr2-2.5*log10(sumb2)
	      else
		 smagb2=99.99
	      end if
	      smaga1=smag1-smag
	      smaga2=smag2-smag
	      smagb1=smagb1-smag
	      smagb2=smagb2-smag
	      smagt1=-sqrt(smaga1*smaga1+smagb1*smagb1)
	      smagt2=sqrt(smaga2*smaga2+smagb2*smagb2)
	      write (11,666) h,np,sum,smag,bkgd,sb,pcon,tint
666	      format (F9.3,I6,'  ',G9.3,5F9.3)
	      write (11,667) '      Errors : ',smaga1,smaga2,smagb1,smagb2,
     1              smagt1,smagt2
667	      format (A,6F8.3)
	      write (string,668) h,np,sum,smag,bkgd,sb,smagt1,smagt2
668	      format (F9.3,' ',I6,'  ',G9.3,5F9.3)
	      call gwrits (string,2)
	   enddo
	else
	if (.not.selap) then
	   ap(1)=rmin
	   i=1
400	   if (ap(i).le.rmax) then
	      i=i+1
	      ap(i)=factor*ap(i-1)
	      goto 400
	   end if
	   na=i-1
	else
	   ap(1)=rmin*0.1
	   ap(2)=rmin*0.2
	   ap(3)=rmin*0.3162
	   ap(4)=rmin*0.5
	   ap(5)=rmin
	   na=5
	end if
	pcon2=26.00-pcon-corr1
	write (11,780) ' *** CIRCULAR/ELLIPTICAL MAGNITUDES ***   ',
     1         datafile(1:20),xout,yout
	write (11,99999) ' '
	write (11,776) '      R(")     Npix  ', 
     1           '    Flux      Bkgd      Pcon    Tint   Ell  ',
     2           '    PA      SB'
776	format (A,A,A) 
	write (string,776) '      R(")      Npix  ', 
     1           '    Flux      Bkgd      SB           Errors    '
	call gwrits(string,2)
	write (string,'(''                                       '',
     1         ''                                            '')')
	call gwrits(string,2)
	write (11,99999) ' '
99999	format(A)
	if (ell.ge.1.) then
	   write (string,'('' ellipticity too large '')')
	   call gwrits (string,2)
	   return
	end if
	do k=1,na
	   sum=0.
	   tpoids=0
	   apmask=.false.
	   napm=0
	   do i=1,nx
	      do j=1,ny
	         poids=0.
		 d=(ca*(i-xout)+sa*(j-yout))**2. + 
     1		   ((ca*(j-yout)-sa*(i-xout))/(1.-ell))**2.
		 d=sqrt(d)
		 dif=ap(k)-d
		 if (dif.ge.0.) then
		    if (maskf(i,j).lt.0.5) then
		       apmask=.true.
		       napm=napm+1
		    else
		       if (dif.gt.0.5) then
			  poids=1.
		       else
			  poids=0.5*(1+2.*dif)
		       end if
		    end if
		 else
		    if (abs(dif).gt.0.5) then
		       poids=0.
		    else
		       if (maskf(i,j).lt.0.5) then
		          apmask=.true.
			  napm=napm+1
		       else
			  poids=0.5*(1.+2.*dif)
		       end if
		    end if
		 end if
		 if (poids.gt.0.) then
	         end if
		 sum=sum+poids*pixi(i,j)
		 tpoids=tpoids+poids
	      enddo
	   enddo
C
C	subtract background
C
	   sum=sum-tpoids*bkgd
	   if (sum.le.0.) then
	      write (string,'('' Negative signal '')')
	      call gwrits(string,2)
	      return
	   end if
C
C	now transform to magnitudes
C
	   tl=alog10(tpoids)/alog10(2.5)
	   smag=pcon2-2.5*alog10(sum)+corr1+corr2
	   sb=smag+tl+corr1
C
C	now calculate errors
C
C	1. systematic sky errors
C
	      suma1=sum-tpoids*se
	      suma2=sum+tpoids*se
C
C	2. as a result of pixel-pixel variations
C
	      sumb1=sum + sqrt(tpoids)*pe
	      sumb2=sum - sqrt(tpoids)*pe
	      if (suma1.gt.0.) then
	         smaga1=pcon2+corr2-2.5*log10(suma1)+corr1
	      else
		 smaga1=99.99
	      end if
	      if (suma2.gt.0.) then
	         smaga2=pcon2+corr2-2.5*log10(suma2)+corr1
	      else
		 smaga2=99.99
	      end if
	      if (sumb1.gt.0.) then
	         smagb1=pcon2+corr2-2.5*log10(sumb1)+corr1
	      else
		 smagb1=99.99
	      end if
	      if (sumb2.gt.0.) then
	         smagb2=pcon2+corr2-2.5*log10(sumb2)+corr1
	      else
		 smagb2=99.99
	      end if
	      smaga1=smaga1-smag
	      smaga2=smaga2-smag
	      smagb1=smagb1-smag
	      smagb2=smagb2-smag
	      smagt1=sqrt(smaga1*smaga1+smagb1*smagb1)
	      smagt2=-sqrt(smaga2*smaga2+smagb2*smagb2)
	   write (11,777) ap(k)*scale,tpoids,smag,bkgd,pcon,tint,
     1                    ell,posang,sb
	   write (11,667) '      Errors : ',smaga1,smaga2,smagb1,smagb2,
     1		 smagt1,smagt2
	   write (string,779) ap(k)*scale,tpoids,smag,bkgd,sb,smagt1,smagt2
	   call gwrits(string,2)
777	   format (F10.3,F9.2,3F10.3,F8.1,F7.3,F8.1,F9.3)
779	   format (7F10.3)
	   if (apmask) then
	      write (string,'(''    Careful:'',I5,'' pixels masked '')') 
     1              napm 
	      call gwrits(string,2)
	      write (11,'(''     Careful:'',I5,'' pixels masked '')') napm
	   end if
	enddo
	end if
	close(11)
100	return
	end
