	subroutine redcl

	call clred

	return
	end

	subroutine clred
C-----------------------------------------------------------------------------
C
C	program to reduce IR-data; removes stars from background fields
C	subtracts sky, divides by flatfield
C
C-----------------------------------------------------------------------------

	Parameter (MAXNPIX=256*256*20,MAXPIX=256*256)

	Integer Nx,Ny,unit
	Real*4 obji(MAXNPIX),skyi(MAXNPIX),darkf(MAXPIX)
	Real*4 maskf(MAXPIX),flatf(MAXPIX),redi(MAXNPIX)
	Real*4 scr(MAXPIX),ssky(MAXPIX),starco
	Character*10 Ans
	Character*128 outname,darkfile,maskfile
	Character*128 objlist,skylist,redlist
	Character*128 olist(100),string,flatfile
	Character*128 slist(100),rlist(100)
	Character*60 obj(100),objdark,objmask,objflat
	Character*60 sky(100),red(100)

	call gproms('objlist',' ',' ',objlist,ierr)
	call gproms('skylist',' ',' ',skylist,ierr)
	call gproms('redlist',' ',' ',redlist,ierr)
	call gproms('darkfile',' ',' ',darkfile,ierr)
	call gproms('maskfile',' ',' ',maskfile,ierr)
	call gproms('flatfield',' ',' ',flatfile,ierr)
	call gpromr('starcutoff',0.03,' ',starco,ierr)

C	
C	first unravel the list of input,output and reduced files
C
	L=Len(objlist)
	ipos=1
10	if (objlist(ipos:ipos).eq.'@') then	
	   objlist(1:(128-ipos))=objlist((ipos+1):128)
	   call unravel(objlist,olist,N)
	else
	   if (objlist(ipos:ipos).eq.' ') then
	      ipos=ipos+1
	      if (ipos.le.L) goto 10
	   else
	      olist(1)=objlist
	      N=1
	   end if
	end if
110	if (skylist(ipos:ipos).eq.'@') then	
	    skylist(1:(128-ipos))=skylist((ipos+1):128)
	   call unravel(skylist,slist,N1)
	else
	   if (skylist(ipos:ipos).eq.' ') then
	      ipos=ipos+1
	      if (ipos.le.L) goto 110
	   else
	      slist(1)=skylist
	      N1=1
	   end if
	end if
	if (N1.ne.N) then
	   write (string,'('' obj and sky list unequal length'')')
	   return
	end if
210	if (redlist(ipos:ipos).eq.'@') then	
	   redlist(1:(128-ipos))=redlist((ipos+1):128)
	   call unravel(redlist,rlist,N2)
	else
	   if (redlist(ipos:ipos).eq.' ') then
	      ipos=ipos+1
	      if (ipos.le.L) goto 210
	   else
	      rlist(1)=redlist
	      N2=1
	   end if
	end if
	if (N2.ne.N) then
	   write (string,'('' obj and reduced list unequal length'')')
	   return
	end if

	unit=11
	do i=1,N
	   call gimopen(unit,olist(i),ierr)
	   if (ierr.ne.0) then
	    write (string,'('' CLRED: Error opening '',a)') olist(i)
	    call gwrits(string,2)
	    return
	   end if
	   call gimhead(unit,obj(i),nx,ny,ierr)
	   if (ierr.ne.0) then
	    write (string,'('' CLRED: Error opening header of'',a)') olist(i)
	    call gwrits(string,2)
	   end if
	   unit=unit+1
	end do
	call read3d(11,nx,ny,N,obji,ierr)
	nu=unit
	do i=1,N
	   call gimopen(unit,slist(i),ierr)
	   if (ierr.ne.0) then
	    write (string,'('' CLRED: Error opening '',a)') slist(i)
	    call gwrits(string,2)
	    return
	   end if
	   call gimhead(unit,sky(i),nx,ny,ierr)
	   if (ierr.ne.0) then
	    write (string,'('' CLRED: Error opening header of'',a)') slist(i)
	    call gwrits(string,2)
	   end if
	   unit=unit+1
	end do
	call read3d(nu,nx,ny,N,skyi,ierr)

	call gimopen(61,darkfile,ierr)
	if (ierr.ne.0) then
	   write (string,'('' CLRED: Error opening '',a)') darkfile
	   call gwrits(string,2)
	   return
	end if
	call gimhead(61,objdark,nx,ny,ierr)
	if (ierr.ne.0) then
	   write (string,'('' CLRED: Error opening header of'',a)') darkfile
	   call gwrits(string,2)
	end if
	call readin(61,nx,ny,darkf,ierr)

	call gimopen(62,maskfile,ierr)
	if (ierr.ne.0) then
	   write (string,'('' CLRED: Error opening '',a)') maskfile
	   call gwrits(string,2)
	   return
	end if
	call gimhead(62,objmask,nx,ny,ierr)
	if (ierr.ne.0) then
	   write (string,'('' CLRED: Error opening header of'',a)') maskfile
	   call gwrits(string,2)
	end if
	call readin(62,nx,ny,maskf,ierr)
	call gimopen(63,flatfile,ierr)
	if (ierr.ne.0) then
	   write (string,'('' CLRED: Error opening '',a)') flatfile
	   call gwrits(string,2)
	   return
	end if
	call gimhead(63,objflat,nx,ny,ierr)
	if (ierr.ne.0) then
	   write (string,'('' CLRED: Error opening header of'',a)') flatfile
	   call gwrits(string,2)
	end if
	call readin(63,nx,ny,flatf,ierr)
C
C	Now call subroutine to do all the work
C
	call allwork(obji,nx,ny,N,skyi,redi,darkf,maskf,
     1              flatf,scr,ssky,starco)
	call write3D(redi,nx,ny,N,rlist,red,scr,ierr)
	return
	end

	subroutine allwork(odata,nx,ny,nz,sdata,rdata,dark,mask,flat,
     1             scr,zky,starco)

	real odata(nx,ny,nz),dark(nx,ny),mask(nx,ny),flat(nx,ny)
	real sdata(nx,ny,nz),rdata(nx,ny,nz),scr(nx,ny),zky(nx,ny)
	real starco
	integer nx,ny,nz,sa1,sa2
	character*128 string

C
C	First dark-subtract everything
C
	do k=1,nz
	   do i=1,nx
	      do j=1,ny
	         odata(i,j,k)=odata(i,j,k)-dark(i,j)
	 	 sdata(i,j,k)=sdata(i,j,k)-dark(i,j)
	      enddo
	   enddo
	enddo
C
C	Now the big reduce-loop
C
	if (nz.eq.1) then
	   sum=0.
	   do i=1,nx
	      do j=1,ny
	         rdata(i,j,1)=(odata(i,j,1)-sdata(i,j,1))/flat(i,j)
	         if (mask(i,j).gt.0.5) then
	            sum=sum+rdata(i,j,1)
	            np=np+1
		 end if
	      enddo
	   enddo
	   sum=sum/np
	   do i=1,nx
	      do j=1,ny
	         if (mask(i,j).le.0.5) then
	            rdata(i,j,1)=sum
	         end if
	      enddo
	   enddo
	else
	   do k=1,nz
C
C	first get rid of stars in sky-frames
C
	      if (k.eq.1) then
	         sa1=2
	         sa2=3
	      else
	         if (k.eq.nz) then
		    if (nz.eq.2) then
		       sa1=nz-1
		    else
		       sa1=nz-2
		    end if
	            sa2=nz-1
	         else
	            sa1=k-1
	            sa2=k+1
	         end if
	      end if
	      sum=0.
	      np=0
	      do i=1,nx
	         do j=1,ny
		    h=sdata(i,j,sa1)+sdata(i,j,sa2)
	            if ((h.gt.0.).and.(mask(i,j).gt.0.5)) then
		       scr(i,j)=sdata(i,j,k)/h
		       sum=sum+scr(i,j)
		       np=np+1
		    else
		       scr(i,j)=0.
	            end if
	         enddo
	      enddo
	      sum=(sum/np)
	      thr=sum*(1.+starco)
	      do i=1,nx
	         do j=1,ny
	            if (mask(i,j).gt.0.5) then
		       if (scr(i,j).gt.thr) then
		          zky(i,j)=sum*(sdata(i,j,sa1)+sdata(i,j,sa2))
		        else
			   zky(i,j)=sdata(i,j,k)
		        end if
		     else
		        zky(i,j)=0.
		     end if
		  enddo
	       enddo
C
C	now sky-subtract and flat-field
C
	       sum=0.
	       np=0
	       do i=1,nx
		  do j=1,ny
		     if ((mask(i,j).gt.0.5).and.(flat(i,j).gt.0.)) then
		       rdata(i,j,k)=(odata(i,j,k)-zky(i,j))/flat(i,j)
	                sum=sum+rdata(i,j,k)
			np=np+1
		     end if
		  enddo
	       enddo
	       sum=sum/np
	       do i=1,nx
		  do j=1,ny
		     if (mask(i,j).le.0.5) then
		        rdata(i,j,k)=sum
		     end if
		  enddo
	       enddo
	   enddo	
	end if
	return
	end
	
	subroutine write3D(redi,nx,ny,N,rlist,red,zred,ierr)
	real redi(nx,ny,N),zred(nx,ny)
	character*128 rlist(100),rlis
	character*60 red(100),obj
	integer nx,ny,N

	do k=1,N
	   do i=1,nx
	      do j=1,ny
	         zred(i,j)=redi(i,j,k)
	      enddo
	   enddo
	   rlis=rlist(k)
	   obj=red(k)
	   call gimwrit(rlis,nx,ny,zred,obj,ierr)
	enddo
	return
	end
