	subroutine dstr

	call destri

	return
	end

	subroutine destri
C-----------------------------------------------------------------------------
C
C	program to destripe data. Program gets rid of 
C	horizontal odd-even effects without loss of resolution
C	parameter max sets maximum to correction.
C
C-----------------------------------------------------------------------------

	Parameter (MAXNPIX=128*128*20,MAXPIX=128*128)

	Integer Nx,Ny,unit
	Real*4 obji(MAXNPIX),redi(MAXNPIX)
	Real*4 maskf(MAXPIX),scr(MAXPIX),ssky(MAXPIX)
	Real*4 scr(MAXPIX),maxcor
	Character*10 Ans
	Character*128 maskfile
	Character*128 objlist,redlist
	Character*128 olist(100),string
	Character*128 rlist(100)
	Character*60 obj(100),objmask
	Character*60 red(100)

	call gproms('objlist',' ',' ',objlist,ierr)
	call gproms('redlist',' ',' ',redlist,ierr)
	call gproms('maskfile',' ',' ',maskfile,ierr)
	call gpromr('maxcor',0.03,' ',maxcor,ierr)

C	
C	first unravel the list of input and reduced files
C
	L=Len(objlist)
	ipos=1
10	if (objlist(ipos:ipos).eq.'@') then	
	   objlist(1:(128-ipos))=objlist((ipos+1):128)
	   call unravel(objlist,olist,N)
	else
	   if (objlist(ipos:ipos).eq.' ') then
	      ipos=ipos+1
	      if (ipos.le.L) goto 10
	   else
	      olist(1)=objlist
	      N=1
	   end if
	end if
210	if (redlist(ipos:ipos).eq.'@') then	
	   redlist(1:(128-ipos))=redlist((ipos+1):128)
	   call unravel(redlist,rlist,N2)
	else
	   if (redlist(ipos:ipos).eq.' ') then
	      ipos=ipos+1
	      if (ipos.le.L) goto 210
	   else
	      rlist(1)=redlist
	      N2=1
	   end if
	end if
	if (N2.ne.N) then
	   write (string,'('' obj and reduced list unequal length'')')
	   call gwrits(string,2)
	   return
	end if

	unit=11
	do i=1,N
	   call gimopen(unit,olist(i),ierr)
	   if (ierr.ne.0) then
	    write (string,'('' DSTRIP: Error opening '',a)') olist(i)
	    call gwrits(string,2)
	    return
	   end if
	   call gimhead(unit,obj(i),nx,ny,ierr)
	   if (ierr.ne.0) then
	    write (string,'('' DSTRIP: Error opening header of'',a)') olist(i)
	    call gwrits(string,2)
	   end if
	   unit=unit+1
	end do
	call read3d(11,nx,ny,N,obji,ierr)

	call gimopen(62,maskfile,ierr)
	if (ierr.ne.0) then
	   write (string,'('' DSTRIP: Error opening '',a)') maskfile
	   call gwrits(string,2)
	   return
	end if
	call gimhead(62,objmask,nx,ny,ierr)
	if (ierr.ne.0) then
	   write (string,'('' DSTRIP: Error opening header of'',a)') maskfile
	   call gwrits(string,2)
	end if
	call readin(62,nx,ny,maskf,ierr)
C
C	Now call subroutine to do all the work
C
	call alldstr(obji,nx,ny,N,redi,maskf,scr,ssky,maxcor)
	call write3D(redi,nx,ny,N,rlist,red,scr,ierr)
	return
	end

	subroutine alldstr(odata,nx,ny,nz,rdata,mask,
     1             scr,zky,maxcor)

	real odata(nx,ny,nz),mask(nx,ny)
	real rdata(nx,ny,nz),scr(nx,ny),zky(nx,ny)
	real maxcor,sum(512),list(200)
	integer nx,ny,nz,sa1,sa2
	character*128 string

	do k=1,nz
C
C	first calculate image where stripes have been averaged
C	across odd and even columns
C
	   do j=1,ny
	      do i=1,nx
	         if ((i-1).le.0) then
	            if (mask(i+1,j).gt.0.5) then
C
C	right neighbour usable
C
	               scr(i,j)=(odata(i,j,k)+odata(i+1,j,k))/2.
		    else
C
C	none of the neighbours useful
C
		       scr(i,j)=odata(i,j,k)
		    end if
		 else
	            if (mask(i-1,j).le.0.5) then
	               if ((i+1).le.nx) then
			  if (mask(i+1,j).gt.0.5) then		
C
C	right neighbour usable
C
	                  scr(i,j)=(odata(i,j,k)+odata(i+1,j,k))/2.
		          else
			     scr(i,j)=odata(i,j,k)
		          end if
		       else
C
C	none of the neighbours useful
C
			     scr(i,j)=odata(i,j,k)
		       end if
		    else
	               if ((i+1).le.nx) then
			  if (mask(i+1,j).gt.0.5) then		
C
C	left + right neighbour usable
C
	                  scr(i,j)=(odata(i,j,k)+odata(i+1,j,k)/2.
     1                            +odata(i-1,j,k)/2.)/2.
		          else
C
C	left neighbour usable
C
			     scr(i,j)=(odata(i,j,k)+odata(i-1,j,k))/2.
		          end if
		       else
C
C	left neighbour usable
C
			     scr(i,j)=(odata(i,j,k)+odata(i-1,j,k))/2.
		       end if
		    end if
		 end if
	      end do
	   end do
	   maxcor=abs(maxcor)
	   s=0
	   nns=0
	   do i=1,nx
	      sum(i)=0.
	      np=0
	      do j=1,ny
		 scr(i,j)=odata(i,j,k)-scr(i,j)
		 if (scr(i,j).gt.maxcor) then
		    scr(i,j)=maxcor
	         else
		    if (scr(i,j).lt.(-maxcor)) then
		       scr(i,j)=-maxcor
		    end if
		 end if
	         if (mask(i,j).gt.0.5) then
	            list(np+1)=scr(i,j)
		    np=np+1
		 end if
	      enddo
C
C	take median in stead of average
C
	      if (np.eq.0) then
		 sum(i)=0.
	      else
	         do nt1=1,np-1
	            do nt2=nt1+1,np
		       if (list(nt1).lt.list(nt2)) then
		          hulp=list(nt1)
		          list(nt1)=list(nt2)
		          list(nt2)=hulp
		       end if
		    enddo
	         enddo
	         if (2*(np/2).eq.np) then
		    sum(i)=list(np/2)
		 else
		    sum(i)=(list(np/2)+list(np/2+1))/2.
		 end if
	      end if
	      do j=1,ny
	         if (mask(i,j).gt.0.5) then
		    rdata(i,j,k)=odata(i,j,k)-sum(i)
		    s=s+rdata(i,j,k)
		    nns=nns+1
	         end if
	      enddo
	   enddo
	   s=s/nns
	   do i=1,nx
	      do j=1,ny
		 if (mask(i,j).le.0.5) then
		    rdata(i,j,k)=s
		 end if
	      enddo
	   enddo
	enddo
	return
	end
