	subroutine fixupc

	call fixup

	return
	end

	subroutine fixup
C-----------------------------------------------------------------------------
C
C	program tries to make the background of IR frames flatter,
C	by adding a dark-difference, obtained by subtracting 2 sky-frames
C	maximum 8 input sky-frames allowed
C
C-----------------------------------------------------------------------------

	Parameter (MAXNPIX=64*64*10,MAXPIX=64*64,MAXLPIX=64*64*50)

	Integer Nx,Ny,unit
	Real*4 obji(MAXNPIX),skyi(MAXNPIX),ddif(MAXLPIX)
	Real*4 maskf(MAXPIX),redi(MAXNPIX),flatf(MAXPIX)
	Real*4 flato(MAXPIX)
	Real*4 scr(MAXPIX),ssky(MAXPIX),starco,dcon,reloe
	Character*10 Ans
	Character*128 outname,maskfile
	Character*128 objlist,skylist,redlist
	Character*128 olist(20),string,flatfile
	Character*128 slist(20),rlist(20)
	Character*60 obj(20),objdark,objmask,objflat
	Character*60 sky(20),red(20)

	call gproms('objlist',' ',' ',objlist,ierr)
	call gproms('skylist',' ',' ',skylist,ierr)
	call gproms('redlist',' ',' ',redlist,ierr)
	call gproms('maskfile',' ',' ',maskfile,ierr)
	call gproms('flatfile',' ',' ',flatfile,ierr)
	call gpromr('starcutoff',0.03,' ',starco,ierr)
	call gpromr('difference',0.,' ',dcon,ierr)
	call gpromr('reloe',1.,' ',reloe,ierr)
	call gpromr('pickup',0.,' ',pickup,ierr)

C	
C	first unravel the list of input,output and reduced files
C
	L=Len(objlist)
	ipos=1
10	if (objlist(ipos:ipos).eq.'@') then	
	   objlist(1:(128-ipos))=objlist((ipos+1):128)
	   call unravel(objlist,olist,N)
	else
	   if (objlist(ipos:ipos).eq.' ') then
	      ipos=ipos+1
	      if (ipos.le.L) goto 10
	   else
	      olist(1)=objlist
	      N=1
	   end if
	end if
110	if (skylist(ipos:ipos).eq.'@') then	
	    skylist(1:(128-ipos))=skylist((ipos+1):128)
	   call unravel(skylist,slist,N1)
	else
	   if (skylist(ipos:ipos).eq.' ') then
	      ipos=ipos+1
	      if (ipos.le.L) goto 110
	   else
	      slist(1)=skylist
	      N1=1
	   end if
	end if
	if (N1.ne.N) then
	   write (string,'('' obj and sky list unequal length'')')
	   call gwrits(string,2)
	   return
	end if
210	if (redlist(ipos:ipos).eq.'@') then	
	   redlist(1:(128-ipos))=redlist((ipos+1):128)
	   call unravel(redlist,rlist,N2)
	else
	   if (redlist(ipos:ipos).eq.' ') then
	      ipos=ipos+1
	      if (ipos.le.L) goto 210
	   else
	      rlist(1)=redlist
	      N2=1
	   end if
	end if
	if (N2.ne.N) then
	   write (string,'('' obj and reduced list unequal length'')')
	   call gwrits(string,2)
	   return
	end if

	unit=11
	do i=1,N
	   call gimopen(unit,olist(i),ierr)
	   if (ierr.ne.0) then
	    write (string,'('' FIXUP: Error opening '',a)') olist(i)
	    call gwrits(string,2)
	    return
	   end if
	   call gimhead(unit,obj(i),nx,ny,ierr)
	   if (ierr.ne.0) then
	    write (string,'('' FIXUP: Error opening header of'',a)') olist(i)
	    call gwrits(string,2)
	   end if
	   unit=unit+1
	end do
	call read3d(11,nx,ny,N,obji,ierr)
	nu=unit
	do i=1,N
	   call gimopen(unit,slist(i),ierr)
	   if (ierr.ne.0) then
	    write (string,'('' FIXUP: Error opening '',a)') slist(i)
	    call gwrits(string,2)
	    return
	   end if
	   call gimhead(unit,sky(i),nx,ny,ierr)
	   if (ierr.ne.0) then
	    write (string,'('' FIXUP: Error opening header of'',a)') slist(i)
	    call gwrits(string,2)
	   end if
	   unit=unit+1
	end do
	call read3d(nu,nx,ny,N,skyi,ierr)

	call gimopen(62,maskfile,ierr)
	if (ierr.ne.0) then
	   write (string,'('' FIXUP: Error opening '',a)') maskfile
	   call gwrits(string,2)
	   return
	end if
	call gimhead(62,objmask,nx,ny,ierr)
	if (ierr.ne.0) then
	   write (string,'('' FIXUP: Error opening header of'',a)') maskfile
	   call gwrits(string,2)
	end if
	call readin(62,nx,ny,maskf,ierr)
	call gimopen(63,flatfile,ierr)
	if (ierr.ne.0) then
	   write (string,'('' FIXUP: Error opening '',a)') flatfile(1:80)
	   call gwrits(string,2)
	   return
	end if
	call gimhead(63,objflat,nx,ny,ierr)
	if (ierr.ne.0) then
	   write (string,'('' FIXUP: Error opening header of'',a)') 
     1            flatfile(1:80)
	   call gwrits(string,2)
	end if
	call readin(63,nx,ny,flatf,ierr)
	ND=(N*(N-1)/2)+1
C
C	Now call subroutine to do all the work
C
	call fixwork(obji,nx,ny,N,ND,skyi,redi,ddif,maskf,
     1              scr,ssky,starco,dcon,flatf,reloe,pickup,flato)
	call write3D(redi,nx,ny,N,rlist,red,scr,ierr)
	return
	end

	subroutine fixwork(odata,nx,ny,nz,NDP1,sdata,rdata,ddif,mask,
     1             scr,zky,starco,dcon,flat,reloe,pickup,flato)

	real odata(nx,ny,nz),ddif(nx,ny,NDP1),mask(nx,ny)
	real sdata(nx,ny,nz),rdata(nx,ny,nz),scr(nx,ny),zky(nx,ny)
	real flat(nx,ny),reloe,pickup,flato(nx,ny)
	real starco,dcon,fitval(100),h1val(100),h2val(100)
        real h3val(100)
	real xv(5000),yv(5000),zv(5000),sv(5000),fit(3)
	integer nx,ny,nz,ND,sa1,sa2,mx(100),my(100),NDP1
	character*128 string

	ND=NDP1-1
C
C	first destripe sky-files
C
	maxcor=100.
	call alldstr(sdata,nx,ny,nz,rdata,mask,scr,zky,maxcor)
C	
C	and destripe the flatfield!
C
C	call alldstr(flat,nx,ny,1,flato,mask,scr,zky,maxcor)
C	write (string,'(2F)') flat(27,27),flato(27,27)
C	call gwrits (string,2)
C
C	first determine dark-difference-files
C
	ndif=1
	do k=1,nz-1
	   do l=k+1,nz
	      do i=1,nx
	         do j=1,ny
		    ddif(i,j,ndif)=(rdata(i,j,k)-rdata(i,j,l))/
     1                             flat(i,j)
		 enddo
	      enddo
	      mx(ndif)=k
	      my(ndif)=l
	      ndif=ndif+1
	   enddo
	enddo
C
C	now add and subtract all ddif files from the object frames,
C	determine flatness-criteria, and choose best fit
C
	do k=1,nz
	   do l=1,ND
	      do i=1,nx
		 do j=1,ny
		    scr(i,j)=odata(i,j,k)+ddif(i,j,l)
		 enddo
	      enddo
	      fitval(l)=crit(scr,mask,nx,ny,dcon,reloe,pickup,h1,h2,h3)
	      h1val(l)=h1
	      h2val(l)=h2
	      h3val(l)=h3
	   enddo
	   do l=1,ND
	      do i=1,nx
		 do j=1,ny
		    scr(i,j)=odata(i,j,k)-ddif(i,j,l)
		 enddo
	      enddo
	      fitval(l+ND)=crit(scr,mask,nx,ny,dcon,reloe,pickup,h1,h2,h3)
	      h1val(l+ND)=h1
	      h2val(l+ND)=h2
	      h3val(l+ND)=h3
	   enddo
	   do i=1,nx
	      do j=1,ny
		 scr(i,j)=odata(i,j,k)
	      enddo
	   enddo
	   fitval(2*ND+1)=crit(scr,mask,nx,ny,dcon,reloe,pickup,h1,h2,h3)
	   h1val(2*ND+1)=h1
	   h2val(2*ND+1)=h2
	   h3val(2*ND+1)=h3
	   xmin=1.E9
	   do l=1,2*ND+1
	      if (abs(fitval(l)).lt.xmin) then
	         minpos=l
	         xmin=abs(fitval(l))
	      end if
	   enddo
	   write (string,'('' xmin,pos '',F9.3,I4,3F9.3)') xmin,minpos,
     1            h1val(minpos),h2val(minpos),h3val(minpos)
	   call gwrits(string,2)
C
C	now remove stars in the best ddif
C	compare each pixel with all pixels between 3 and 5 pixels 
C	away in x and in y; if abs. difference larger than starco,
C	replace by the average.
C
	   if (minpos.ne.(2*ND+1)) then
	   nt=1
	   do i=1,nx
	      do j=1,ny
	         if (mask(i,j).gt.0.5) then
		    xv(nt)=i
	            yv(nt)=j
	            if (minpos.gt.ND) then
		       zv(nt)=-ddif(i,j,minpos-ND)
		    else
		       zv(nt)=ddif(i,j,minpos)
		    end if
		    sv(nt)=1./(1.+abs(i-(nx/2.)))+1./(1.+abs(j-(ny/2.)))
		    nt=nt+1
		 end if
	      enddo
	   enddo
C 
C	now call planefit
C
	   nt=nt-1
	   ndecl=5000
	   call planefit(xv,yv,zv,sv,nt,ndecl,fit,ierr)
	   if (ierr.ne.0) then
	      write (string,'(''planefit did not work '',2I)') k,ierr
	      call gwrits(string,2)
	      goto 444
	   else
	      sum=0.
	      sum2=0.
	      tsv=0.
	      do i=1,nt
		 term=sv(i)*(zv(i)-fit(1)-fit(2)*xv(i)-fit(3)*yv(i))
	         tsv=tsv+sv(i)*sv(i)
	         sum=sum+term
	         sum2=sum2+term*term
	      enddo
	      sum2=sqrt(sum2/tsv)
	      do i=1,nx
		 do j=1,ny
		    if (mask(i,j).gt.0.5) then
		       if (minpos.gt.ND) then
			  yval=-ddif(i,j,minpos-ND)
		       else
			  yval=ddif(i,j,minpos)
		       end if
		       val=1./(1.+abs(i-(nx/2.)))+1./(1.+abs(j-(ny/2.)))
		       resid=val*(yval-fit(1)-i*fit(2)-j*fit(3))
		       if (abs(resid).gt.(3.*sum2*val)) then
		          scr(i,j)=fit(1)+i*fit(2)+j*fit(3)
		       else
			  scr(i,j)=yval
		       end if
		    else
		       scr(i,j)=0.
		    end if
		 enddo
	      enddo
	   end if
	   do i=1,nx
	      do j=1,ny
		    rdata(i,j,k)=odata(i,j,k)+scr(i,j)
	      enddo
	   enddo
	   else
444	   do i=1,nx
	      do j=1,ny
		 rdata(i,j,k)=odata(i,j,k)
	      enddo
	   enddo
	   end if
	enddo   
	return
	end

	function crit(scr,mask,nx,ny,dcon,reloe,pickup,h1,h2,h3)
C
C	this function determines how well one corner of the
C	frame reassembles the other corner (provided for a 
C	constant dcon).
C
	real scr(nx,ny),mask(nx,ny)
	integer nx,ny
	real dcon,reloe,h1,h2,h3,pickup
	real ar(100),br(100)
	character*128 string

	sum1o=0.
	np1o=0
	sum1e=0.
	np1e=0
	do i=35,44
	   do j=41,50
	      if (i.eq.2*(i/2)) then
	         if (mask(i,j).gt.0.5) then
		    np1e=np1e+1
		    ar(np1e)=scr(i,j)
	         end if 
	      else
		 if (mask(i,j).gt.0.5) then
		    np1o=np1o+1
		    br(np1o)=scr(i,j)
		 end if
	      end if
	   enddo
	enddo
	if ((np1o+np1e).eq.0) then
	   write (string,'('' crit: no legal values '')') 
	   call gwrits(string,2)
	   crit=-1E10
	   return
	else
C	sort ar and br
	   do i=1,np1e
	      do j=1+1,np1e
		 if (ar(i).lt.ar(j)) then
		    h=ar(i)
		    ar(i)=ar(j)
		    ar(j)=h
		 end if
	      enddo
	   enddo
	   sum1e=ar(np1e/2)
	   do i=1,np1o
	      do j=1+1,np1o
		 if (br(i).lt.br(j)) then
		    h=br(i)
		    br(i)=br(j)
		    br(j)=h
		 end if
	      enddo
	   enddo
	   sum1o=br(np1o/2)
	   ad1=(sum1o+sum1e)/2.
	   aoe1=abs(sum1o-sum1e)
	end if
	sum1o=0.
	np1o=0
	sum1e=0.
	np1e=0
	do i=11,20
	   do j=6,15
	      if (i.eq.2*(i/2)) then
	         if (mask(i,j).gt.0.5) then
		    np1e=np1e+1
		    ar(np1e)=scr(i,j)
	         end if 
	      else
		 if (mask(i,j).gt.0.5) then
		    np1o=np1o+1
		    br(np1o)=scr(i,j)
		 end if
	      end if
	   enddo
	enddo
	if ((np1o+np1e).eq.0) then
	   write (string,'('' crit: no legal values '')') 
	   call gwrits(string,2)
	   crit=-1E10
	   return
	else
	   do i=1,np1e
	      do j=1+1,np1e
		 if (ar(i).lt.ar(j)) then
		    h=ar(i)
		    ar(i)=ar(j)
		    ar(j)=h
		 end if
	      enddo
	   enddo
	   sum1e=ar(np1e/2)
	   do i=1,np1o
	      do j=1+1,np1o
		 if (br(i).lt.br(j)) then
		    h=br(i)
		    br(i)=br(j)
		    br(j)=h
		 end if
	      enddo
	   enddo
	   sum1o=br(np1o/2)
	   ad2=(sum1o+sum1e)/2.
	   aoe2=abs(sum1o-sum1e)
	end if
	sum1o=0.
	np1o=0
	sum1e=0.
	np1e=0
	do i=19,20
	   do j=1,58
	      if (mask(i,j).gt.0.5) then
		   sum1e=sum1e+scr(i,j)
		   np1e=np1e+1
	      end if 
	   enddo
	enddo
	do i=17,18
	   do j=1,58
	      if (mask(i,j).gt.0.5) then
		   sum1o=sum1o+scr(i,j)
		   np1o=np1o+1
	      end if 
	   enddo
	enddo
	do i=21,22
	   do j=1,58
	      if (mask(i,j).gt.0.5) then
		   sum1o=sum1o+scr(i,j)
		   np1o=np1o+1
	      end if 
	   enddo
	enddo
	if ((np1o+np1e).eq.0) then
	   write (string,'('' crit: no legal values '')') 
	   call gwrits(string,2)
	   crit=-1E10
	   return
	else
	   sum1e=sum1e/np1e
	   sum1o=sum1o/np1o
	end if
C
C	now the final crit-value
C
	h1=0.8*abs(ad1-ad2-dcon)
	h2=2.5*reloe*(aoe1+aoe2)
	h3=10.*abs(sum1e-sum1o)*pickup
	crit=h1+h2+h3
	return
	end

	subroutine planefit(x,y,z,sig,n,ndecl,fit,ierr)
C
C	fits a plane to a dataset z_i = f(x_i,y_i)
C
	real x(ndecl),y(ndecl),z(ndecl),fit(3),sig(ndecl)
	integer n,ierr

	s=0.
	sy=0.
	sx=0.
	sz=0.
	sxy=0.
	sxz=0.
	syz=0.
	sxx=0.
	syy=0.
	szz=0.
	do i=1,n
	   if (sig(i).eq.0.) then
	      ierr=1
 	      return
	   else
	      term=1./sig(i)
	      term=term*term
	      s=s+term
	      sx=sx+x(i)*term
	      sy=sy+y(i)*term
	      sz=sz+z(i)*term
	      sxy=sxy+x(i)*y(i)*term
	      sxz=sxz+x(i)*z(i)*term
	      syz=syz+y(i)*z(i)*term
	      sxx=sxx+x(i)*x(i)*term
	      syy=syy+y(i)*y(i)*term
	      szz=szz+z(i)*z(i)*term
	   end if
	enddo
	den=(syy-sy*sy/s)-(sxy-sx*sy/s)**2./(sxx-sx*sx/s)
	if (den.eq.0) then
	   ierr=1
	   return
	else
	   dnom=(syz-sy*sz/s)-(sxy-sx*sy/s)*(sxz-sx*sz/s)/(sxx-sx*sx/s)
	   c=dnom/den
	   den=sxx-sx*sx/s
	   b=((sxz-sx*sz/s)-c*(sxy-sx*sy/s))/den
	   a=(sz-b*sx-c*sy)/s
	   fit(1)=a
	   fit(2)=b
	   fit(3)=c
	end if
	ierr=0
	return
	end
	      
