      subroutine gimopen(unit,filename,ierr)

      integer unit,ierr
      character*(*) filename

      common /gimpar/
     &     im(100), naxis(100), dtype (100), nrows(100), ncols(100),
     &     name(100)

      integer	im, axlen(7), naxis, dtype
      character*80	name


c     subroutine opens fits file named name
c     subroutine uses STSDAS/IRAF interface routine for use within IRAF
c     author marijn franx


      call uimopn( filename, 1, im(unit), ierr )

      if (ierr.ne.0) return


      nrows (unit)=0.
      ncols (unit)=0.
      name  (unit)=filename

      return
      end

      subroutine gimhead(unit,object,ncol,nrow,ierr)

      integer	unit,ncol,nrow
      character*(*)	object

      common /gimpar/
     &     im(100), naxis(100), dtype (100), nrows(100), ncols(100),
     &     name(100)
      integer	im, axlen(7), naxis, dtype
      character*80	name

      character*80	keyword, header, filename
      character*128	string

c     subroutine fetches header of iraf file
c     on logical unit unit
c     subroutine uses STSDAS/IRAF interface routine for use within IRAF
c     author marijn franx

      call uimgid( im(unit), dtype, naxis(unit), axlen, ierr)

      if (ierr.ne.0) return

      if (naxis(unit).gt.2) then
         write(string,'('' NAXIS > 2 Higher dimensions ignored '')')
         call gwrits(string,2)
      end if

      ncols(unit)=axlen(1)
      nrows(unit)=axlen(2)

      keyword='title'
      call uhdgst( im(unit), keyword, header, ierr)
      if (ierr.ne.0) return
      object=header

      ncol=ncols(unit)
      nrow=nrows(unit)

      filename=name(unit)
      do 30 i=80,2,-1
         if (filename(i:i).eq.'/') then
            filename=filename(i+1:80)
            goto 110
         end if
 30   continue
 110  do 40 i=80,1,-1
         if (filename(i:i).ne.' ') goto 120
 40   continue
 120  iend=i

      l=lenc(object)
      if (l.gt.20) l=20
c     write(string,'(1x,a,''  ['',i4,'','',i4,''] :'',a)')
c     &    filename(1:iend),ncol,nrow,object(1:l)
c     call gwrits(string,1)

      return
      end

      subroutine gimrow (unit,l,nbin,data,ierr)

      integer unit,l,nbin
      real	data(nbin)

      common /gimpar/
     &     im(100), naxis(100), dtype (100), nrows(100), ncols(100),
     &     name(100)
      integer	im, axlen(7), naxis, dtype
      character*80	name
      character*128	string

c     reads row from iraf formatted file
c     subroutine uses STSDAS/IRAF interface routine for use within IRAF
c     author marijn franx


      if (l.gt.nrows(unit)) then
         write(string,'('' RROW: irow too large '')')
         call gwrits(string,2)
         return
      end if

      call uigl2r( im(unit), l, data, ierr)

      if (ierr.ne.0) then
         write(string,'('' GIMROW: error reading '',i6)') ierr
         call gwrits(string,2)
         return
      end if

      return
      end

      subroutine gimread (unit,nx,ny,data,ierr)

      integer unit,nx,ny
      real	data(nx,ny)

      common /gimpar/
     &     im(100), naxis(100), dtype (100), nrows(100), ncols(100),
     &     name(100)
      integer	im, axlen(7), naxis, dtype
      character*80	name
      character*128	string

c     reads complete file from iraf formatted file
c     subroutine uses STSDAS/IRAF interface routine for use within IRAF
c     author marijn franx


      call uigs2r( im(unit), 1, nx, 1, ny, data, ierr)

      if (ierr.ne.0) then
         write(string,'('' GIMREAD: error reading '',i6)') ierr
         call gwrits(string,2)
         return
      end if

      return
      end

      subroutine gimclose(unit,ierr)

      integer unit

      common /gimpar/
     &     im(100), naxis(100), dtype (100), nrows(100), ncols(100),
     &     name(100)
      integer	im, axlen(7), naxis, dtype
      character*80	name
      character*128	string

c     reads complete file from iraf formatted file
c     subroutine uses STSDAS/IRAF interface routine for use within IRAF
c     author marijn franx


      call uimclo( im(unit), ierr)

      if (ierr.ne.0) then
         write(string,'('' GIMCLOSE: ERROR: closing file'')')
         call gwrits(string,2)
         return
      end if

      return
      end
