      subroutine inppro(image,output,galaxy,deletion,intable,outtable,
     &     ngal,ellipsefit,ierr)

c     this subroutine reads in the input values by means of
c     prompting. Used for the IRAF version

      include 'param.inc'

      character*128	image,output,galaxy,deletion,intable,outtable
      integer		ngal
      character*128	string
      logical ellipsefit

c     io via prompting

      call startsub('INPPRO')

      call gproms('image'   ,    ' ',' ',image,ierr)
      if (ierr.ne.0) return
      call gproms('output'  ,    ' ',' ',output,ierr)
      if (ierr.ne.0) return
      call gproms('galaxy'  , '.gal',' ',galaxy,ierr)
      if (ierr.ne.0) return
      call gpromi('ngal'    ,      1,' ',ngal,ierr)
      if (ierr.ne.0) return
      call gproms('deletion','.del .star .cosmic',' ',deletion,ierr)
      if (ierr.ne.0) return
      call gproms('intable' ,    ' ',' ',intable,ierr)
      if (ierr.ne.0) return
      call gproms('outtable', '.prf',' ',outtable,ierr)
      if (ierr.ne.0) return
      call gpromr('rmin'    ,    0.3,' ',rmin,ierr)
      if (ierr.ne.0) return
      call gpromr('rmax'    ,    0.0,' ',rmax,ierr)
      if (ierr.ne.0) return
      call gpromr('radfac'  ,    1.1,' ',radfac,ierr)
      if (ierr.ne.0) return
      call gproml('linear'  ,.false.,' ',linear,ierr)
      if (ierr.ne.0) return
      if (ellipsefit) then
         call gpromr('rshap'   ,    0.0,' ',rshap,ierr)
         if (ierr.ne.0) return
         call gpromr('rcen'    ,    0.0,' ',rcen,ierr)
         if (ierr.ne.0) return
         call gpromr('errshap' ,    0.5,' ',errshap,ierr)
         if (ierr.ne.0) return
         call gpromr('errcen'  ,    0.1,' ',errcen,ierr)
         if (ierr.ne.0) return
         call gpromi('iter1'   ,      3,' ',iter1,ierr)
         if (ierr.ne.0) return
         call gpromi('iter2'   ,      5,' ',iter2,ierr)
         if (ierr.ne.0) return
      end if
      call gpromi('hmax'    ,      6,' ',hmax,ierr)
      if (ierr.ne.0) return
      if (ellipsefit) then
         call gpromr('dposmax' ,    0.0,' ',dposmax,ierr)
         if (ierr.ne.0) return
         call gpromr('dellmax' ,    0.1,' ',dellmax,ierr)
         if (ierr.ne.0) return
         call gpromr('dangmax' ,    0.1,' ',dangmax,ierr)
         if (ierr.ne.0) return
      end if
      call gpromr('r1'      ,    20.,' ',r1,ierr)
      if (ierr.ne.0) return
      call gpromr('r2'      ,    0.0,' ',r2,ierr)
      if (ierr.ne.0) return
      call gpromi('nsammax' ,    66 ,' ',nsammax,ierr)
      if (ierr.ne.0) return
      call gpromr('fracmin' ,    0.4,' ',fracmin,ierr)
      if (ierr.ne.0) return
      call gpromi('debug'   ,      0,' ',debug,ierr)
      if (ierr.ne.0) return
      if (ellipsefit) then
         call  gproml('extend' , .true.,' ',extend,ierr)
         if (ierr.ne.0) return
      end if
      call gproml('outfill' , .true.,' ',outfill,ierr)
      if (ierr.ne.0) return
      call gpromi('npolres' ,      4,' ',npolres,ierr)
      if (ierr.ne.0) return

      if (debug.ge.2) call
     &     prio(image,output,galaxy,deletion,intable,outtable,
     &     ngal)

      ierr=0
      return
      end

      subroutine prio(image,output,galaxy,deletion,intable,outtable,
     &     ngal)

      include 'param.inc'

      character*128	image,output,galaxy,deletion,intable,outtable
      integer		ngal
      character*128	string

      write(string,'('' image     ='',a70)') image
      call gwrits(string,1)
      write(string,'('' output    ='',a70)') output
      call gwrits(string,1)
      write(string,'('' galaxy    ='',a70)') galaxy
      call gwrits(string,1)
      write(string,'('' deletion  ='',a70)') deletion
      call gwrits(string,1)
      write(string,'('' intable   ='',a70)') intable
      call gwrits(string,1)
      write(string,'('' outtable  ='',a70)') outtable
      call gwrits(string,1)
      write(string,'('' Iter1     ='',i5)') iter1
      call gwrits(string,1)
      write(string,'('' Iter2     ='',i5)') iter2
      call gwrits(string,1)
      write(string,'('' Hmax      ='',i5)') hmax
      call gwrits(string,1)
      write(string,'('' Nsammax   ='',i5)') nsammax
      call gwrits(string,1)
      write(string,'('' debug     ='',i5)') debug
      call gwrits(string,1)
      write(string,'('' npolres   ='',i5)') npolres
      call gwrits(string,1)
      write(string,'('' rmin      ='',f10.4)') rmin
      call gwrits(string,1)
      write(string,'('' rmax      ='',f10.4)') rmax
      call gwrits(string,1)
      write(string,'('' radfac    ='',f10.4)') radfac
      call gwrits(string,1)
      write(string,'('' rshap     ='',f10.4)') rshap
      call gwrits(string,1)
      write(string,'('' rcen      ='',f10.4)') rcen
      call gwrits(string,1)
      write(string,'('' errshap   ='',f10.4)') errshap
      call gwrits(string,1)
      write(string,'('' errcen    ='',f10.4)') errcen
      call gwrits(string,1)
      write(string,'('' dposmax   ='',f10.4)') dposmax
      call gwrits(string,1)
      write(string,'('' dellmax   ='',f10.4)') dellmax
      call gwrits(string,1)
      write(string,'('' dangmax   ='',f10.4)') dangmax
      call gwrits(string,1)
      write(string,'('' r1        ='',f10.4)') r1
      call gwrits(string,1)
      write(string,'('' r2        ='',f10.4)') r2
      call gwrits(string,1)
      write(string,'('' fracmin   ='',f10.4)') fracmin
      call gwrits(string,1)
      write(string,'('' linear    ='',l5)') linear
      call gwrits(string,1)
      write(string,'('' extend    ='',l5)') extend
      call gwrits(string,1)
      write(string,'('' outfill   ='',l5)') outfill
      call gwrits(string,1)


      return
      end
