	subroutine intrp

	call interp

	return
	end

	subroutine interp
C-----------------------------------------------------------------------------
C
C	program to interpolate across bad data. Works like
C	fixpix, but this program has a mask-file as input.
C	It fits planes to the bad areas.
C
C-----------------------------------------------------------------------------

	Parameter (MAXNPIX=128*128*20,MAXPIX=256*256)

	Integer Nx,Ny,unit
	Real*4 obji(MAXNPIX)
	Real*4 maskf(MAXPIX),redi(MAXNPIX),omask(MAXPIX)
	Integer*4 scr(MAXPIX)
	Logical outmask
	Character*128 maskfile,outmfile
	Character*128 objlist,redlist
	Character*128 olist(100),string
	Character*128 rlist(100)
	Character*60 obj(100)
	Character*60 Objmask
	Character*60 red(100)

	call gproms('objlist',' ',' ',objlist,ierr)
	call gproms('redlist',' ',' ',redlist,ierr)
	call gproms('maskfile',' ',' ',maskfile,ierr)
	call gproml('outmask',.TRUE.,' ',outmask,ierr)
	call gproms('outmaskfile',' ',' ',outmfile,ierr)
C	
C	first unravel the list of input and output files
C
	L=Len(objlist)
	ipos=1
10	if (objlist(ipos:ipos).eq.'@') then	
	   objlist(1:(128-ipos))=objlist((ipos+1):128)
	   call unravel(objlist,olist,N)
	else
	   if (objlist(ipos:ipos).eq.' ') then
	      ipos=ipos+1
	      if (ipos.le.L) goto 10
	   else
	      olist(1)=objlist
	      N=1
	   end if
	end if
210	if (redlist(ipos:ipos).eq.'@') then	
	   redlist(1:(128-ipos))=redlist((ipos+1):128)
	   call unravel(redlist,rlist,N2)
	else
	   if (redlist(ipos:ipos).eq.' ') then
	      ipos=ipos+1
	      if (ipos.le.L) goto 210
	   else
	      rlist(1)=redlist
	      N2=1
	   end if
	end if
	if (N2.ne.N) then
	   write (string,'('' obj and reduced list unequal length'')')
	   call gwrits(string,2)
	   return
	end if

	unit=11
	do i=1,N
	   call gimopen(unit,olist(i),ierr)
	   if (ierr.ne.0) then
	    write (string,'('' INTERP: Error opening '',a)') olist(i)
	    call gwrits(string,2)
	    return
	   end if
	   call gimhead(unit,obj(i),nx,ny,ierr)
	   if (ierr.ne.0) then
	    write (string,'('' INTERP: Error opening header of'',a)') olist(i)
	    call gwrits(string,2)
	   end if
	   unit=unit+1
	end do
	call read3d(11,nx,ny,N,obji,ierr)

	call gimopen(62,maskfile,ierr)
	if (ierr.ne.0) then
	   write (string,'('' INTERP: Error opening '',a)') maskfile(1:80)
	   call gwrits(string,2)
	   return
	end if
	call gimhead(62,Objmask,nx,ny,ierr)
	if (ierr.ne.0) then
	   write (string,'('' INTERP: Error opening header of'',a)') 
     1            maskfile(1:80)
	   call gwrits(string,2)
	end if
	call readin(62,nx,ny,maskf,ierr)
C
C	Now call subroutine to do all the work
C
	call intwork(obji,nx,ny,N,redi,maskf,scr,omask)
	call write3D(redi,nx,ny,N,rlist,red,scr,ierr)
	if (outmask) then
	   call gimwrit(outmfile,nx,ny,omask,red(1),ierr)
	end if
	return
	end

	subroutine intwork(odata,nx,ny,nz,rdata,mask,scr,omask)

	real odata(nx,ny,nz),mask(nx,ny),omask(nx,ny)
	real rdata(nx,ny,nz)
	integer scr(nx,ny)
	integer nxl,nxh,nyl,nyh
	real xv(1000),yv(1000),zv(1000),sig(1000)
	integer nx,ny,nz
	real fit(3)
	integer ixl(100),ixh(100),iyl(100),iyh(100),ni
	character*128 string

C
C	first analyze the mask-file, and find the blotted areas
C	identify them as rectangles, fit a plane through the pixels
C	in that rectangle that are not blotted and in the 
C	border region of max. 2 pixels on each side
C
	do i=1,nx
	   do j=1,ny
	      omask(i,j)=mask(i,j)
	      mask(i,j)=1.-mask(i,j)
	   enddo
	enddo
	call findimage(nx,ny,mask,scr,0.5)
	do i=1,1000
	   ixl(i)=9999
	   ixh(i)=-999
	   iyl(i)=9999
	   iyh(i)=-999
	   np=0
	   do j=1,nx
	      do k=1,ny
		 if (scr(j,k).eq.i) then
		    if (j.lt.ixl(i)) ixl(i)=j
		    if (j.gt.ixh(i)) ixh(i)=j
		    if (k.lt.iyl(i)) iyl(i)=k
		    if (k.gt.iyh(i)) iyh(i)=k
		    np=np+1
		 end if
	      enddo
	   enddo
	   if (np.eq.0) goto 210
	enddo
	   
C
C	now the bad areas have been found - now interpolate
C
210	ni=i-1
C	write (string,'(''ni = '',I)') ni
C	call gwrits(string,2)
	do k=1,nz
	   do l=1,nx
	      do m=1,ny
	         rdata(l,m,k)=odata(l,m,k)
	      enddo
	   enddo
	   do i=2,ni
C	don't use the 1st area, because then you will interpolate all
C	the data
	      if (ixl(i).gt.2) then
		 nxl=ixl(i)-2
	      else
		 nxl=1
	      end if
	      if (ixh(i).lt.(nx-1)) then
		 nxh=ixh(i)+2
	      else
		 nxh=nx
	      end if
	      if (iyl(i).gt.2) then
		 nyl=iyl(i)-2
	      else
		 nyl=1
	      end if
	      if (iyh(i).lt.(ny-1)) then
		 nyh=iyh(i)+2
	      else
		 nyh=ny
	      end if
	      if (nxl.gt.nx) goto 444
	      if (nyl.gt.ny) goto 444
	      nt=0
	      do m=nxl,nxh
		 do l=nyl,nyh
		    if (mask(m,l).lt.0.5) then
		       nt=nt+1
		       xv(nt)=m
		       yv(nt)=l
		       zv(nt)=odata(m,l,k)
		       sig(nt)=1.
		    end if
		 enddo
	      enddo
	      ndecl=1000
	      call planefit(xv,yv,zv,sig,nt,ndecl,fit,ierr)
	      if (ierr.ne.0) then
	         write (string,'(''planefit did not work '',2I)') k,ierr
	         call gwrits(string,2)
		 goto 444
	      else
		 do l=nxl,nxh
		    do m=nyl,nyh
		       if (mask(l,m).gt.0.5) then
			  omask(l,m)=1.
			  rdata(l,m,k)=fit(1)+fit(2)*l+fit(3)*m
		       end if
		    enddo
		 enddo
	      end if
444	   enddo
	enddo
	return
	end

      subroutine findimage(nx,ny,pix,im,v)
      
      real	pix(nx,ny)
      integer im(nx,ny)
      
      parameter (MAXIM=24000)
      integer   x1(MAXIM),x2(MAXIM),y1(MAXIM),y2(MAXIM),num(MAXIM)
      integer	  im1(MAXIM),im2(MAXIM),newnum(MAXIM)
      logical   cr
      cr=.true.
      
      imlast=0
      do 10 iy=1,ny
         if ( (iy/(ny/20))*(ny/20).eq.iy) write(*,'(2i10)') iy,imlast
         do 11 ix=1,nx
            imx=-1
            imy=-1
            if (pix(ix,iy).gt.v) then
               if (iy.gt.1) then
                  if (pix(ix,iy-1).gt.v) then
                     imy=num(im(ix,iy-1))
                  else if (cr.and.ix.lt.nx.and.ix.gt.1) then
                     if ((pix(ix-1,iy-1).gt.v).and.
     $                    (pix(ix+1,iy-1).gt.v)) then
                        imy=num(im(ix-1,iy-1))
                        imy2=num(im(ix+1,iy-1))
                        if (imy.ne.imy2)
     &                       call substitute(nx,ny,im,MAXIM,
     $                       x1,x2,y1,y2,im1,im2,imy2,imy,num)
                     else if (pix(ix-1,iy-1).gt.v) then
                        imy=num(im(ix-1,iy-1))
                     else if (pix(ix+1,iy-1).gt.v) then
                        imy=num(im(ix+1,iy-1))
                     end if
                  end if
               end if
               
               if (ix.gt.1.) then
                  if (pix(ix-1,iy).gt.v) then
                     imx=num(im(ix-1,iy))
                  end if
               end if
               
               if (imy.ne.-1) then
                  if (imx.ne.-1) then
                     if (imy.ne.imx) call substitute
     &                    (nx,ny,im,MAXIM,x1,x2,y1,y2,
     $                    im1,im2,imx,imy,num)
                     imx=imy
                  else
                     imx=imy
                  end if
               end if
               if (imx.eq.-1) then
                  imlast=imlast+1
                  if (imlast.gt.MAXIM) then
                     write(*,'('' FINDIMAGE: too many images '')')
                     return
                  end if
                  imx=imlast
                  num(imlast)=imlast
                  im1(imlast)=imlast
                  im2(imlast)=imlast
               end if
               im(ix,iy)=imx
               if (x1(imx).gt.ix) x1(imx)=ix
               if (x2(imx).lt.ix) x2(imx)=ix
               if (y1(imx).gt.iy) y1(imx)=iy
               if (y2(imx).lt.iy) y2(imx)=iy
            end if
 11      continue
 10   continue
      
      imnum=0
      do 30 i=1,imlast
         if (num(i).eq.i) then
            imnum=imnum+1
            newnum(i)=imnum
         else
            newnum(i)=newnum(num(i))
         end if
         if (num(i).gt.i) write(*,'('' FINDIMAGE : num(i) > i !! '')')
 30   continue
      write(*,'('' number of images = '',i5)') imnum
      
      do 21 iy=1,ny
         do 22 ix=1,nx
            if (im(ix,iy).ne.0) im(ix,iy)=newnum(im(ix,iy))
 22      continue
 21   continue
      
      return
      end
      subroutine substitute(nx,ny,im,MAXIM,x1,x2,y1,y2,im1,im2,
     $     imx,imy,num)
      
      integer im(nx,ny)
      integer   x1(MAXIM),x2(MAXIM),y1(MAXIM),y2(MAXIM),num(MAXIM)
      integer	  im1(MAXIM),im2(MAXIM)
      
      if (imx.lt.imy) then
         it=imy
         imy=imx
         imx=it
      end if
      
      do 10 i=im1(imx),im2(imx)
         if (num(i).eq.imx) num(i)=num(imy)
 10   continue
      
      if (im1(imx).lt.im1(imy)) im1(imy)=im1(imx)
      if (im2(imx).gt.im2(imy)) im2(imy)=im2(imx)
      
      if (x1(imx).lt.x1(imy)) x1(imy)=x1(imx)
      if (x2(imx).gt.x2(imy)) x2(imy)=x2(imx)
      if (y1(imx).lt.y1(imy)) y1(imy)=y1(imx)
      if (y2(imx).gt.y2(imy)) y2(imy)=y2(imx)
      
      x1(imx)=-1
      x2(imx)=-2
      y1(imx)=-1
      y2(imx)=-2
      
      return
      end

