	subroutine linco

	call lincor

	return
	end

	subroutine lincor
C-----------------------------------------------------------------------------
C
C	program to apply linearlity correction
C	correction only depends on pixel value
C
C-----------------------------------------------------------------------------

	Parameter (MAXNPIX=256*256*20,MAXPIX=256*256)

	Implicit Real*8 (A-H,O-Z)
	Integer Nx,Ny,unit
	Real*4 pixi(MAXNPIX),scr(MAXPIX)
	Character*10 Ans
	Character*128 inlist,outlist
	Character*128 ilist(400),olist(400),string
	Character*60 obj(400),objflat

	call gproms('inlist',' ',' ',inlist,ierr)
	call gproms('outlist',' ',' ',outlist,ierr)

C	
C	first unravel the list of input files
C
	L=Len(inlist)
	ipos=1
10	if (inlist(ipos:ipos).eq.'@') then	
	   inlist(1:(128-ipos))=inlist((ipos+1):128)
	   call unravel(inlist,ilist,N)
	else
	   if (inlist(ipos:ipos).eq.' ') then
	      ipos=ipos+1
	      if (ipos.le.L) goto 10
	   else
	      ilist(1)=inlist
	      N=1
	   end if
	end if
	write (string,'('' # input files '',I4)') N
	call gwrits (string,2)
210	if (outlist(ipos:ipos).eq.'@') then	
	   outlist(1:(128-ipos))=outlist((ipos+1):128)
	   call unravel(outlist,olist,N)
	else
	   if (outlist(ipos:ipos).eq.' ') then
	      ipos=ipos+1
	      if (ipos.le.L) goto 10
	   else
	      olist(1)=outlist
	      N=1
	   end if
	end if

	unit=11
	do i=1,N
	   call gimopen(unit,ilist(i),ierr)
	   if (ierr.ne.0) then
	    write (string,'('' LINCOR: Error opening '',a)') ilist(i)
	    call gwrits(string,2)
	    return
	   end if
	   call gimhead(unit,obj(i),nx,ny,ierr)
	   if (ierr.ne.0) then
	    write (string,'('' LINCOR: Error opening header of'',a)') ilist(i)
	    call gwrits(string,2)
	   end if
	   unit=unit+1
	end do
	call read3d(11,nx,ny,N,pixi,ierr)
	write (string,'('' data read in '')') 
	call gwrits (string,2)
C
C	Now call subroutine to do all the work
C
	call correct(pixi,nx,ny,N)
	call write3d(pixi,nx,ny,N,olist,obj,scr,ierr)
	return
	end

	subroutine correct(data,nx,ny,nz)

	real data(nx,ny,nz)
	integer nx,ny,nz
	character*128 string

	do k=1,nz
	write (6,*) k
	   do i=1,nx
              do j=1,ny
	         data(i,j,k)=data(i,j,k)*(1.+(data(i,j,k)/10000.)
     1                      *3.50e-2+(data(i,j,k)/10000.)**2.*0.011)
              enddo
	   enddo
	enddo	
	return
	end

