
	subroutine listl

	call delsub

	return
	end

      subroutine  delsub

      character*128 image,output,deletion,object,rootname
      real vbad
      character*128 string

	parameter	(MAXGAL=1, MAXLINE=128, MAXHARM=9, MAXNPIX=512*512,
     &      MAXSAMP=1024, VALMIN=-32000, VALBAD=0.,NCOLMAX=64)
	parameter	(pi=3.141592645)

c	common block with switches/parameter values for the fitting programs
c	most of these parameters are user-controlled

	common/photpar/
     &	iter1,iter2,hmax,nsammax,debug,npolres,
     &	rmin,rmax,radfac,rshap,rcen,errshap,errcen,dposmax,dellmax,
     &	dangmax,r1,r2,fracmin,
     &  linear,outfill,extend

c		parameters for the setting up of the radius interval

	real	rmin,rmax,radfac
	logical	linear

c		parameters which determine the radial cutoffs for the
c		ellipse fitting

	real	rshap,rcen
	real	errshap,errcen

c		parameters which determine the number of iterations when
c		fitting ellipses

	integer	iter1,iter2

c		parameters needed for the ellipsefitting & harminical fitting

	integer	hmax
	real	dposmax,dellmax,dangmax

c		radial & azimuthal sampling parameters

	real	r1,r2
	integer	nsammax
	real	fracmin

c		parameter for extending the radial range at the end

	logical extend

c		debugging

	integer	debug

c		parameters for the calculation of residuals

	logical	outfill
	integer	npolres

c	COMMON BLOCK FOR PIXEL STORAGE - TO MAKE MORE EFFICIENT USE
c	OF MEMORY IN IRAF EXECUTABLE.
c
	real	pix,dif
	common/pixcom/pix(MAXNPIX), dif(MAXNPIX)

      call gproms('image',' ',' ',image,ierr)
      if (ierr.ne.0) return
      call gproms('output',' ',' ',output,ierr)
      if (ierr.ne.0) return
      call gproms('deletion',' ',' ',deletion,ierr)
      if (ierr.ne.0) return
      call gproms('rootname',' ',' ',rootname,ierr)
      if (ierr.ne.0) return
      call gpromi('verbose',0,'',debug,ierr)
      if (ierr.ne.0) return

      call  gimopen (1,image, ierr)
      if (ierr.ne.0) then
         write(string,'('' DELETE:: Error opening '',a)') image
         call gwrits(string,2)
         return
      end if
      call gimhead (1,object,nx,ny,ierr)
      if (ierr.ne.0) goto 999


      call readin (1, nx, ny, pix ,ierr)
      if (ierr.ne.0) goto 999

      call gimclose(1,ierr)
      if (ierr.ne.0) return

      if (debug.ge.1) then
         write(string,'('' DELETE: start deleting pixels '')')
         call gwrits(string,1)
      end if

      if (rootname.eq.'') rootname=image
      call maskpix(nx,ny,pix,rootname,deletion)

      if (debug.ge.1) then
         write(string,'('' DELETE: finished deleting pixels '')')
         call gwrits(string,1)
      end if

      call imname(rootname,output)

      if (output.ne.' ') then
         if (debug.ge.1) then
            write(string,'('' DELETE: write file to disk '')')
            call gwrits(string,1)
         end if
         call gimwrit(output, nx, ny, pix, object,ierr)
      end if


      return
 999  call gimclose(1,ierr)
      return

      end

      subroutine maskpix(nx,ny,pix,image,deletion)

c     this subroutine deletes all the images given in the multiple
c     files in deletion

      real	pix(nx,ny)
      character*128	image,deletion

      character*128	file,delname

      call startsub('MASKPIX')

      delname=deletion
 10   if (delname.ne.' ') then
         call parse(delname,file,lfile)
         call imname(image,file)
         call delpix(file,nx,ny,pix)
         goto 10
      end if

      return
      end

      subroutine delpix (file,nx,ny,pix)

c     this subroutine deletes the images defined in file


      character*128	file
      real		pix(nx,ny)


	parameter	(MAXGAL=1, MAXLINE=128, MAXHARM=9, MAXNPIX=512*512,
     &      MAXSAMP=1024, VALMIN=-32000, VALBAD=0.,NCOLMAX=64)
	parameter	(pi=3.141592645)

c	common block with switches/parameter values for the fitting programs
c	most of these parameters are user-controlled

	common/photpar/
     &	iter1,iter2,hmax,nsammax,debug,npolres,
     &	rmin,rmax,radfac,rshap,rcen,errshap,errcen,dposmax,dellmax,
     &	dangmax,r1,r2,fracmin,
     &  linear,outfill,extend

c		parameters for the setting up of the radius interval

	real	rmin,rmax,radfac
	logical	linear

c		parameters which determine the radial cutoffs for the
c		ellipse fitting

	real	rshap,rcen
	real	errshap,errcen

c		parameters which determine the number of iterations when
c		fitting ellipses

	integer	iter1,iter2

c		parameters needed for the ellipsefitting & harminical fitting

	integer	hmax
	real	dposmax,dellmax,dangmax

c		radial & azimuthal sampling parameters

	real	r1,r2
	integer	nsammax
	real	fracmin

c		parameter for extending the radial range at the end

	logical extend

c		debugging

	integer	debug

c		parameters for the calculation of residuals

	logical	outfill
	integer	npolres
      integer		x1,x2,y1,y2
      real		del(4)
      character	record*80
      logical 	exist
      character*128	string


      call startsub('DELPIX')

      inquire(file=file,exist=exist)
      if (.not.exist) then
         if (debug.ge.2) then
            write(string,'('' DELPIX: no file '',a)')
     &           file(1:80)
            call gwrits(string,1)
         end if
         return
      end if

      open(unit=1,file=file,status='old',iostat=iostat)
      if (iostat.ne.0) then
         if (debug.ge.2) then
            write(string,'('' DELPIX: cannot open file '',a)')
     &           file(1:80)
            call gwrits(string,1)
         end if
         return
      end if

      if (debug.ge.2) then
         write(string,'('' DELPIX: file opened '',a)')  file(1:80)
         call gwrits(string,1)
      end if

      ndel = 0
 10   if (iostat.eq.0) then

c     read line from deletions file

         read (1,'(a)',iostat=iostat) record
         if (debug.ge.5) then
            write(string,'('' DELPIX: deleting '',a)')
     $           record(1:lenc(record))
            call gwrits(string,1)
         end if

         do 20 i=1,4
            del(i)=0.
 20      continue
         call arguments(record,4,del,narg)
         if (del(1).ne.0) then
            if (del(4).ne.0) then

c     delete square region

               x1=nint(del(1))
               x2=nint(del(2))
               y1=nint(del(3))
               y2=nint(del(4))
               do 21 j=y1,y2
                  if (j.ge.1.and.j.le.ny) then
                     do 22 i=x1,x2
                        if (i.ge.1.and.i.le.nx) then
                           pix(i,j)=VALBAD
                        end if
 22                  continue
                  end if
 21            continue
            else

c     delete circle

               xcir=del(1)
               ycir=del(2)
               rcir=del(3)
               if (rcir.gt.0.) then
                  rcir2=rcir**2
                  x1=xcir-rcir-1.
                  x2=xcir+rcir+1.
                  y1=ycir-rcir-1.
                  y2=ycir+rcir+1.
                  do 23 j=y1,y2
                     if (j.ge.1.and.j.le.ny) then
                        do 24 i=x1,x2
                           if (i.ge.1.and.i.le.nx) then
                              rad2=(float(i)-xcir)**2+(float(j)-ycir)**2
                              if (rad2.le.rcir2) pix(i,j)=VALBAD
                           end if
 24                     continue
                     end if
 23               continue
               end if
            end if
            ndel=ndel+1
         end if
         goto 10
      end if

      close(unit=1)
      if (debug.ge.2) then
         write(string,'('' DELPIX: '',i5,'' objects deleted'')') ndel
         call gwrits(string,1)
      end if

      return


      end

