	subroutine ffmake

	call makeff

	return
	end

	subroutine makeff
C-----------------------------------------------------------------------------
C
C	program to obtain a flatfield by median-filtering
C	a number of dome or sky-flats
C	Program takes care of bad regions (in maskfile),
C	and subtracts a darkframe from the data first.
C
C-----------------------------------------------------------------------------

	Parameter (MAXNPIX=256*256*20,MAXPIX=256*256)

	Implicit Real*8 (A-H,O-Z)
	Integer Nx,Ny,unit
	Real*4 pixi(MAXNPIX),darkf(MAXPIX)
	Real*4 Maskf(MAXPIX),Flatf(MAXPIX)
	Character*10 Ans
	Character*128 inlist,outname,darkfile,maskfile
	Character*128 ilist(100),string
	Character*60 obj(100),objdark,objmask,objflat

	call gproms('inlist',' ',' ',inlist,ierr)
	call gproms('darkfile',' ',' ',darkfile,ierr)
	call gproms('maskfile',' ',' ',maskfile,ierr)
	call gproms('flatfield',' ',' ',outname,ierr)

C	
C	first unravel the list of input files
C
	L=Len(inlist)
	ipos=1
10	if (inlist(ipos:ipos).eq.'@') then	
	   inlist(1:(128-ipos))=inlist((ipos+1):128)
	   call unravel(inlist,ilist,N)
	else
	   if (inlist(ipos:ipos).eq.' ') then
	      ipos=ipos+1
	      if (ipos.le.L) goto 10
	   else
	      ilist(1)=inlist
	      N=1
	   end if
	end if

	unit=11
	do i=1,N
	   call gimopen(unit,ilist(i),ierr)
	   if (ierr.ne.0) then
	    write (string,'('' MAKEFF: Error opening '',a)') ilist(i)
	    call gwrits(string,2)
	    return
	   end if
	   call gimhead(unit,obj(i),nx,ny,ierr)
	   if (ierr.ne.0) then
	    write (string,'('' MAKEFF: Error opening header of'',a)') ilist(i)
	    call gwrits(string,2)
	   end if
	   unit=unit+1
	end do
	call read3d(11,nx,ny,N,pixi,ierr)

	call gimopen(41,darkfile,ierr)
	if (ierr.ne.0) then
	   write (string,'('' MAKEFF: Error opening '',a)') darkfile
	   call gwrits(string,2)
	   return
	end if
	call gimhead(41,objdark,nx,ny,ierr)
	if (ierr.ne.0) then
	   write (string,'('' MAKEFF: Error opening header of'',a)') darkfile
	   call gwrits(string,2)
	end if
	call readin(41,nx,ny,darkf,ierr)

	call gimopen(42,maskfile,ierr)
	if (ierr.ne.0) then
	   write (string,'('' MAKEFF: Error opening '',a)') maskfile
	   call gwrits(string,2)
	   return
	end if
	call gimhead(42,objmask,nx,ny,ierr)
	if (ierr.ne.0) then
	   write (string,'('' MAKEFF: Error opening header of'',a)') maskfile
	   call gwrits(string,2)
	end if
	call readin(42,nx,ny,maskf,ierr)

C
C	Now call subroutine to do all the work
C
	call dowork(pixi,nx,ny,N,darkf,maskf,flatf)
	call gimwrit(outname,nx,ny,Flatf,obj(1),ierr)
	return
	end

	subroutine dowork(data,nx,ny,nz,dark,mask,flat)

	real data(nx,ny,nz),dark(nx,ny),mask(nx,ny),flat(nx,ny)
	integer nx,ny,nz
	character*128 string

C
C	first subtract dark and normalize
C
	do k=1,nz
	   sum=0.
	   np=0
	   do i=1,nx
	      do j=1,ny
		 data(i,j,k)=data(i,j,k)-dark(i,j)
	         if (mask(i,j).gt.0.5) then
	            np=np+1
	            sum=sum+data(i,j,k)
	         end if
	      enddo
	   enddo
	   do i=1,nx
	      do j=1,ny
	         data(i,j,k)=data(i,j,k)/sum
	      enddo
	   enddo
	enddo
C
C	now the median-filtering
C
	do i=1,nx
	   do j=1,ny
	      do k=1,nz-1
	         do l=1,nz-k
		    if (data(i,j,k+l-1).gt.data(i,j,k+l)) then
	               help=data(i,j,k+l)
	               data(i,j,k+l)=data(i,j,k+l-1)
	               data(i,j,k+l-1)=help	         
	            end if
	         enddo
	      enddo
	   enddo
	enddo
	sum=0.
	if (nz.eq.(2.*(nz/2))) then
	   do i=1,nx
	      do j=1,ny
	         flat(i,j)=(data(i,j,nz/2)+data(i,j,nz/2+1))/2.
	         if (mask(i,j).gt.0.5) then
	            sum=sum+flat(i,j)
	         end if
	      enddo
	   enddo
	else
	   do i=1,nx
	      do j=1,ny
	         flat(i,j)=data(i,j,nz/2+1)
	         if (mask(i,j).gt.0.5) then
		    sum=sum+flat(i,j)
	         end if
	      enddo
	   enddo
	end if
	sum=sum/(1.*np)
	do i=1,nx
	   do j=1,ny
	      flat(i,j)=flat(i,j)/sum
	      if (mask(i,j).le.0.5) then
	         flat(i,j)=1.
	      end if
	   enddo
	enddo
	return
	end	

	subroutine unravel(istr,lists,N)

	character*128 istr,lists(100),string
	character*128 file

	file=istr
	
	open(unit=45,file=file,status='old')
	i=1
10	read (45,99999,end=20) lists(i)
99999	format (A)
	i=i+1
	goto 10
20	N=i-1
	close(45)
	return
	end
	
      SUBROUTINE READ3D (IUNST, NX, NY, NZ, DATA ,ierr)
      REAL*4 DATA(NX,NY,NZ)
      INTEGER UNIT
C	character*128 string

      REAL*4	BUF(2028)

      character*128	string

      DO UNIT=IUNST,IUNST+NZ-1
         IUN=UNIT
         DO 10 IY=1,NY
            CALL gimROW(IUN,IY,NX,BUF,ierr)
            if (ierr.ne.0) return
            DO 11 IX=1,NX
               DATA(IX,IY,UNIT-IUNST+1)=BUF(IX)
 11         CONTINUE
 10      CONTINUE
	
      END DO

      RETURN
      END
