      subroutine maskpix(nx,ny,pix,image,deletion)

c     this subroutine deletes all the images given in the multiple
c     files in deletion

      real	pix(nx,ny)
      character*128	image,deletion

      character*128	file,delname

      call startsub('MASKPIX')

      delname=deletion
 10   if (delname.ne.' ') then
         call parse(delname,file,lfile)
         call imname(image,file)
         call delpix(file,nx,ny,pix)
         goto 10
      end if

      return
      end

      subroutine delpix (file,nx,ny,pix)

c     this subroutine deletes the images defined in file


      character*128	file
      real		pix(nx,ny)

      include 'param.inc'

      integer		x1,x2,y1,y2
      real		del(4)
      character	record*80
      logical 	exist
      character*128	string


      call startsub('DELPIX')

      inquire(file=file,exist=exist)
      if (.not.exist) then
         if (debug.ge.2) then
            write(string,'('' DELPIX: no file '',a)')
     &           file(1:80)
            call gwrits(string,1)
         end if
         return
      end if

      open(unit=1,file=file,status='old',iostat=iostat)
      if (iostat.ne.0) then
         if (debug.ge.2) then
            write(string,'('' DELPIX: cannot open file '',a)')
     &           file(1:80)
            call gwrits(string,1)
         end if
         return
      end if

      if (debug.ge.2) then
         write(string,'('' DELPIX: file opened '',a)')  file(1:80)
         call gwrits(string,1)
      end if

      ndel = 0
 10   if (iostat.eq.0) then

c     read line from deletions file

         read (1,'(a)',iostat=iostat) record
         if (debug.ge.5) then
            write(string,'('' DELPIX: deleting '',a)')
     $           record(1:lenc(record))
            call gwrits(string,1)
         end if

         do 20 i=1,4
            del(i)=0.
 20      continue
         call arguments(record,4,del,narg)
         if (del(1).ne.0) then
            if (del(4).ne.0) then

c     delete square region

               x1=nint(del(1))
               x2=nint(del(2))
               y1=nint(del(3))
               y2=nint(del(4))
               do 21 j=y1,y2
                  if (j.ge.1.and.j.le.ny) then
                     do 22 i=x1,x2
                        if (i.ge.1.and.i.le.nx) then
                           pix(i,j)=VALBAD
                        end if
 22                  continue
                  end if
 21            continue
            else

c     delete circle

               xcir=del(1)
               ycir=del(2)
               rcir=del(3)
               if (rcir.gt.0.) then
                  rcir2=rcir**2
                  x1=xcir-rcir-1.
                  x2=xcir+rcir+1.
                  y1=ycir-rcir-1.
                  y2=ycir+rcir+1.
                  do 23 j=y1,y2
                     if (j.ge.1.and.j.le.ny) then
                        do 24 i=x1,x2
                           if (i.ge.1.and.i.le.nx) then
                              rad2=(float(i)-xcir)**2+(float(j)-ycir)**2
                              if (rad2.le.rcir2) pix(i,j)=VALBAD
                           end if
 24                     continue
                     end if
 23               continue
               end if
            end if
            ndel=ndel+1
         end if
         goto 10
      end if

      close(unit=1)
      if (debug.ge.2) then
         write(string,'('' DELPIX: '',i5,'' objects deleted'')') ndel
         call gwrits(string,1)
      end if

      return


      end

