	subroutine mods

	call mod
	
	return
	end

	subroutine mod
C
C	Makes a model of an exponential disk
C	Reynier Peletier
C
	parameter	(MAXGAL=1, MAXLINE=128, MAXHARM=9, MAXNPIX=512*512,
     &      MAXSAMP=1024, VALMIN=-32000, VALBAD=-33000.,NCOLMAX=64)
	parameter	(pi=3.141592645)
C
C	New Declarations
C
	character*128 name,string,outname
	character*60 object
	real*4 Len,X,Y,Ang,Alpha,Back,B,Beta,xc,yc
	real*4 Sumn(-512:512),Sum(-512:512),Sum2(-512:512)
	integer ln
	logical exist

	real pix(MAXNPIX),out(MAXNPIX)

C	read in parameters

	call gproms('infile',' ',' ',name,ierr)
	call gproms('outfile',' ',' ',outname,ierr)
	call gpromr('xc',1.,' ',xc,ierr)
	call gpromr('yc',1.,' ',yc,ierr)
	call gpromr('h0',1.,' ',h0,ierr)
	call gpromr('z0',1.,' ',z0,ierr)
	call gpromr('a0',1.,' ',a0,ierr)
	call gpromr('angle',0.,' ',angle,ierr)

C	write(string,'(a)') name
C	call gwrits(string,2)
	call gimopen(1,name,ierr)
	if (ierr.ne.0) then
	   write (string,'('' CUTS: Error opening '',a)') name
	   call gwrits(string,2)
	   return
	end if
	call gimhead(1,object,nx,ny,ierr)
	if (ierr.ne.0) then
	   write (string,'('' CUTS: Error opening header of'',a)') name
	   call gwrits(string,2)
	end if
C
C	Read in pixel data
C
	call readin(1,nx,ny,pix,ierr)
	call fill(out,nx,ny,h0,z0,a0,angle,xc,yc)
	call imname(name,outname)
	call gimwrit(outname,nx,ny,out,object,ierr)
	return
	end

	subroutine fill(pix,nx,ny,h0,z0,a0,angle,xc,yc)
	real pix(nx,ny),h0,z0,a0,angle,xc,yc
	integer nx,ny
	character*128 string

	write(string,'(3f)') angle,h0,z0
	call gwrits(string,2)
	cosa=cos(angle/180.*3.14159265)
        sina=sin(angle/180.*3.14159265)
	do 100 i=1,nx
	   do 200 j=1,ny
	      x=i - xc
	      y=j - yc
              val=a0*exp(-abs((cosa*x-sina*y)/h0))*
     1               exp(-abs((sina*x+cosa*y)/z0))
	      pix(i,j)=val
200	   continue
100	continue
	return
	end
