	subroutine selec

	call select

	return
	end

	subroutine select
C-----------------------------------------------------------------------------
C
C	program tries to make the background of IR frames flatter,
C	by adding a dark-difference, obtained by subtracting 2 sky-frames
C	maximum 8 input sky-frames allowed
C
C-----------------------------------------------------------------------------

	Parameter (MAXNPIX=64*64*10,MAXPIX=128*128)

	Integer Nx,Ny,unit
	Real*4 obji(MAXNPIX),tempf(MAXPIX)
	Real*4 outf(MAXPIX),outf2(MAXPIX)
	Real*4 maskf(MAXPIX)
	Real*4 scr(MAXPIX),ssky(MAXPIX),starco,dcon
	Integer*4 Iscr(MAXPIX)
	Character*10 Ans
	Character*128 outfile,maskfile
	Character*128 objlist,template
	Character*128 olist(20),string,flatfile
	Character*60 obj(20),objtemp
	Character*60 Objmsk

	call gproms('objlist',' ',' ',objlist,ierr)
	call gproms('template',' ',' ',template,ierr)
	call gproms('maskfile',' ',' ',maskfile,ierr)
	call gproms('outfile',' ',' ',outfile,ierr)
	call gpromr('reject',10.,' ',reject,ierr)

C	
C	first unravel the list of input files
C
	L=Len(objlist)
	ipos=1
10	if (objlist(ipos:ipos).eq.'@') then	
	   objlist(1:(128-ipos))=objlist((ipos+1):128)
	   call unravel(objlist,olist,N)
	else
	   if (objlist(ipos:ipos).eq.' ') then
	      ipos=ipos+1
	      if (ipos.le.L) goto 10
	   else
	      olist(1)=objlist
	      N=1
	   end if
	end if

	unit=11
	do i=1,N
	   call gimopen(unit,olist(i),ierr)
	   if (ierr.ne.0) then
	    write (string,'('' SELECT: Error opening '',a)') olist(i)
	    call gwrits(string,2)
	    return
	   end if
	   call gimhead(unit,obj(i),nx,ny,ierr)
	   if (ierr.ne.0) then
	    write (string,'('' SELECT: Error opening header of'',a)') olist(i)
	    call gwrits(string,2)
	   end if
	   unit=unit+1
	end do
	call read3d(11,nx,ny,N,obji,ierr)
	nu=unit

	call gimopen(61,template,ierr)
	if (ierr.ne.0) then
	   write (string,'('' SELECT: Error opening '',a)') 
     1		template(1:80)
	   call gwrits(string,2)
	   return
	end if
	call gimhead(61,objtemp,nx,ny,ierr)
	if (ierr.ne.0) then
	 write (string,'('' SELECT: Error opening header of'',a)') 
     1          template(1:80)
	   call gwrits(string,2)
	end if
	call readin(61,nx,ny,tempf,ierr)

	call gimopen(41,maskfile,ierr)
	if (ierr.ne.0) then
	   write (string,'('' SELECT: Error opening '',a)') 
     1            maskfile(1:80)
	   call gwrits(string,2)
	   return
	end if
 	call gimhead(41,Objmsk,nx,ny,ierr)
	if (ierr.ne.0) then
	   write (string,'('' SELECT: Error opening header of'',a)') 
     1            maskfile(1:80)
	   call gwrits(string,2)
	end if
	call readin(41,nx,ny,maskf,ierr)

C
C	Now call subroutine to do all the work
C
	call selwork(obji,nx,ny,N,tempf,maskf,outf,
     1              scr,reject)
	call intwork(outf,nx,ny,1,outf2,maskf,iscr)
	call gimwrit(outfile,nx,ny,outf2,obj(1),ierr)
	return
	end

	subroutine selwork(odata,nx,ny,nz,tempd,mask,rdata,
     1		scr,reject)

	real odata(nx,ny,nz),mask(nx,ny),tempd(nx,ny)
	real rdata(nx,ny),scr(nx,ny)
	real reject
	real xv(5000),yv(5000),zv(5000),sv(5000),fit(3)
	integer nx,ny,nz,ND,sa1,sa2,mx(100),my(100),NDP1
	character*128 string

C 
C	first fit a plane to the templatefile
C
	np=1
	do i=1,nx
	      do j=1,ny
	         if (mask(i,j).gt.0.5) then
		    xv(np)=i/1.
		    yv(np)=j/1.
		    zv(np)=tempd(i,j)
		    sv(np)=1.
		    np=np+1
		 end if
	   enddo
	enddo
	np=np-1
	ndecl=5000
	call planefit(xv,yv,zv,sv,np,ndecl,fit,ierr)
	if (ierr.ne.0) then
	   write (string,'(''planefit did not work '',2I)') k,ierr
	   call gwrits(string,2)
	else
	   sum=0.
	   sum2=0.
	   tsv=0.
	   do i=1,nx
	      do j=1,ny
	         term=tempd(i,j)-fit(1)-fit(2)*i-fit(3)*j
	         scr(i,j)=term
	         sum=sum+term
	         sum2=sum2+term*term
	      enddo
	   enddo
	   sum2=sqrt(sum2)
	end if

C
C	Now determine criteria of the individual frames and reject
C	or not
C
	do i=1,nx
	   do j=1,ny
	      rdata(i,j)=0.
	   enddo
	enddo
	do k=1,nz
C
C	first calculate median of data (sky measure)
C
	   sum1=0.
	   np=0
	   do i=1,nx
	      do j=1,ny
		 if (mask(i,j).gt.0.5) then
		    np=np+1
		    xv(np)=odata(i,j,k)
		 end if
	      enddo
	   enddo
	   do i=1,np-1
	      do j=i,np-1
		 if (xv(j).gt.xv(j+1)) then
		    h=xv(j)
		    xv(j)=xv(j+1)
		    xv(j+1)=h
		 end if
	      enddo
	   enddo
	   sum1=xv(np/2)
	   sum=0.
	   np=0
	   do i=1,nx
	      do j=1,ny
		 if (mask(i,j).gt.0.5) then
C		    sum=sum+(odata(i,j,k)-sum1)*scr(i,j)
		    np=np+1
		    xv(np)=(odata(i,j,k)-sum1)*scr(i,j)
		 end if
	      enddo
	   enddo
C	   sum=sum/np
C
C	determine median to avoid centre
C
	   do i=1,np-1
	      do j=i,np-1
		 if (xv(j).gt.xv(j+1)) then
		    h=xv(j)
		    xv(j)=xv(j+1)
		    xv(j+1)=h
		 end if
	      enddo
	   enddo
	   sum=xv(np/2)
	   write (string,'('' Val for frame: '',i,F,I)') k,sum,np
	   call gwrits(string,2)
	   if (abs(sum).lt.reject) then
	      do i=1,nx
	         do j=1,ny
		    rdata(i,j)=rdata(i,j)+odata(i,j,k)
		 enddo
	      enddo
	      ns=ns+1
	   end if
	enddo
	write (string,'('' SELECT: added frames '',i)') ns
	call gwrits(string,2)
	return
	end
