
# SDISP --- display image using SHOWIMG
# By Doug Mink, Center for Astrophysics
# February 15, 1989

procedure sdisp (image)

char image=""		{prompt="image to be plotted"}

char imdir=""		{prompt="image directory (.=current)"}
char imtype="imh"	{prompt="image file type (imh,fits,dfits)?"}
int planes=0		{prompt="number of image display planes to reserve"}
int nbits=16		{prompt="number of bits per pixel (8,16,32)"}
int nimage=0		{prompt="Image in sequence to display"}
bool inverse=no		{prompt="default to inverse video on startup"}
bool sqrt=no		{prompt="default to square-root mapping rather than linear"}
bool rgb=no		{prompt="default to red-green-blue rather than gray scale"}
real floor=0		{prompt="minimum value to be plotted (0 for min)"}
real ceiling=0		{prompt="maximum value to be plotted (0 for max)"}
real scale=0		{prompt="scale factor for floating point images (0=1)"}
int hbytes=0		{prompt="number of bytes to skip before image"}
int nrows=0		{prompt="number of row (0 if from header)"}
int ncols=0		{prompt="number of columns (0 if from header)"}
int zf=1		{prompt="zoom factor"}
char font=""		{prompt="X font for title and position"}
char geometry=""	{prompt="window geometry"}
char display=""		{prompt="output X display"}
char title=""		{prompt="optional title"}
bool background=no	{prompt="run showimg in background"}
bool keycurs=no		{prompt="use h,j,k,l keys to move cursor l,d,u,r"}
bool rescale=yes	{prompt="rescale using BSCALE and BZERO if FITS file"}
bool fullpath=no	{prompt="display image pathname instead of filename"}
bool rowflip=no		{prompt="Reverse row coordinates"}
bool colflip=no		{prompt="Reverse column coordinates"}
bool xflip=no		{prompt="Reverse X coordinates"}
bool yflip=no		{prompt="Reverse Y coordinates"}
bool debug=no		{prompt="display parmeter values as set (y or n)"}

begin

  char arg, parfile, im

# Set up parameter file for SHOWIMG
  im = image
  image = ""
  image = im
  imdir = osfn (imdir)
  update sdisp

# Set parameter file name for SHOWIMG
  parfile = osfn ('uparm$itssdisp.par')
  arg = " -par "//parfile

  arg = arg // " " // imdir // im

# Run in background if requested
  if (background) {
      arg = arg // " &"
      }

# Display command to be executed
  print ("showimg ",arg)

# Execute SHOWIMG
  showimg (arg)

end
