.TH SHOWIMG 1 "18 November 1986" "CfA Additions"
.SH NAME
showimg \- display CCD\-format images under X windows
.SH SYNTAX
.B showimg
[ \fIoptions\fR ] \fIfilename\fR
.SH DESCRIPTION
A CCD file or FITS-format file containing header information and 8\-bit or
16-bit image data is read into memory and presented for display
highlighting under the X window system. Mouse and cursor manipulations
allow the control of several interactive functions.  Besides the
options listed below, the usual menu and window options as documented
in the \fBX\fR and \fBXMenu\fR manual pages are available, either as
inputs to the command line or in the \fI.Xdefaults\fR file.
.PP
A `zoom box' is displayed in an independent window next to the main window.
It always displays an area of the picture around the cursor position,
zoomed by a factor of four in each direction. This window can be enlarged,
but updateing will be correspondingly slower, as the entire window is
redrawn whenever the cursor is moved.
.SH OPTIONS
.TP 6
.B \-planes \fIn\fB
Allocate \fIn\fR planes to the display image. This will use 2**n colors or
gray levels.
.TP 6
.B \-rgb
Default to red\-green\-blue color selection on startup instead of gray scale.
.TP 6
.B \-neg
Default to inverse video on startup.
.TP 6
.B \-sqrt
Default to square root mapping on startup instead of linear.
.TP 6
.BI \-threshold\  tnum
Use \fItnum\fR as the threshold level for scaling the 16\-bit image
instead of the one determined automatically.
.TP 6
.BI \-saturate\  snum
Use \fIsnum\fR as the saturation level for scaling the 16\-bit image
instead of the one determined automatically.
.TP 6
.B \-fits
Assume FITS format. Checks for the header keywords `SIMPLE = T' and that
`BITPIX = 16' or `BITPIX = 8', and reads the size from `NAXIS1' and
`NAXIS2'. The image will be read with 2880\-byte reads and the 16\bit
integers byte-swapped if on a VAX.
.TP 6
.B \-dfits
Assume `disk' FITS format. On a VAX this assumes the integers do not need
to be byte-swapped; otherwise this option is identical to \fI\-fits\fR.
Checks that `SIMPLE = T' and that `BITPIX = 16', and reads the size from
`NAXIS1' and `NAXIS2'. The image will be read with 2880\-byte reads.
.TP 6
.BI \-nbits\  num
The input image has \fInum\fR bits per pixel instead of the default 16.
Currently, 8 bits is the only alternative to the default.
.TP 6
.BI \-skip\  hbytes \ \-nrows \ nr \ \-ncols \ nc
Do not read image size information from the header (either FITS or CfA
CCD); skip \fIhbytes\fR bytes of information at the beginning of the file
instead. The image is \fInc\fR columns by \fInr\fR rows of 16-bit pixels
(or 8\-bit pixels if `\-nbit 8' option is given as above).
This option can be used to read and display images in `foreign' formats.
.SH Mouse Control
By default the picture comes up with a linear intensity gray scale. Pressing
any mouse button, with or without mouse motion, causes the intensities 
displayed to change. Holding down the control button while pressing a mouse
button causes a pop\-up menu to appear, providing furthur choices. Releasing 
the button while pointing to an active selection chooses that selection.
.PP
The first pop-up menu selects other functions such as reinitialization to the
default intensity map, display in red\-green\-blue or gray scale, and inverse
versus normal video.
.IP 
Motion in the horizontal direction while holding down a mouse button down
corresponds to a change in the threshold or background levels displayed.
Motion in the vertical direction with a mouse button down changes the
contrast. The center of the window is considered the default or null point.
.IP
If the \-rgb option is selected, either in the command line or via the pop\-up
menu, the left, middle, and right mouse buttons control the red, green, and
blue intensity, respectively.
.PP
The second menu selects secondary cursor\-activated options: printing,
panning, and zoom\-in. As each of these is selected, the mouse cursor changes
to reflect the intended operation. 
.IP
Clicking any mouse button with the print option selected prints the 16-bit 
pixel value under that point, and the pixels atround it in an 11x11 grid.
.IP
Under the pan and zoom options, the picture is redisplayed centered around the
point under the cursor when clicked. If the point is too close to the edge of
the display window, the point may not actually be displayed in the center. The
zoom options (x2 and x4) magnify the picture via pixel replication. If
the picture is zoomed, the zoom box increases its magnification so that
it remains a factor of four higher magnification.
.PP
The third menu select on of two functions to map the 16-bit intensities into
the n-bit intensities loaded into the GPX memory: linear and sqrt. The latter
is useful to relatively de-empahsize the contrast between background and
bright pixels. After recalculating the mapping, the entire picture will be 
redrawn with the new pixels in the GPX.
.SH Cursor Control
The cursor or arrow keys can be used for fine motion, stepping one pixel at
a time in the given direction.
.SH BUGS
.PP
If the `zoom box' is made too large, the image data being written will
overflow the X server buffers, causing a fatal error. This error is not
checked for in the interests of speed, but an error handler should be
inserted to prevent fatal crashes.
.PP
Cursor control is only guanranteed to work on a DEC LK201 keyboard.
.PP
Needs a histogram display function to allow interactive setting of threshold
and saturation values.
.PP
Should have a true color palette instead of the rgb control to provide 
independent colors. Needs more types of mapping.
.SH AUTHOR
William F. Wyatt, Smithsonian Astrophysical Observatory.
