#*** itools.imoff.cl
#*** April 19, 2002
#*** By Doug Mink

# IMOFF -- Given two images with the RA and DEC keywords in each image
#          referring to the same pixel, compute their offset in pixels

procedure imoff (image1, image2)

string image1=""	{prompt="First image name"}
string image2=""	{prompt="Second image name"}
real dx=0		{prompt="X offset in pixels"}
real dy=0		{prompt="Y offset in pixels"}

begin
	string im1, im2
	real ra1, ra2, dec1, dec2, secpix1, secpix2
	real dra, ddec, dec, dx0, dy0

	procdata

	im1 = image1
	im2 = image2

	imgetp (im1, "RA")
	ra1 = real (imgetp.value)
	ra1 = ra1 * 15.0
	imgetp (im2, "RA")
	ra2 = real (imgetp.value)
	ra2 = ra2 * 15.0

	imgetp (im1, "DEC")
	dec1 = real (imgetp.value)
	imgetp (im2, "DEC")
	dec2 = real (imgetp.value)

	imgetp (im1, "SECPIX")
	secpix1 = real (imgetp.value)
	imgetp (im2, "SECPIX")
	secpix2 = real (imgetp.value)

	dra = ra2 - ra1
	ddec = dec2 - dec1
	dec = (dec1 + dec2) / 2.0
	dx0 = -dra * 3600.0 * cos (0.0174533 * dec) / secpix2
	dy0 = ddec * 3600.0 / secpix2
#	print (im2," - ",im1,": dx= ",dx0, ", dy= ",dy0)
	printf ("%s - %s: dx = %.4f, dy = %.4f\n",im2,im1,dx0,dy0)
	dx = dx0
	dy = dy0
end
