#---------------------------------------------------------------#
#								#
#	ONEXAM							#
#	------							#
#								#
#	This package is written mainly for photometry purposes.	#
#	It reads the file "sao_cursor" and gets the image 	#
#	cursor position and its geometry (box, circle, ellipse,	#
#	annulus).						#
#	It is a general purpose script that can be used with	#
#	other tasks that require interactive cursor facility.	#
#								#
#						Charles Rite'	#
#						  07/03/90	#
#								#
#---------------------------------------------------------------#
procedure onexam (images)

string 	images		{prompt="Images to be used"}
struct *clx
struct *cly
bool unique=no

begin 
	real rx, ry, rz, rw
	int px, py, n, i, j
	string imgfile, img, key
	bool first =yes

	# Define a pointer to the file sao_cursor created by SAOIMAGE

	file cursr = "home$sao_cursor"

	# If the file already exists delete old version

	if (access (cursr))
	delete (cursr)	

	# Create a temporary copy of the image file

	imgfile = mktemp ("tmp$ctr")
	sections (images, option="fullname", > imgfile)
	clx = imgfile

	# The main big loop starts here

	while (fscan (clx, img) != EOF) {
	display (img, frame=1)

	if (first) {
	first=no
	print ("* Select Cursor Geometry, save cursor (s) and Write Region *") 
	beep
	# Check if the file is available from SAOIMAGE

	while (access (cursr) != yes) { }

	# Just wait the file to be closed by SAOIMAGE

	sleep 1
	if(unique)
	first=yes
	}
	list = cursr

	# Get cursor geometry (POINT, POLY, BOX, CIRCLE, ELLIPSE or ANNULI)

	while (fscan (list, s1, px, py, rx, ry, rz, rw) != EOF)  {
	if ( s1 == "BOX" ) { 
	print ("Statistics will be made in a BOX")
	print ("Center coordinates: ", px, py)
	print ("Width : ",rx)
	print ("Height: ",ry)
	} else if ( s1 != "BOX" ) { 
	print ("Statistics will be made in an equivalent BOX")
	print ("Center coordinates: ", px, py)
	rx = 2*rx
	ry = rx
	print ("Width : ",rx)
	print ("Height: ",rx)
	}

	# Set internal parameters for plots, statistics, surfaces

	eimexam.ncolumn  = int(rx)
	eimexam.nlines   = int(ry)
	himexam.ncolumn  = int(rx)
	himexam.nlines   = int(ry)
	simexam.ncolumn  = int(rx)
	simexam.nlines   = int(ry)
	imexamine.ncstat = int(rx)
	imexamine.nlstat = int(ry)

	# Examine images with selected cursor width and height
 
	imexamine (img, frame=1)

	}
	if (unique) {
	delete (cursr)
	first=yes
	}
	}

	delete (imgfile, ver-, >& "dev$null")
end


