# SIMTOOL --- Set up saoimage to use tv$display
# By Doug Mink, Center for Astrophysics
# April 24, 2003

procedure simtool

char display=""		{prompt="X display"}
char geometry=""		{prompt="window geometry"}
char pipename="home$imt1"	{prompt="name of imtool pipe"}
bool background=yes		{prompt="run in background"}

begin
    char arg,pn

    arg = " +imtool"

    # Input from IRAF
    pn = osfn (pipename)
    arg = arg //" -idev " // pn //"o -odev " // pn //"i"

    # Display for X
    if (display != "") {
	arg = arg //" -d "//display
	}

    # Geometry for X (X*Y+XDIM+YDIM)
    if (geometry !="")
	arg = arg//" -gd "//geometry

    # Run in background if requested
    if (background)
      arg = arg // " &"

    # Execute SAOIMAGE
    print ("saoimage",arg)
    saoimage (arg)
end
# Dec  2 1991	New task

# Nov 10 1997	Set size of image display window, not entire SAOimage wintdow

# Apr 24 2003	Skip -d if no display is set; do not require it to be set
