
	program combine

c combine a list of images taking into account flagged pixels
c real input, real output, compensates for different exposure levels
c(by adding).  mode input should be scaled to 1, e.g., if all levels
c are the same then all modes should be 1.0
c maxfiles may exceed the operating system limit!
	parameter (maxfiles=40,maxrowl=2048)
	
	integer im(maxfiles), axlen(7), low, high, ngdval(maxfiles+1)
	integer dtype
	real	data(maxrowl, maxfiles), odata(maxrowl)
	integer*2	idata(maxrowl)
	real	scle(maxfiles), mode(maxfiles), gdata(maxfiles)
	character*40 ifile, imfile(maxfiles), imfinal, badfile, infile
	character*80 errmsg
	logical verbose

	verbose = .true.

	call clargc (1, ifile, ier)
	if (ier.ne.0) then
		write (6,10)
10		format (1x,' file with image names : '$)
		read (5,15) ifile
15		format (a)
	endif
	open (21,file=ifile,status='old')
c assume output from imstat - skip 1st line
c	read (21,17)
c17	format (1x)

	call clargc (2, imfinal, ier)
	if (ier.ne.0) then
		write (6,20)
20		format (1x,' output image name : '$)
		read (5,25) imfinal
25		format (a)
	endif

	call clargr (3, thresh, ier)
	if (ier.ne.0) then
		write (6,30)
30		format (1x,' lower threshold of good pixels : '$)
		read (5,*) thresh
	endif

	call clargi (4, low, ier)
	if (ier.ne.0) then
		write (6,32)
32		format (1x,' # pixels on low side to reject : '$)
		read (5,*) low
	endif

	call clargi (5, high, ier)
	if (ier.ne.0) then
		write (6,34)
34		format (1x,' # pixels on high side to reject : '$)
		read (5,*) high
	endif

	call clargr (6, badval, ier)
	if (ier.ne.0) then
		write (6,36)
36		format (1x,' output value for bad pixels : '$)
		read (5,*) badval
	endif

c	call clargc (7, badfile, ier)
c	if (ier.ne.0) then
c		write (6,39)
c39		format (1x,' file for bad pixels : '$)
c		read (5,25) badfile
c	endif

	nfile = 1
	avmode = 0.
40	continue
	read (21,*,end=50) imfile(nfile), mode(nfile)
	avmode = avmode + mode(nfile)
	ngdval(nfile) = 0
	nfile = nfile + 1
	goto 40

50	continue
	nfile = nfile - 1
	avmode = avmode
        print*,'total exposure time',avmode
	close (21)
	
c open all the files - assumed all the same size!
	do 90 i = 1, nfile
		call imopen (imfile(i), 1, im(i), ier)
		if (ier.ne.0) goto 900
		call imgsiz (im(i), axlen, naxis, dtype, ier)	
		if (ier.ne.0) goto 900
c		scle(i) = avmode/mode(i)
		scle(i) = mode(i)
	if (verbose) write (6,57) imfile(i),mode(i),scle(i)
57	format(1x,a20,3x,2f10.3)
90	continue

	npix = axlen(1)
	nrows = axlen(2)

c create the output image - same as first image in list
	dtype=6
	call imcrea(imfinal,axlen,naxis,dtype,ier)
	call imopen(imfinal,3,imout,ier)
c	call imopnc (imfinal, im(1), imout, ier)
	if (ier.ne.0) goto 900

c and the badpixel file
c	open (unit=22, file=badfile, status='new')
	
c if this message occurs, then all files open 
	if (verbose) write (6,95) nfile, low, high
95	format (1x,' number of input images : ',i3,'  low rej = ',i3,
     1		'   high rej = ',i3)

c now work through all the images row by row
	do 200 i = 1, nrows

		do 110 j = 1, nfile
			call imgl2r (im(j), odata(1), i, ier)
c			call imgl2s (im(j), idata(1), i, ier)
			do 674 kkk=1,npix
 674			data(kkk,j)=odata(kkk)
			if (ier.ne.0) goto 900
110		continue

		do 180 m = 1, npix
			odata(m) = 0.
			ngood = 0
                        scale=0.0
			do 160 j = 1, nfile
				if (data(m,j).ge.thresh) then
				ngood = ngood + 1
     				gdata(ngood) = data(m,j)
                                   scale=scale+scle(j)
				endif
160			continue
c                        print*,ngood,scale,data(m,1),data(m,2),data(m,3)

c this is the IRAF sort routine
			call asrtr (gdata, gdata, ngood) 

			nkept = ngood - low - high

			if (nkept.gt.0) then
				do 170 n = 1+low,ngood-high 	
					odata(m) = odata(m)+
     1						gdata(n)
170				continue	
c				odata(m) = odata(m)/scale*avmode
				odata(m) = odata(m)/scale
			else
				odata(m) = badval
c				write (22,172) m,m,i,i
c172				format (4i6)
			endif

c keep track of how many pixels at each value of nkept
			ngdval(nkept+1) = ngdval(nkept+1) + 1

180		continue

	call impl2r (imout, odata, i, ier)
c			do 675 kkk=1,npix
c 675			idata(kkk)=odata(kkk)
c
c	call impl2s (imout, idata, i, ier)
	if (ier.ne.0) goto 900

200	continue


c close all images
        call imhcpy(im(1),imout,ier)
c	call imgkwd (imout, 'exptime', expy, ier)
c        expt=exp*avmode
c	call impkwd (imout, 'exptime', exp, ier)
	do 890 i = 1, nfile
		call imclos (im(i), ier)
		if (ier.ne.0) goto 900
890	continue

c	close (22)

	call imakwi (imout, 'NCOMBINE', nfile, 
     1		'NUMBER FILES COMBINED', ier)
	if (ier.ne.0) goto 900
	call imakwi (imout, 'NLOWER', low, 
     1		'LOW REJECT', ier)
	if (ier.ne.0) goto 900
	call imakwi (imout, 'NHIGH', high, 
     1		'HIGH REJECT', ier)
	if (ier.ne.0) goto 900
	call imakwr (imout, 'BADVAL', badval, 
     1		'VALUE FOR BAD PIXELS', ier)
	if (ier.ne.0) goto 900
	call imclos (imout, ier)
	if (ier.ne.0) goto 900

c now output the statistics of good pixels
	if (verbose) then
		write (6,895)
895		format (/1x)
		do 897 i = 1, nfile+1
			write (6,896) i-1, ngdval(i)
896			format (1x,i6,3x,i10)
897		continue
	endif
	stop

900	continue
	call imemsg (ier, errmsg)
	write (6,905) errmsg
905	format (/1x,' Error : ',a80)
	stop
	end
