include	<error.h>
include	<ctype.h>
include	<imhdr.h>
include	<imio.h>
include	<time.h>

# T_DEPIX -- Remove machine and directory names from pixel file in headers

procedure t_depix()

bool	verbose, clgetb()
int	list, nimages
pointer	sp, template, image
int	imtopen(), imtgetim()

begin
	call smark (sp)
	call salloc (image, SZ_FNAME, TY_CHAR)
	call salloc (template, SZ_LINE, TY_CHAR)

	verbose = clgetb ("verbose")

	call clgstr ("images", Memc[template], SZ_LINE)
	list = imtopen (Memc[template])
	nimages = 0

	while (imtgetim (list, Memc[image], SZ_FNAME) != EOF) {
	    nimages = nimages + 1
	    call idpix (Memc[image], verbose)
	    }

	call imtclose (list)
end


# IDPIX -- Remove machine and directory names from pixel file in image header

procedure idpix (image, verbose)

char	image[ARB]
bool	verbose

pointer	im, sp, title, ip
int	gstrcpy(), strldx(), iex
pointer	oldpix, newpix
pointer	immap()
errchk	immap

begin

	# Allocate automatic buffers.
	call smark (sp)
	call salloc (newpix, SZ_FNAME,  TY_CHAR)
	call salloc (oldpix, SZ_FNAME,  TY_CHAR)
	call salloc (title, SZ_LINE,  TY_CHAR)

	im = immap (image, READ_WRITE, 0)

	call strcpy (IM_PIXFILE(im), Memc[oldpix], SZ_FNAME)

	iex = strldx ("/", Memc[oldpix])
	if (iex < 1)
	    return

	call strcpy ("HDR$", Memc[newpix], SZ_FNAME)
	call strcpy (Memc[oldpix+iex], Memc[newpix+4], SZ_FNAME)

	if (verbose) {

	    # Format subscript strings, date strings, mininum and maximum
	    # pixel values.

	    # Strip any trailing whitespace from the title string.
	    ip = title + gstrcpy (IM_TITLE(im), Memc[title], SZ_LINE) - 1
	    while (ip >= title && IS_WHITE(Memc[ip]) || Memc[ip] == '\n')
		ip = ip - 1
	    Memc[ip+1] = EOS

	    # Print image name and title
	    call printf ("%s: %s\n")
		call pargstr (IM_NAME(im))
		call pargstr (Memc[title])

	    call printf ("%4wPixel file '%s' -> '%s'\n")
		call pargstr (Memc[oldpix])
		call pargstr (Memc[newpix])
	    call flush (STDOUT)
	    }

	if (iex > 0)
	    call strcpy (Memc[newpix], IM_PIXFILE(im), SZ_FNAME)
	call imunmap (im)
	call sfree (sp)
end
