include	<error.h>
include	<ctype.h>
include	<imhdr.h>
include	<imio.h>
include	<time.h>

# DRMACH -- Change machine name to directory in pixel file pointer
#           in IRAF image header

procedure t_drmach()

bool	verbose, clgetb()
int	list, nimages
pointer	sp, template, image, mdir
int	imtopen(), imtgetim()

begin
	call smark (sp)
	call salloc (image, SZ_FNAME, TY_CHAR)
	call salloc (mdir, SZ_FNAME, TY_CHAR)
	call salloc (template, SZ_LINE, TY_CHAR)

	verbose = clgetb ("verbose")
	call clgstr ("machdir", Memc[mdir], SZ_FNAME)

	call clgstr ("images", Memc[template], SZ_LINE)
	list = imtopen (Memc[template])
	nimages = 0

	while (imtgetim (list, Memc[image], SZ_FNAME) != EOF) {
	    nimages = nimages + 1
	    call idrhdr (Memc[image], Memc[mdir], verbose)
	    }

	call imtclose (list)
end


# IDRHDR -- Change machine name to directory in pixel file pointer
#           in one image header

procedure idrhdr (image, mdir, verbose)

char	image[ARB]	# Image file name
char	mdir[ARB]	# Machine directory name
bool	verbose		# List changes (yes or no)

pointer	im, sp, title, ip
int	gstrcpy(), stridx(), iex
pointer	oldpix, newpix
pointer	immap()
errchk	immap

begin

	# Allocate automatic buffers.
	call smark (sp)
	call salloc (newpix, SZ_FNAME,  TY_CHAR)
	call salloc (oldpix, SZ_FNAME,  TY_CHAR)
	call salloc (title, SZ_LINE,  TY_CHAR)

	im = immap (image, READ_WRITE, 0)

	call strcpy (IM_PIXFILE(im), Memc[oldpix], SZ_FNAME)
	iex = stridx ("!", Memc[oldpix])
	if (iex > 0) {
	    call strcpy (mdir, Memc[newpix], SZ_FNAME)
	    call strcat (Memc[oldpix], Memc[newpix], iex-1)
	    call strcat (Memc[oldpix+iex], Memc[newpix], SZ_FNAME)

	    if (verbose) {

	    # Format subscript strings, date strings, mininum and maximum
	    # pixel values.

	    # Strip any trailing whitespace from the title string.
		ip = title + gstrcpy (IM_TITLE(im), Memc[title], SZ_LINE) - 1
		while (ip >= title && IS_WHITE(Memc[ip]) || Memc[ip] == '\n')
		    ip = ip - 1
		Memc[ip+1] = EOS

	    # Print image name and title
		call printf ("%s: %s\n")
		    call pargstr (IM_NAME(im))
		    call pargstr (Memc[title])

		call printf ("%4wPixel file '%s' -> '%s'\n")
		    call pargstr (Memc[oldpix])
		    call pargstr (Memc[newpix])
		call flush (STDOUT)
		}
	    call strcpy (Memc[newpix], IM_PIXFILE(im), SZ_FNAME)
	    }
	call imunmap (im)
	call sfree (sp)
end
