# File archive/Scripts/findcheck.cl
# November 22, 1995
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# FINDCHECK -- Find and extract aperture for a list of FAST observation numbers

procedure findcheck (filename)

string	filename=""	{prompt="Filename or name of file with list of names"}
bool	interactive=yes	{prompt="Run findspec interactively (yes or no)"}
bool	verbose=no	{prompt="Print what's happening (y or n)"}

begin

bool	extract
bool	vb, delf
file	rfn_temp
file	fname
string	listfile
string	tchar, rfile

	rfile = filename
	vb = verbose
	extract = no

#  Process data files from command line or file of files

	tchar = substr (rfile,1,1)
	if (tchar != '@') {
	    rfn_temp = mktemp ("findall")
	    print (rfile,>rfn_temp)
	    listfile = rfn_temp
	    }
	else
	    listfile = substr (rfile,2,64)

	if (vb)
	    print ("RFNs from ",listfile)
	findspec.dbap = no
	findspec.interactive = interactive
 
#  Loop through list of reduced files
	list = listfile
	while (fscan (list,fname) != EOF) {
	    findspec (fname)
	    if (extract) {
		apall.lower = findspec.lower
		apall.upper = findspec.upper
		apall.b_sample = findspec.b_sample
		apall.find = no
		apall.edit = no
		apall.b_function = findspec.b_function
		apall.b_order = findspec.b_order
		apall.b_niterate = findspec.b_niterate
		apall (fname)
		}
	    }

	if (tchar != '@')
	    delete (rfn_temp)
end
# Nov 22 1995	New task based on findall
