# HFAST  Printer header for selected FAST images
#        February 7, 1994
#        By Doug Mink, CfA

procedure hfast (start,finish)

int start=1		{prompt="Starting sequence number"}
int finish=1		{prompt="Ending sequence number"}
file obsdir="./"	{prompt="Directory for input files"}
file obsdate=""		{prompt="Date of observation (yyyy/mm/dd/)"}
string imgtype=""	{prompt="image type to list if not all"}
string imext=".imh"	{prompt="Image extension"}
bool longheader=no	{prompt="Print complete header (y or n)"}
bool verbose=no	{prompt="Log progress (y or n)"}

begin
	int	iobs, firstobs, lastobs, itype
	string	filter, ccdtype
	string	indir, in, val, sky, flat, pi, ltype, cwd
	file	infile
	bool	vb

#   Set up initial parameters (prompt for those unset)
	firstobs = start
	lastobs = finish
	vb = verbose
	ltype = imgtype
	indir = obsdir
	if (indir != "") indir = indir//'$'

#   Read files one at a time
	for (iobs=firstobs; iobs<=lastobs; iobs+=1 ) {

#	Determine correct file extension
	    obsname.imdir = obsdir
	    obsname.obsdate = obsdate
	    obsname.verbose = vb
	    obsname (iobs)

	    if (obsname.obsfile == "")
		next

#	Set up file name
	    infile = obsname.obsdir // obsname.obsfile

#	Get ccdtype or set it from object
	    imgetp (infile, "imagetyp")
	    ccdtype = imgetp.value
	    if (ccdtype == "0") {
		sky = filter//"SKY"
		flat = filter//"FLAT"
		if (object == "BIAS") ccdtype = " zero"
		else if (object == "DARK") ccdtype = " dark"
		else if (object == "SKY") ccdtype = "  sky"
		else if (object == sky) ccdtype = "  sky"
		else if (object == flat) ccdtype = " flat"
		}
	    if (vb) print("typ=",ccdtype)
	    if (ltype != "") {
		if (ltype == ccdtype) {
		    imheader (infile, longheader=longheader)
		    }
		}
	    else
		imheader (infile, longheader=longheader)
	    }

end
