# IRNORM- Normalize IR array data to single frame
#         By Doug Mink, CfA

procedure irnorm (image)

string	image	{prompt="image to normalize"}
int	nsec	{prompt="minimum integrations per second"}
bool	verbose=no	{prompt="Log progress (y or n)?"}

begin

	int	nframe
	int	exposure, framerat, iexp, ifrr
	real	exp,frr,minsec
	char	val
	file	infile
	file	outfile

	infile = image
	minsec = 1. / real(nsec)
	hedit.verify = no

	imgets (infile, "nframe")
	if (imgets.value == "0") {

#	Get exposure duration and round to nearest good time

	    imgets (infile, "exposure")
	    if (imgets.value == "0") imgets.value = "1"
	    val = imgets.value
	    exp = real (val)
	    iexp = int (val)
	    if (iexp > exp) iexp = iexp - 1
	    exp = real (iexp) + minsec * real(int((exp-iexp+(0.5*minsec)) / minsec))
	    exposure = (exp + .0005) * 1000.

#	Get frame rate and round to nearest good time

	    imgets (infile, "framerat")
	    if (imgets.value == "0") imgets.value = val
	    frr = real (imgets.value)
	    ifrr = int (imgets.value)
	    if (ifrr > frr) ifrr = ifrr - 1
	    frr = real (ifrr) + minsec * real(int((frr-ifrr+(0.5*minsec)) / minsec))
	    framerat = (frr + .0005) * 1000.

#	Compute normalization for this image

	    nframe = exposure / framerat
	    if (verbose) print ("nframe = ",exposure,"/ ",framerat,"= ",nframe)

#	Change image header parameters

	    hedit (infile,"exposure",str(exp))
	    hedit (infile,"framerat",str(frr))
	    hedit.add = yes
	    hedit (infile,"nframe",str(nframe))
	    hedit.add = no

#	Normalize this image

	    if (nframe > 1) {
		imarith (infile,"/",nframe,infile)
		}
	    if (verbose) print ("image ",infile," divided by ",nframe)
	    }

end
