# LSRATE- List exposure and frame rate for selected IR images
#         By Doug Mink, CfA

procedure lsrate (imtemp)

string	imtemp	{prompt="images to list"}
int	nsec	{prompt="minimum integrations per second"}
bool	verbose	{prompt="Log progress (yes or no)"}

begin

	int	nframe
	int	exposure, framerat, iexp, ifrr
	real	exp,frr,minsec
	file	infile,imfile

	if (access ("temp")) {
	    delete ("temp")
	    if (verbose)
		print("temp deleted")
	    }
	imfile = mktemp ("temp")
	files (imtemp,> imfile)

	minsec = 1. / real (nsec)

	print("")
	print("    image         exp   frame   #")
	print("    header       time    rate  fr")
	print("")
	while (scan (infile) != EOF) {

#	Get exposure duration and round to nearest good time

	    imgetp (infile, "exposure")
	    exp = real (imgetp.value)
	    iexp = int (imgetp.value)
	    if (iexp > exp) iexp = iexp - 1
	    exp = real (iexp) + minsec * real(int((exp-iexp+(0.5*minsec)) / minsec))
	    exposure = (exp + .0005) * 1000.

#	Get frame rate and round to nearest good time

	    imgetp (infile, "framerat")
	    frr = real (imgetp.value)
	    ifrr = int (imgetp.value)
	    if (ifrr > frr) ifrr = ifrr - 1
	    frr = real (ifrr) + minsec * real(int((frr-ifrr+(0.5*minsec)) / minsec))
	    framerat = (frr + .0005) * 1000.

	    imgetp (infile, "nframe")
	    nframe = int (imgetp.value)
#	    nframe = exposure / framerat

	    if (exp < 10.)
		print (infile,"     ",exp,"    ",frr,"  ",nframe)
	    else if (exp < 100.)
		print (infile,"    ",exp,"   ",frr,"  ",nframe)
	    else
		print (infile,"   ",exp,"  ",frr,"  ",nframe)
	    }

end
