# File procdata/Scripts/pfast.cl
# November 22, 1995
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# PFAST -- Plot a list of FAST observations from the archive

procedure pfast (filelist)

string	filelist=""	{prompt="Files to plot"}
bool	verbose=no	{prompt="Print what's happening (y or n)"}

begin

bool	vb
file	rfn_temp
file	listfile
string	tchar, rfile, line

	rfile = filelist
	vb = verbose

	set clobber = yes

#  Process date string
	tchar = substr (rfile,1,1)

# Read filenames from a file
	if (tchar == '@')
	    listfile = substr(rfile,2,64)

# Read single file name
	else {
	    rfn_temp = mktemp ("procf")
	    print (file,>rfn_temp)
	    listfile = rfn_temp
	    }
 
#  Loop through list of reduced files
	list = listfile
	while (fscan (list,line) != EOF) {
	    if (vb)
		print ("PFAST: plot ",line)
	    splot.new_image = line
	    splot (line,1,1)
	    }

	if (tchar != '@')
	    delete (rfn_temp)
end
