# SORTFAST  Printer header for selected FAST images
#	    January 12, 1996
#	    By Doug Mink, CfA

procedure sortfast (start,finish)

int start=1		{prompt="Starting sequence number"}
int finish=1		{prompt="Ending sequence number"}
file obsdir="./"	{prompt="Directory for input files"}
file obsdate=""		{prompt="Date of observation (yyyy.mmdd)"}
string imgtype=""	{prompt="image type to list if not all"}
string imext=".imh"	{prompt="Image extension"}
bool longheader=no	{prompt="Print complete header (y or n)"}
bool verbose=no	{prompt="Log progress (y or n)"}

begin
	int	iobs, firstobs, lastobs, itype
	string	filter, ccdtype
	string	indir, in, val, sky, flat, pi, ltype, cwd
	file	infile
	bool	vb

#   Set up initial parameters (prompt for those unset)
	firstobs = start
	lastobs = finish
	vb = verbose
	ltype = imgtype
	indir = obsdir
	if (indir != "") indir = indir // '$'

#   Read files one at a time
	for (iobs=firstobs; iobs<=lastobs; iobs+=1 ) {

#	Determine correct file extension
	    lenstr (indir)
	    lstr = lenstr.length
	    if (substr(indir,lstr,1) != "/")
		indir = indir // "/"
	    obsname.imdir = indir
	    obsname.obsdate = ""
	    obsname.verbose = vb
	    obsname (iobs)

	    if (obsname.obsfile == "")
		next

#	Set up file name
	    infile = obsname.obsdir // obsname.obsfile

#	Sort out different apertures
	    imgetp (infile, "aperture")
	    if (imgetp.value ==) {
		if (vb) print("aperture=",imgetp.value)
		outdir = indir // "ap" // imgetp.value // "/" // obsdate // "/"
		}

#	Sort out different gratings
	    imgetp (infile, "disperse")
	    if (imgetp.value ==) {
		if (vb) print("grating=",imgetp.value)
		outdir = indir // "grating" // imgetp.value // "/" // obsdate // "/"
		}

#	Sort out different tilt positions
	    imgetp (infile, "disperse")
	    if (imgetp.value ==) {
		if (vb) print("tilt=",imgetp.value)
		outdir = indir // "tilt" // imgetp.value // "/" // obsdate // "/"
		}
	    }

end
