# File fspec.com
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics
# November 27, 1995

# Common for FINDSPEC and its subroutines

common/fspec/ nsect, bsect, psig, pfrac, pnit, pmin, pmax, 
	      bsig, bfrac, bnit, bnpix, bgrow, bdiff, bminsect, dbap, imup

int	nsect		# Left background limits
int	bsect[MAXBSECT,2]	# Background sections
real	psig		# Minimum number of sigma for peak acceptance
real	pfrac		# Minimum peak fraction for spectrum
int	pnit		# Number of iterations for peak findinG
int	pmin		# Minimum pixel number for peak search
int	pmax		# Maximum pixel number for peak search
real	bsig		# Maximum number of sigma for background acceptance
real	bfrac		# Maximum peak fraction for background
int	bnit		# Number of times to iterate background rejection
int	bnpix		# Number of pixels in background (on each side)
int	bgrow		# Number of pixels to remove around rejected ones
int	bdiff		# Number of pixels to skip between spectrum and back
int	bminsect	# Minimum number of pixels in background section
bool	dbap		# Save aperture and background limits in database
bool	imup		# True if image is updateable

# Nov  3 1995	New common
# Nov 27 1995	Add DBAP and IMUP to common
