# File procdata/Src/logtime.x
# October 5, 1995
# Modified extensively from sys/misc/cnvtime.x
# by Doug Mink, Harvard-Smithsonian Center for Astrophysics

include	<time.h>

define	SZ_MONTH		3

# LOGTIME -- Return current time as a string, i.e., " 17-Mar-1982 16:30".
# The maximum length of the returned string is given by the parameter
# SZ_TIME in <time.h>.

procedure logtime (outstr, maxch)

char	outstr[maxch]
int	maxch

int	tm[LEN_TMSTRUCT]	# broken down time structure
string	month	"JanFebMarAprMayJunJulAugSepOctNovDec"
long	ltime			# seconds since 00:00:00 10-Jan-80
long	clktime()

begin
	ltime = 0
	ltime = clktime (ltime)
	call brktime (ltime+30, tm)
	
	call sprintf (outstr, maxch, " %02d-%3.3s-%02d %02d:%02d")
	    call pargi (TM_MDAY(tm))
	    call pargstr (month [(TM_MONTH(tm) - 1) * SZ_MONTH + 1])
	    call pargi (TM_YEAR(tm))
	    call pargi (TM_HOUR(tm))
	    call pargi (TM_MIN(tm))
end
