#*** File procdata/Src/t_obsname.x
#*** March 16, 1994
#*** By Doug Mink, Center for Astrophysics

#--- Find observatory filename given file number and observation date

procedure t_obsname

char imdir[SZ_FNAME]	# Pathname of data directory
int fn			# File number
char filename[SZ_FNAME]	# File name (returned)

int	access(), clgeti(), i, strldx(), strlen()
int	ldir,ldate
char	rfname[20]
char	obsdate[16]
bool	debug, verbose, clgetb()
char	idot

begin
	idot = char (46)

#  Get name of file given reduced file number

	fn = clgeti ("file_number")
	if (fn < 10) {
	    call sprintf (rfname,20,"000%d")
		call pargi (fn)
	    }
	else if (fn < 100) {
	    call sprintf (rfname,20,"00%d")
		call pargi (fn)
	    }
	else if (fn < 1000) {
	    call sprintf (rfname,20,"0%d")
		call pargi (fn)
	    }
	else if (fn < 10000) {
	    call sprintf (rfname,20,"%d")
		call pargi (fn)
	    }
	else {
	    call printf ("OBSNAME: Number %d is too big!\n")
		call pargi (fn)
	    }

#  Get pathname of directory given root directory and date
	call clgstr ("imdir",imdir,SZ_FNAME)
	ldir = strlen (imdir)
	if (ldir > 0 && imdir[ldir] != '/') {
	    imdir[ldir+1] = '/'
	    imdir[ldir+2] = EOS
	    }
	call clgstr ("obsdate",obsdate,16)
	ldate = strlen (obsdate)
	if (ldate > 0) {
	    call strcat (obsdate,imdir,SZ_FNAME)
	    ldir = strlen (imdir)
	    if (ldir > 0 && imdir[ldir] != '/') {
		imdir[ldir+1] = '/'
		imdir[ldir+2] = EOS
		}
	    }
	debug = clgetb ("debug")
	verbose = clgetb ("verbose")
	if (debug) {
	    call printf ("OBSNAME:  dir: %s, rfn: %s \n")
		call pargstr (imdir)
		call pargstr (rfname)
	    call flush (STDOUT)
	    }

	filename[1] = EOS
	if (access (imdir,0,0) == YES) {
	    call dirtemp (imdir,rfname,4,filename,SZ_FNAME)
	    if (filename[1] == EOS) {
		if (debug) {
		    call printf ("OBSNAME: fn %d not found in directory %s\n")
			call pargi (fn)
			call pargstr (imdir)
		    call flush (STDOUT)
		    }
		else if (verbose) {
		    call printf ("Observation %d not found in directory %s\n")
			call pargi (fn)
			call pargstr (imdir)
		    call flush (STDOUT)
		    }
		}
	    else {
		i = strldx (idot,filename)
		filename[i] = EOS
		if (debug) {
		    call printf ("OBSNAME:  file %s in %s\n")
			call pargstr (filename)
			call pargstr (imdir)
		    call flush (STDOUT)
		    }
		else if (verbose) {
		    call printf ("%s\n")
			call pargstr (filename)
		    call flush (STDOUT)
		    }
		}
	    }
	else {
	    if (debug) {
		call printf ("OBSNAME: directory %s not found for fn %d\n")
		    call pargstr (imdir)
		    call pargi (fn)
		call flush (STDOUT)
		}
	    else if (verbose) {
		call printf ("Directory %s not found\n")
		    call pargstr (imdir)
		call flush (STDOUT)
		}
	    imdir[1] = EOS
	    filename[1] = EOS
	    }

	call clpstr ("obsfile",filename,SZ_FNAME)
	call clpstr ("obsdir",imdir,SZ_FNAME)
end
# Feb  1 1994	Write task
# Feb  7 1994	Return nulls string if file or directory not found

# Mar 16 1994	Add lesser level of verbosity
