# T_PRINTF -- Print a set of values according with a given format string.
# The values are retrieved from the task parameter file as they are needed
# until the format string is completely processed. This task is intended
# for CL scripts, to get formatted output (something that the CL print
# does not support so far).

procedure t_printf ()

char	format[SZ_LINE]		# format string

int	ip
pointer	sp, ptr

int	fmt_printf()
extern	prn_user()

begin
	# Get parameters
	call clgstr ("format", format, SZ_LINE)

	# Allocate structure
	call smark  (sp)
	call salloc (ptr, 1, TY_STRUCT)

	# Initialize variables
	ip        = 1
	Memi[ptr] = 1

	# Loop until the format string is completly processed
	while (fmt_printf (format, ip, prn_user, ptr) > 0)
	    Memi[ptr] = Memi[ptr] + 1

	# Free memory
	call sfree (sp)
end


# PRN_USER -- User supplied function.

procedure prn_user (dtype, bval, cval, lval, dval, xval, strval, maxch, ptr)

int	dtype			# data type requested
bool	bval			# boolean value (output)
char	cval			# character value (output)
long	lval			# integer/long value (output)
double	dval			# real/double value (output)
complex	xval			# complex value (output)
char	strval[maxch]		# string value (output)
int	maxch			# max number of characters in string value
pointer	ptr			# pointer to counter

char	param[SZ_LINE]

bool	clgetb()
long	clgetl()
double	clgetd()
complex	clgetx()

begin
	# Create parameter name
	call sprintf (param, SZ_LINE, "value%d")
	    call pargi (Memi[ptr])

	# Branch on data type
	switch (dtype) {
	case TY_BOOL:
	    bval = clgetb (param)
	case TY_CHAR:
	    if (maxch == 0)
	        call clgstr (param, cval, 1)
	    else
	        call clgstr (param, strval, SZ_LINE)
	case TY_LONG:
	    lval = clgetl (param)
	case TY_DOUBLE:
	    dval = clgetd (param)
	case TY_COMPLEX:
	    xval = clgetx (param)
	default:
	    call error (0, "fp_user: unknown data type")
	}
end
